unit FrmMain;

{

   COPYRIGHT 2013 .. 2015 Blue Hell / Jan Punter

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 2 as
  published by the Free Software Foundation;

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  For all listed email addresses :

    _dot. to be substituted by a dot      '.'
    2@t2  to be substituted by an at sign '@'


  Blue Hell is a trade mark owned by

    Jan Punter
    Oogstplein 6
    7545 HP Enschede
    the Netherlands
    http://www.iaf.nl/Users/BlueHell/
    http://bluehell.electro-music.com/
    j_dot.punter2@t2iaf_dot.nl

  All rights attributed to Blue Hell are owned by Jan Punter.
}

interface

uses

  WinApi.Windows, WinApi.Messages, Winapi.CommCtrl, System.SysUtils, System.UITypes, System.TypInfo, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, Vcl.ComCtrls,
  VCLTee.Chart, VCLTee.Series, System.IniFiles, WinApi.MMSystem, System.Math, Vcl.Menus, Vcl.Samples.Spin,
  WinApi.ShellApi, Vcl.Imaging.jpeg, VclTee.TeeGDIPlus, VCLTee.TeeProcs, VCLTee.TeEngine, System.Win.Registry,
  Vcl.Imaging.pngimage, OverbyteIcsWndControl, OverbyteIcsWSocket, Vcl.Mask, System.StrUtils,

  KnobsConversions, KnobsUtils, Globals, FrmStore, wave_dlg, KnobParser, AudioIO, CpuUsage, module_defs, module_scales,
  module_implementations, knobs2013, Rationals, WaveStorage, WaveUtils, wave_tools, midi_defs, midi_reader, synth_info,
  FmMidiCC,

  ctypes, portaudio, fftw_, Talkie, OSCif, grains,

  HrastUnit;

const

  UM_OSCDATA = WM_USER + 1;

type

  TMsgOSCData = TMessage;

  // Some stuff to fix the border width for TPageControls

  TPageControl = class( Vcl.ComCtrls.TPageControl)
  private
    procedure   TCMAdjustRect(var Msg: TMessage); message TCM_ADJUSTRECT;
  end;

  EWren               = class( Exception);
  EWrenExecutionError = class( Ewren);

  TFormWren = class(TForm)
    PanelControl: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    TimerStatsUpdate: TTimer;
    PanelMain: TPanel;
    PageControlMain: TPageControl;
    SaveDialogPatch: TSaveDialog;
    TabSheetEditor: TTabSheet;
    OpenDialogPatch: TOpenDialog;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuFileLoad: TMenuItem;
    MenuFileSave: TMenuItem;
    MenuEdit: TMenuItem;
    MenuFileExit: TMenuItem;
    MenuEditDelete: TMenuItem;
    MenuEditCut: TMenuItem;
    MenuEditCopy: TMenuItem;
    MenuEditPaste: TMenuItem;
    N2: TMenuItem;
    MenuEditSelectAll: TMenuItem;
    MenuEditInvertSelection: TMenuItem;
    N3: TMenuItem;
    MenuEditUndo: TMenuItem;
    MenuEditRedo: TMenuItem;
    MenuFileSaveAs: TMenuItem;
    N4: TMenuItem;
    MenuEditWiggleWires: TMenuItem;
    MenuSetup: TMenuItem;
    MenuSetupDevices: TMenuItem;
    MenuFileNew: TMenuItem;
    MenuHelp: TMenuItem;
    MenuHelpHelp: TMenuItem;
    MenuSetupSettings: TMenuItem;
    BitBtnAudioRunning: TBitBtn;
    MenuView: TMenuItem;
    MenuViewEditor: TMenuItem;
    MenuViewDebugger: TMenuItem;
    MenuViewGraphs: TMenuItem;
    MenuViewSettings: TMenuItem;
    N8: TMenuItem;
    MenuFileReopen: TMenuItem;
    knob_outputlevel1: TKnobsKnob;
    knob_inputlevel1: TKnobsKnob;
    IndicatorBarVolumeInLeft1: TKnobsIndicatorBar;
    IndicatorBarVolumeInRight1: TKnobsIndicatorBar;
    IndicatorBarVolumeOutLeft1: TKnobsIndicatorBar;
    IndicatorBarVolumeOutRight1: TKnobsIndicatorBar;
    LabeldBInPeak1: TLabel;
    LabeldbOutPeak1: TLabel;
    MenuAction: TMenuItem;
    MenuActionRunStop: TMenuItem;
    OpenDialogWave: TOpenDialog;
    PanelEditorTop: TPanel;
    MenuEditSelectNone: TMenuItem;
    Bevel4: TBevel;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Bevel7: TBevel;
    PatchEditor: TKnobsWirePanel;
    WSocketNetMidi: TWSocket;
    TimerNetMidiConnect: TTimer;
    LedNetMidiConnect1: TKnobsLed;
    LedNetMidiTx1: TKnobsLed;
    LedNetMidiRx1: TKnobsLed;
    Label20: TLabel;
    Label19: TLabel;
    Label18: TLabel;
    Label6: TLabel;
    PanelEditorTopRight: TPanel;
    ModuleSelector: TKnobsModuleSelector;
    EditPatchName: TEdit;
    LabelRunTime: TLabel;
    SpinButtonWireThickness: TSpinButton;
    LabelCpuUsage: TLabel;
    Label3: TLabel;
    EditSearch: TEdit;
    MenuViewHelp: TMenuItem;
    MenuActionProfile: TMenuItem;
    N6: TMenuItem;
    MenuEditFind: TMenuItem;
    Label10: TLabel;
    Label24: TLabel;
    PopupMenuConnector: TPopupMenu;
    DeleteConnector: TMenuItem;
    BreakWire: TMenuItem;
    DisconnectConnector: TMenuItem;
    BitBtnSynthReset: TBitBtn;
    PopupMenuModule: TPopupMenu;
    CopyModule: TMenuItem;
    CutModule: TMenuItem;
    DeleteModule: TMenuItem;
    PopupMenuKnob: TPopupMenu;
    SetKnobDefaultvalue: TMenuItem;
    LockKnob: TMenuItem;
    LabeldBInMax1: TLabel;
    LabeldBOutMax1: TLabel;
    TimerLightsUpdate: TTimer;
    PopupMenuSelector: TPopupMenu;
    dynamics1: TMenuItem;
    SaveDialogWave: TSaveDialog;
    KnobsLedrendering: TKnobsLed;
    KnobsSelectorFileRender: TKnobsSelector;
    LabeldBInMin1: TLabel;
    LabeldBOutMin1: TLabel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel8: TBevel;
    Bevel9: TBevel;
    Label31: TLabel;
    Label32: TLabel;
    IndicatorBarVolumeInLeft2: TKnobsIndicatorBar;
    IndicatorBarVolumeInRight2: TKnobsIndicatorBar;
    IndicatorBarVolumeOutLeft2: TKnobsIndicatorBar;
    IndicatorBarVolumeOutRight2: TKnobsIndicatorBar;
    LabeldBInPeak2: TLabel;
    LabeldbOutPeak2: TLabel;
    LabeldBInMax2: TLabel;
    LabeldBOutMax2: TLabel;
    LabeldBInMin2: TLabel;
    LabeldBOutMin2: TLabel;
    knob_outputlevel2: TKnobsKnob;
    knob_inputlevel2: TKnobsKnob;
    Bevel10: TBevel;
    Bevel11: TBevel;
    Bevel12: TBevel;
    Bevel13: TBevel;
    Label39: TLabel;
    Label40: TLabel;
    IndicatorBarVolumeInLeft3: TKnobsIndicatorBar;
    IndicatorBarVolumeInRight3: TKnobsIndicatorBar;
    IndicatorBarVolumeOutLeft3: TKnobsIndicatorBar;
    IndicatorBarVolumeOutRight3: TKnobsIndicatorBar;
    LabeldBInPeak3: TLabel;
    LabeldbOutPeak3: TLabel;
    LabeldBInMax3: TLabel;
    LabeldBOutMax3: TLabel;
    LabeldBInMin3: TLabel;
    LabeldBOutMin3: TLabel;
    knob_outputlevel3: TKnobsKnob;
    knob_inputlevel3: TKnobsKnob;
    Bevel14: TBevel;
    Bevel15: TBevel;
    Bevel16: TBevel;
    Bevel17: TBevel;
    Label47: TLabel;
    Label48: TLabel;
    IndicatorBarVolumeInLeft4: TKnobsIndicatorBar;
    IndicatorBarVolumeInRight4: TKnobsIndicatorBar;
    IndicatorBarVolumeOutLeft4: TKnobsIndicatorBar;
    IndicatorBarVolumeOutRight4: TKnobsIndicatorBar;
    LabeldBInPeak4: TLabel;
    LabeldbOutPeak4: TLabel;
    LabeldBInMax4: TLabel;
    LabeldBOutMax4: TLabel;
    LabeldBInMin4: TLabel;
    LabeldBOutMin4: TLabel;
    knob_outputlevel4: TKnobsKnob;
    knob_inputlevel4: TKnobsKnob;
    SplitterMain: TSplitter;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    ColorDialogModule: TColorDialog;
    N9: TMenuItem;
    Color1: TMenuItem;
    MenuEditFindunconnectedmodules: TMenuItem;
    N10: TMenuItem;
    MenuFileSaveastemplate1: TMenuItem;
    MenuFileSaveastemplate2: TMenuItem;
    MenuActionStartfilerender: TMenuItem;
    N1: TMenuItem;
    MenuFileImportmodules: TMenuItem;
    MenuFileExportselectedmodules: TMenuItem;
    SpeedButtonChangeControlPanel: TSpeedButton;
    MenuActionReset: TMenuItem;
    MenuEditPasteValues: TMenuItem;
    MenuActionRecompile: TMenuItem;
    LabeldBInValey1: TLabel;
    LabeldBInValey2: TLabel;
    LabeldBInValey3: TLabel;
    LabeldBInValey4: TLabel;
    LabeldbOutValey1: TLabel;
    LabeldbOutValey2: TLabel;
    LabeldbOutValey3: TLabel;
    LabeldbOutValey4: TLabel;
    Checkforupdates1: TMenuItem;
    KnobsLedUnderflows: TKnobsLed;
    N11: TMenuItem;
    N12: TMenuItem;
    TabSheetSettings: TTabSheet;
    TabSheetGraphs: TTabSheet;
    TabSheetDebug: TTabSheet;
    PanelSettings: TPanel;
    GroupBoxEditorSettings: TGroupBox;
    Label30: TLabel;
    Label26: TLabel;
    Label15: TLabel;
    RadioGroupControlMode: TRadioGroup;
    CheckBoxReloadLastPatch: TCheckBox;
    CheckBoxAutoRun: TCheckBox;
    CheckBoxWarnOnPatchChange: TCheckBox;
    KnobsSmallKnob_LightsRate: TKnobsSmallKnob;
    KnobsDisplayLightsRate: TKnobsDisplay;
    CheckBoxResetOnRender: TCheckBox;
    CheckBoxUseWheelOnKnobs: TCheckBox;
    knob_WheelSensitivity: TKnobsSmallKnob;
    KnobsDisplayWheelSensitivity: TKnobsDisplay;
    CheckBoxUseUnFocus: TCheckBox;
    CheckBoxClearVUOnStop: TCheckBox;
    KnobsDisplayHistoryCount: TKnobsDisplay;
    KnobsNoKnob_HistoryCount: TKnobsNoKnob;
    CheckBoxClearVUOnRecompile: TCheckBox;
    CheckBoxWarnChangeOnLoad: TCheckBox;
    CheckBoxUndoAfterSave: TCheckBox;
    CheckBoxUndoAfterLoad: TCheckBox;
    CheckBoxPatchChangedInCaption: TCheckBox;
    CheckBoxSourceNameInCaption: TCheckBox;
    CheckBoxProfiledInCaption: TCheckBox;
    CheckBoxAudioStatusInCaption: TCheckBox;
    CheckBoxProgramNameInCaption: TCheckBox;
    CheckBoxPortAudioInCaption: TCheckBox;
    CheckBoxFileVersionInCaption: TCheckBox;
    CheckBoxPatchNameInCaption: TCheckBox;
    GroupBoxNetMidi: TGroupBox;
    Label16: TLabel;
    Label17: TLabel;
    LedNetMidiConnect2: TKnobsLed;
    LedNetMidiTx2: TKnobsLed;
    LedNetMidiRx2: TKnobsLed;
    Label23: TLabel;
    Label22: TLabel;
    Label21: TLabel;
    EditNetMidiServer: TEdit;
    EditNetMidiPort: TEdit;
    BitBtnApplyNetMidi: TBitBtn;
    BitBtnCancelNetMidi: TBitBtn;
    BitBtnNetMidiConnect: TBitBtn;
    CheckBoxNetMidiAutoConnect: TCheckBox;
    GroupBoxTuning: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label11: TLabel;
    Label25: TLabel;
    EditReferenceA: TEdit;
    EditNotesPerOctave: TEdit;
    EditMiddleNote: TEdit;
    BitBtnApplyTuning: TBitBtn;
    BitBtnCancelTuning: TBitBtn;
    RadioGroupPrioLevel: TRadioGroup;
    GroupBoxAudioProperties: TGroupBox;
    LabelPleaseStopAudio1: TLabel;
    LabelPleaseStopAudio2: TLabel;
    RadioGroupSampleRate: TRadioGroup;
    CheckBoxUsePortAudio: TCheckBox;
    GroupBoxProgramInfo: TGroupBox;
    LabelProgramVersion: TLabel;
    LabelPatchVersion: TLabel;
    BitBtnCheckForUpdates: TBitBtn;
    BitBtnAcknowledgements: TBitBtn;
    PanelSettingsControl: TPanel;
    BitBtnCloseSettings: TBitBtn;
    ChartDebug: TChart;
    PanelGraphControl: TPanel;
    BitBtnDebigStep: TBitBtn;
    BitBtnDebugRun: TBitBtn;
    BitBtnDebugReset: TBitBtn;
    BitBtnClearGraphs: TBitBtn;
    CheckBoxGraphStairs: TCheckBox;
    BitBtnCloseGraphs: TBitBtn;
    MemoDebug: TMemo;
    PanelDebugControl: TPanel;
    LabelIOBalance: TLabel;
    LabelAudioInOverflows: TLabel;
    LabelAudioInUnderflows: TLabel;
    LabelFrameSize: TLabel;
    BitBtnClear: TBitBtn;
    BitBtnDump: TBitBtn;
    BitBtnCloseDubugger: TBitBtn;
    BitBtnProfile: TBitBtn;
    N5: TMenuItem;
    Makegreen1: TMenuItem;
    Redwires1: TMenuItem;
    Bluewires1: TMenuItem;
    Yellowwires1: TMenuItem;
    Customwirecolor1: TMenuItem;
    Defaultwirecolor1: TMenuItem;
    LabelExceptions: TLabel;
    LabelSynthOverflows: TLabel;
    LabelSynthUnderflows: TLabel;
    LabelAudioOutOverflows: TLabel;
    LabelAudioOutUnderflows: TLabel;
    FontDialog: TFontDialog;
    BevelSeparator: TBevel;
    CheckBoxUseConfigHints: TCheckBox;
    GroupBoxDebugSettings: TGroupBox;
    CheckBoxCompilerDebug: TCheckBox;
    CheckBoxShowLightsTime: TCheckBox;
    CheckBoxAbsTimeStamps: TCheckBox;
    CheckBoxLogToFile: TCheckBox;
    CheckBoxLogMidi: TCheckBox;
    CheckBoxLogMidiMsgs: TCheckBox;
    CheckBoxUseGraphs: TCheckBox;
    CheckBoxLightsActive: TCheckBox;
    GroupBoxLooks: TGroupBox;
    CheckBoxCurvedLines: TCheckBox;
    GroupBoxEditorBorders: TGroupBox;
    Label12: TLabel;
    Label13: TLabel;
    KnobsDisplayOffsetLeft: TKnobsDisplay;
    KnobsDisplayOffsetTop: TKnobsDisplay;
    KnobsSmallKnob_LeftOffset: TKnobsNoKnob;
    KnobsSmallKnob_TopOffset: TKnobsNoKnob;
    CheckBoxStandardColors: TCheckBox;
    KnobsLedModuleColor: TKnobsLed;
    Label27: TLabel;
    LabelModuleTitleFont: TLabel;
    LabelModuleFont: TLabel;
    BitBtnModuleColor: TBitBtn;
    KnobsSmallKnobModuleOpacity: TKnobsSmallKnob;
    KnobsDisplayModuleOpacity: TKnobsDisplay;
    BitBtnModuleTitleFont: TBitBtn;
    BitBtnModuleFont: TBitBtn;
    BitBtnDocument: TBitBtn;
    Defaultcolor1: TMenuItem;
    WSocketOSC: TWSocket;
    GroupBoxOSC: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    LedOSCTx2: TKnobsLed;
    LedOSCRx2: TKnobsLed;
    Label9: TLabel;
    Label14: TLabel;
    EditOSCServer: TEdit;
    EditOSCPort: TEdit;
    BitBtnApplyOSC: TBitBtn;
    BitBtnCancelOSC: TBitBtn;
    CheckBoxUseOSC: TCheckBox;
    LedOSCTx1: TKnobsLed;
    LedOSCRx1: TKnobsLed;
    Label28: TLabel;
    Label29: TLabel;
    Label37: TLabel;
    CheckBoxLogOSC: TCheckBox;
    BitBtnSendOSCTestMessage: TBitBtn;
    CheckBoxLogOSCMsgs: TCheckBox;
    TimerOSCGuard: TTimer;
    LedOSCEnabled: TKnobsLed;
    Label38: TLabel;
    LabelLightsTime: TLabel;
    Label41: TLabel;
    EditSynthName: TEdit;
    CheckBoxSynthNameInCaption: TCheckBox;
    KnobMIDICC: TMenuItem;
    N7: TMenuItem;
    PanelTemplates: TPanel;
    BitBtnLoadTemplate1: TBitBtn;
    BitBtnLoadTemplate2: TBitBtn;
    main_midich: TKnobsNoKnob;
    main_display_midich: TKnobsDisplay;
    Label42: TLabel;
    N13: TMenuItem;
    MIDI1: TMenuItem;
    AssigntoCC: TMenuItem;
    UnassignCC: TMenuItem;
    EditPark: TEdit;
    BitBtnView1: TBitBtn;
    BitBtnView2: TBitBtn;
    BitBtnView3: TBitBtn;
    BitBtnView4: TBitBtn;
    procedure BitBtnExItClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtnDebugStepClick(Sender: TObject);
    procedure BitBtnClearClick(Sender: TObject);
    procedure BitBtnClearGraphsClick(Sender: TObject);
    procedure BitBtnDebugRunClick(Sender: TObject);
    procedure CheckBoxUseGraphsClick(Sender: TObject);
    procedure BitBtnDebugResetClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBoxGraphStairsClick(Sender: TObject);
    procedure BitBtnDumpClick(Sender: TObject);
    procedure knob_outputlevel1ValueChanged(aSender: TObject; const aPath, aControlType: string; aValue: Double; IsFinal, IsAutomation: Boolean);
    procedure knob_inputlevel1ValueChanged(aSender: TObject; const aPath, aControlType: string; aValue: Double; IsFinal, IsAutomation: Boolean);
    procedure TimerStatsUpdateTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBoxReloadLastPatchClick(Sender: TObject);
    procedure CheckBoxAutoRunClick(Sender: TObject);
    procedure BitBtnDocumentClick(Sender: TObject);
    procedure ModuleSelectorModuleButtonClick(aSender: TObject; aModuleclass: Integer);
    procedure MenuFileLoadClick(Sender: TObject);
    procedure MenuFileSaveClick(Sender: TObject);
    procedure MenuFileSaveAsClick(Sender: TObject);
    procedure MenuFileExitClick(Sender: TObject);
    procedure MenuEditDeleteClick(Sender: TObject);
    procedure MenuEditCutClick(Sender: TObject);
    procedure MenuEditCopyClick(Sender: TObject);
    procedure MenuEditPasteClick(Sender: TObject);
    procedure MenuEditSelectAllClick(Sender: TObject);
    procedure MenuEditInvertSelectionClick(Sender: TObject);
    procedure MenuEditUndoClick(Sender: TObject);
    procedure MenuEditRedoClick(Sender: TObject);
    procedure MenuEditWiggleWiresClick(Sender: TObject);
    procedure MenuSetupDevicesClick(Sender: TObject);
    procedure MenuFileNewClick(Sender: TObject);
    procedure SpinButtonWireThicknessUpClick(Sender: TObject);
    procedure SpinButtonWireThicknessDownClick(Sender: TObject);
    procedure CheckBoxCurvedLinesClick(Sender: TObject);
    procedure MenuHelpHelpClick(Sender: TObject);
    procedure MenuSetupSettingsClick(Sender: TObject);
    function ModuleSelectorGetGlyph(aSender: TObject; const aName: string): TBitmap;
    procedure BitBtnAudioRunningClick(Sender: TObject);
    procedure RadioGroupPrioLevelClick(Sender: TObject);
    procedure MenuViewEditorClick(Sender: TObject);
    procedure MenuViewDebuggerClick(Sender: TObject);
    procedure MenuViewGraphsClick(Sender: TObject);
    procedure MenuViewSettingsClick(Sender: TObject);
    procedure EditPatchNameChange(Sender: TObject);
    procedure EditNotesPerOctaveChange(Sender: TObject);
    procedure EditReferenceAChange(Sender: TObject);
    procedure BitBtnProfileClick(Sender: TObject);
    procedure KnobsSmallKnob_LeftOffsetValueChanged(aSender: TObject; const aPath, aControlType: string; aValue: Double; IsFinal, IsAutomation: Boolean);
    procedure KnobsSmallKnob_TopOffsetValueChanged(aSender: TObject; const aPath, aControlType: string; aValue: Double; IsFinal, IsAutomation: Boolean);
    procedure MenuActionRunStopClick(Sender: TObject);
    procedure MenuEditSelectNoneClick(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
      var Handled: Boolean);
    procedure RadioGroupControlModeClick(Sender: TObject);
    procedure BitBtnNetMidiConnectClick(Sender: TObject);
    procedure CheckBoxNetMidiAutoConnectClick(Sender: TObject);
    procedure BitBtnApplyNetMidiClick(Sender: TObject);
    procedure BitBtnCancelNetMidiClick(Sender: TObject);
    procedure EditNetMidiServerChange(Sender: TObject);
    procedure EditNetMidiPortChange(Sender: TObject);
    procedure TimerNetMidiConnectTimer(Sender: TObject);
    procedure WSocketNetMidiBgException(Sender: TObject; E: Exception; var CanClose: Boolean);
    procedure WSocketNetMidiChangeState(Sender: TObject; OldState, NewState: TSocketState);
    procedure WSocketNetMidiDataAvailable(Sender: TObject; ErrCode: Word);
    procedure WSocketNetMidiDataSent(Sender: TObject; ErrCode: Word);
    procedure WSocketNetMidiSessionClosed(Sender: TObject; ErrCode: Word);
    procedure WSocketNetMidiSessionConnected(Sender: TObject; ErrCode: Word);
    procedure CheckBoxLogMidiClick(Sender: TObject);
    procedure CheckBoxLogMidiMsgsClick(Sender: TObject);
    procedure EditSearchChange(Sender: TObject);
    procedure CheckBoxCompilerDebugClick(Sender: TObject);
    procedure MenuActionProfileClick(Sender: TObject);
    procedure MenuEditFindClick(Sender: TObject);
    procedure EditMiddleNoteChange(Sender: TObject);
    procedure DeleteConnectorClick(Sender: TObject);
    procedure BreakConnectorClick(Sender: TObject);
    procedure DisconnectConnectorClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure CheckBoxWarnOnPatchChangeClick(Sender: TObject);
    procedure BitBtnSynthResetClick(Sender: TObject);
    procedure CutModuleClick(Sender: TObject);
    procedure CopyModuleClick(Sender: TObject);
    procedure DeleteModuleClick(Sender: TObject);
    procedure SetKnobDefaultvalueClick(Sender: TObject);
    procedure LockKnobClick(Sender: TObject);
    procedure LabeldBOutMaxClick(Sender: TObject);
    procedure LabeldBInMaxClick(Sender: TObject);
    procedure TimerLightsUpdateTimer(Sender: TObject);
    procedure RadioGroupSampleRateClick(Sender: TObject);
    procedure LabelRunTimeClick(Sender: TObject);
    procedure KnobsSmallKnob_LightsRateValueChanged(aSender: TObject; const aPath, aControlType: string; aValue: Double;
      IsFinal, IsAutomation: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure KnobsSelectorFileRenderValueChanged(const aSender: TObject; const aPath, aControlType: string;
      aValue: Double; IsFinal, IsAutomation: Boolean);
    procedure Color1Click(Sender: TObject);
    procedure BitBtnModuleColorClick(Sender: TObject);
    procedure CheckBoxUseWheelOnKnobsClick(Sender: TObject);
    procedure knob_WheelSensitivityValueChanged(const aSender: TObject; const aPath, aControlType: string;
      aValue: Double; IsFinal, IsAutomation: Boolean);
    procedure CheckBoxUseUnFocusClick(Sender: TObject);
    procedure CheckBoxUsePortAudioClick(Sender: TObject);
    procedure MenuEditFindunconnectedmodulesClick(Sender: TObject);
    procedure KnobsSmallKnobModuleOpacityValueChanged(const aSender: TObject; const aPath, aControlType: string;
      aValue: Double; IsFinal, IsAutomation: Boolean);
    procedure IndicatorBarVolumeDblClick(Sender: TObject);
    procedure CheckBoxClearVUOnStopClick(Sender: TObject);
    procedure ModuleSelectorDrawTab(Control: TCustomTabControl; TabIndex: Integer; const Rect: TRect; Active: Boolean);
    procedure MenuFileSaveastemplate1Click(Sender: TObject);
    procedure MenuFileSaveastemplate2Click(Sender: TObject);
    procedure MenuActionStartfilerenderClick(Sender: TObject);
    procedure BitBtnLoadTemplate1Click(Sender: TObject);
    procedure BitBtnLoadTemplate2Click(Sender: TObject);
    procedure MenuFileImportmodulesClick(Sender: TObject);
    procedure MenuFileExportselectedmodulesClick(Sender: TObject);
    procedure SpeedButtonChangeControlPanelClick(Sender: TObject);
    procedure MenuActionResetClick(Sender: TObject);
    procedure MenuEditPasteValuesClick(Sender: TObject);
    procedure MenuActionRecompileClick(Sender: TObject);
    procedure BitBtnApplyTuningClick(Sender: TObject);
    procedure BitBtnCancelTuningClick(Sender: TObject);
    procedure Checkforupdates1Click(Sender: TObject);
    procedure BitBtnCheckForUpdatesClick(Sender: TObject);
    procedure KnobsNoKnob_HistoryCountValueChanged(const aSender: TObject; const aPath, aControlType: string;
      aValue: Double; IsFinal, IsAutomation: Boolean);
    procedure CheckBoxClearVUOnRecompileClick(Sender: TObject);
    procedure CheckBoxWarnChangeOnLoadClick(Sender: TObject);
    procedure CheckBoxShowLightsTimeClick(Sender: TObject);
    procedure CheckBoxUndoAfterSaveClick(Sender: TObject);
    procedure CheckBoxUndoAfterLoadClick(Sender: TObject);
    procedure CheckBoxAbsTimeStampsClick(Sender: TObject);
    procedure ModuleHelpClick(Sender: TObject);
    procedure CheckBoxLogToFileClick(Sender: TObject);
    procedure BitBtnAcknowledgementsClick(Sender: TObject);
    procedure CheckBoxPatchChangedInCaptionClick(Sender: TObject);
    procedure CheckBoxProfiledInCaptionClick(Sender: TObject);
    procedure CheckBoxAudioStatusInCaptionClick(Sender: TObject);
    procedure CheckBoxProgramNameInCaptionClick(Sender: TObject);
    procedure CheckBoxFileVersionInCaptionClick(Sender: TObject);
    procedure CheckBoxPatchNameInCaptionClick(Sender: TObject);
    procedure CheckBoxSourceNameInCaptionClick(Sender: TObject);
    procedure CheckBoxPortAudioInCaptionClick(Sender: TObject);
    procedure BitBtnCloseDubuggerClick(Sender: TObject);
    procedure BitBtnCloseGraphsClick(Sender: TObject);
    procedure BitBtnCloseSettingsClick(Sender: TObject);
    procedure MakeGreenClick(Sender: TObject);
    procedure Redwires1Click(Sender: TObject);
    procedure Bluewires1Click(Sender: TObject);
    procedure Yellowwires1Click(Sender: TObject);
    procedure Customwirecolor1Click(Sender: TObject);
    procedure Defaultwirecolor1Click(Sender: TObject);
    procedure CheckBoxLightsActiveClick(Sender: TObject);
    procedure BitBtnModuleTitleFontClick(Sender: TObject);
    procedure BitBtnModuleFontClick(Sender: TObject);
    procedure CheckBoxUseConfigHintsClick(Sender: TObject);
    procedure CheckBoxStandardColorsClick(Sender: TObject);
    procedure Defaultcolor1Click(Sender: TObject);
    procedure WSocketOSCDataAvailable(Sender: TObject; ErrCode: Word);
    procedure EditOSCServerChange(Sender: TObject);
    procedure EditOSCPortChange(Sender: TObject);
    procedure CheckBoxUseOSCClick(Sender: TObject);
    procedure BitBtnApplyOSCClick(Sender: TObject);
    procedure BitBtnCancelOSCClick(Sender: TObject);
    procedure CheckBoxLogOSCClick(Sender: TObject);
    procedure BitBtnSendOSCTestMessageClick(Sender: TObject);
    procedure WSocketOSCSessionAvailable(Sender: TObject; ErrCode: Word);
    procedure WSocketOSCSessionClosed(Sender: TObject; ErrCode: Word);
    procedure WSocketOSCSessionConnected(Sender: TObject; ErrCode: Word);
    procedure WSocketOSCDataSent(Sender: TObject; ErrCode: Word);
    procedure CheckBoxLogOSCMsgsClick(Sender: TObject);
    procedure WSocketOSCChangeState(Sender: TObject; OldState, NewState: TSocketState);
    procedure TimerOSCGuardTimer(Sender: TObject);
    procedure WSocketOSCBgException(Sender: TObject; E: Exception; var CanClose: Boolean);
    procedure CheckBoxSynthNameInCaptionClick(Sender: TObject);
    procedure EditSynthNameChange(Sender: TObject);
    procedure KnobMIDICCClick(Sender: TObject);
    procedure main_midichValueChanged(const aSender: TObject; const aPath, aControlType: string; aValue: Double;
      IsFinal, IsAutomation: Boolean);
    procedure MIDI1Click(Sender: TObject);
    procedure AssigntoCCClick(Sender: TObject);
    procedure UnassignCCClick(Sender: TObject);
    procedure knob_inputlevel2ValueChanged(const aSender: TObject; const aPath, aControlType: string; aValue: Double;
      IsFinal, IsAutomation: Boolean);
    procedure knob_outputlevel2ValueChanged(const aSender: TObject; const aPath, aControlType: string; aValue: Double;
      IsFinal, IsAutomation: Boolean);
    procedure knob_outputlevel3ValueChanged(const aSender: TObject; const aPath, aControlType: string; aValue: Double;
      IsFinal, IsAutomation: Boolean);
    procedure knob_inputlevel3ValueChanged(const aSender: TObject; const aPath, aControlType: string; aValue: Double;
      IsFinal, IsAutomation: Boolean);
    procedure knob_inputlevel4ValueChanged(const aSender: TObject; const aPath, aControlType: string; aValue: Double;
      IsFinal, IsAutomation: Boolean);
    procedure knob_outputlevel4ValueChanged(const aSender: TObject; const aPath, aControlType: string; aValue: Double;
      IsFinal, IsAutomation: Boolean);
    procedure BitBtnView1Click(Sender: TObject);
    procedure knob_iolevel_UnFocus(const aSender: TObject);
  private
    FOldMemoDebug             : TWndMethod;                   // Startup (original) window proc for the debug memo
  private
    FSynthName                : string;                       // OSC synth name
    FClosing                  : Boolean;                      // Set to true when closing down the program, precenting some actions to be processed
    FSavedLogs                : TStringList;                  // Used to store log strings when logging is still disabled.
    FCanLog                   : Boolean;                      // Indicates whether logging is enableed or not
    FLogToFile                : Boolean;                      // When true log to a logfile in addition to the internal memo
    FIniLoaded                : Boolean;                      // True on successful load of ini file - no auto ini save when false
    FStandardColors           : Boolean;                      // When true use the standard color on new modules added.
    FPrioLevel                : Integer;                      // Current process priority level
    FBufferSize               : Integer;                      // Audio buffer size as requested by user
    FLightsActive             : Boolean;                      // Debug thingie for turning lights updates on / off
    FAbsTimeStamps            : Boolean;                      // Use absolute time or time relative to program start time
    FUseGraphs                : Boolean;                      // Make use of the graphs or not
    FGraphStairs              : Boolean;                      // Make the graphs smooth or stair stepped
    FHistoryCount             : Integer;                      // Number of files to hold in file history
    FRecentSourceFiles        : TRecentStrings;               // The file history itself
    FOrigCaption              : string;                       // Program startup caption for main screen (as set at design time)
    FReloadLastPatch          : Boolean;                      // True when on program start the last patch must be reloaded
    FAutoRun                  : Boolean;                      // True when audio processing must be turned on after program start
    FClearVUOnStop            : Boolean;                      // Clear main VU meters when audio processing is stopped
    FClearVUOnRecompile       : Boolean;                      // Clear main VU meters when a patch gets compiled
    FRenderToFile             : Boolean;                      // Do not output real time audio, but write it to a file
    FRenderFileName           : string;                       // The file used to write generated audio into
    FRenderDuration           : string;                       // The maximum render time as set by the user on render start
    FRenderFile               : TStereoWaveWriter;            // The render file encapsulation
    FPatchChanged             : Boolean;                      // True when the in memory patch differs from the one on disk
    FWarnOnPatchChange        : Boolean;                      // Whether a patch changed warning must be issued on program exit
    FWarnChangeOnLoad         : Boolean;                      // Whether a patch changed warning must be issued on loading a new patch
    FUndoAfterSave            : Boolean;                      // Allow for undo after a patch was saved
    FUndoAfterLoad            : Boolean;                      // Allow for a patch load action to be undone
    FUseWheelOnKnobs          : Boolean;                      // Use the mouse wheel to control knobs
    FWheelSensitivity         : Integer;                      // The amount of mouse wheel action needed for a ceratin knob movement
    FUseUnfocus               : Boolean;                      // Whether a knob should loose focus when the mouse moves out of it
    FPopupSender              : TControl;                     // The control that caused a popup menu to be shown
    FTuningChanged            : Boolean;                      // True when the main tuning was changed but not applied or cancelled yet
  private
    FMidiReceiver             : TMidiReceiver;                // MIDI data reception handler
    FNetMidiServer            : string;                       // IP address of NetMIDI / MidiTangle server
    FNetMidiPort              : string;                       // IP port    of NetMIDI / MidiTangle server
    FNetMidiAutoConnect       : Boolean;                      // True when at program startup a connection to the MIDI servrr should be made
    FNetMidiConnected         : Boolean;                      // True when a MIDI server is connected
    FNetMidiChanged           : Boolean;                      // True when unapplied or uncancelled changes were made for the MIDI server settings
    FLogMidi                  : Boolean;                      // True when MIDI activity should be logged
    FLogMidiMsgs              : Boolean;                      // True when MIDI messages should be logged
    FMidiChannel              : Byte;                         // MIDI channel for non-midi modules, 0 -> channel 1, 16 -> OMNI (xmit on 1)
  private
    FOSCServer                : string;                       // IP address of OSC server, or blank when client
    FOSCPort                  : string;                       // IP port    of OSC server or client
    FUSeOSC                   : Boolean;                      // True when OSC is to be used
    FOSCChanged               : Boolean;                      // True when OSC settings were changed and not applied or cancelled
    FLogOSC                   : Boolean;                      // True when OSC activity should be logged
    FLogOSCMsgs               : Boolean;                      // True when OSC messages should be logged
  private
    FCompilerDebug            : Boolean;                      // When true some compiler related files will be generated when a patch gets compiled
    FDebugRunning             : Boolean;                      // True for a debug run, a debug run makes graphs instead of audio
    FSynthPatch               : TSynthPatch;                  // The compiled synth patch - the audio generator
    FChartSeries              : array of TFastLineSeries;     // A set of graphs for the graphs mode
    FUpdateCounter            : Integer;                      // Cycle counter for toggling between lights updating and other update actions
    FCanCreateAudio           : Boolean;                      // Set to true when the program is ready to create and handle audio devices
  private
    FPortAudioAvailable       : Boolean;                      // True when the port audio DLL was detected and initialised
    FUsePortAudio             : Boolean;                      // True when port audio should be used, when off no attempt is made to use it
    FPortAudioSelected        : Boolean;                      // True when port audio was selected to be used by the user in the device setup
    FSelectedAPIID            : Integer;                      // The selected port audio API to be used (DerictX, ASIO, etc.)
  private
    FFFTWAvailable            : Boolean;                      // True when the FFTW DLL was found to be present and usable
  private
    FSelectedInputId          : DWORD;                        // Input  device ID for legacy audio
    FSelectedOutputId         : DWORD;                        // Output device ID for legacy audio
    FSelectedInputIdPA        : DWORD;                        // Input  device IS for port audio audio
    FSelectedOutputIdPA       : DWORD;                        // Output device ID for port audio audio
  private
    FAudioIn                  : TAudioIn;                     // Legacy audio in  port
    FAudioOut                 : TAudioOut;                    // Legacy audio out port
    FPaStream                 : Pointer;                      // Port Audio stream handle
    FPaInstreamParameters     : TPaStreamParameters;          // Port audio input  stream parameters
    FPaOutstreamParameters    : TPaStreamParameters;          // Port audio output stream parameters
    FPaAsioInStreamInfo       : TPaAsioStreamInfo;            // Port audio asio input  stream parameters
    FPaAsioOutStreamInfo      : TPaAsioStreamInfo;            // Port audio asio output stream parameters
    FPaAsioMinFrames          : clong;
    FPaAsioMaxFrames          : clong;
    FPaAsioPrefFrames         : clong;
    FPaAsioGranFrames         : clong;
  private
    FPaInUnderflows           : Int64;                        // Port audio input  underflow counter
    FPaInoverflows            : Int64;                        // Port audio input  overflow  counter
    FPaOutUnderflows          : Int64;                        // Port audio output underflow counter
    FPaOutoverflows           : Int64;                        // Port audio output overflow  counter
    FIOBalance                : Int64;                        // Legacy audio difference between input and output requests
    FLastAudioInUnderflows    : Int64;                        // Used to keep track of changes in input  underflow count
    FLastAudioInOverflows     : Int64;                        // Used to keep track of changes in input  overflow  count
    FLastAudioOutUnderflows   : Int64;                        // Used to keep track of changes in output underflow count
    FLastAudioOutOverflows    : Int64;                        // Used to keep track of changes in output overflow  count
    FPatchReader              : IKnobsPatchReader;            // Patch reader
    FPatchWriter              : IKnobsPatchWriter;            // Patch writer
  private
    FStartTime                : TDateTime;                    // Program start time - but can be reset to Now
    FInShadow1                : TSignal;                      // Dezipper register for InVolume1
    FInShadow2                : TSignal;                      //
    FInShadow3                : TSignal;                      //  ... ...
    FInShadow4                : TSignal;                      //
    FOutShadow1               : TSignal;                      //
    FOutShadow2               : TSignal;                      //  ... ...
    FOutShadow3               : TSignal;                      //
    FOutShadow4               : TSignal;                      // Dezipper register for OutVolume4
    FInVolume1                : TSignal;                      // Current channel 1 input volume
    FInVolume2                : TSignal;                      //
    FInVolume3                : TSignal;                      //  ... ...
    FInVolume4                : TSignal;                      //
    FOutVolume1               : TSignal;                      //
    FOutVolume2               : TSignal;                      //  ... ...
    FOutVolume3               : TSignal;                      //
    FOutVolume4               : TSignal;                      // Current channel 4 output volume
    FAudioInRunning           : Boolean;
    FAudioOutRunning          : Boolean;
  private
    FUseConfigHints           : Boolean;                      // Whether to use popup hints on the config screens
    FWireThickness            : Integer;                      // Pen size for wire drawing
    FCurvedLines              : Boolean;                      // True for curved lines instead of straight ones
    FControlMode              : TDistanceMode;                // Knob control mode (circular, horizontal, vertical)
    FReferenceA               : TSignal;                      // Frequency of reference A
    FNotesPerOctave           : TSignal;                      // The number of notes in a octave
    FMiddleNote               : TSignal;                      // The MIDI note number used to result in the reference A
    FLightsRate               : TSignal;                      // Lights update rate in the patch editor
    FKeyF8Down                : Boolean;                      // True when F8 key is active - for knob popups
    FResetOnRender            : Boolean;                      // When true a patch reset is issued when rendering starts, otherwise rendering starts where the patch currently happens to be
    FShowLightsTime           : Boolean;                      // Debug aid, when tru shows the amount of time spent in updating lights
  private
    FSynthNameInCaption       : Boolean;                      // When true show a 'OSC synth name'   indicator in the main window title bar
    FPatchChangedInCaption    : Boolean;                      // When true show a 'patch changed'    indicator in the main window title bar
    FProfiledInCaption        : Boolean;                      // When true show a 'profiled'         indicator in the main window title bar
    FAudioStatusInCaption     : Boolean;                      // When true show a 'audio status'     indicator in the main window title bar
    FProgramNameInCaption     : Boolean;                      // When true show a 'program exe name' indicator in the main window title bar
    FFileVersionInCaption     : Boolean;                      // When true show a 'program version'  indicator in the main window title bar
    FPatchNameInCaption       : Boolean;                      // When true show a 'patch name'       indicator in the main window title bar
    FSourceNameInCaption      : Boolean;                      // When true show a 'patch file name'  indicator in the main window title bar
    FPortAudioInCaption       : Boolean;                      // When true show a 'port audio'       indicator in the main window title bar
  private
    FDbMinMaxIn               : array[ 1 .. 8] of  TDbMinMax; // dB calculators for input  channelse
    FDbMinMaxOut              : array[ 1 .. 8] of  TDbMinMax; // dB calculators for output channelse
    FVuSampleCount            : Integer;                      // Samples / buffer, used to calculate VU timing
    FVuSystemRate             : Integer;                      // Samples / second, used to calculate VU timing
    FLightsTime               : TSignal;                      // Time spent in lights updater
  private
    FCpuUsageData             : PCPUUsageData;                // CPU usage calculator
    FProcessTime              : Single;                       // Current CPU usage percentage
  private
    FRequestAudioStart        : Boolean;                      // Async request to start audio devices
    FRequestAsioPanel         : Boolean;                      // Async request to start ASIO panel
    FRequestAudioRestart      : Boolean;                      // Async request to restart audio devices
    FPanelAudioWasRunning     : Boolean;                      // Flag to restart audio after ASIO panel was shown
    FAsioPanelDevice          : TPaDeviceIndex;               // The device on whcich the ASIO panel was opened
    FAsioPanelPointer         : Pointer;                      // Handle fro ASIO panel
  private
    FLastControlWidth         : Integer;                      // State for volume control panel folding
  private
    FOSCFifo                  : TBytesFifo;                   // Fifo for storing OSC messages coming from synth
    FLastCC                   : Byte;                         // Last MIDI CC seen (on assigned channel, or in OMNI mode).
    FLastFrozenCC             : Byte;                         // Last frozen MIDI CC seen (on assigned channel, or in OMNI mode).
  private
    procedure   UpdateCaptions;
    procedure   FixFoldButton;
  private
    procedure   SetSynthName             ( const aValue: string);
    procedure   SetCanLog                ( aValue: Boolean);
    procedure   SetLogToFile             ( aValue: Boolean);
    function    GetOffsetLeft            : Integer;
    procedure   SetOffsetLeft            ( aValue: Integer);
    function    GetOffsetTop             : Integer;
    procedure   SetOffsetTop             ( aValue: Integer);
    function    GetModuleColor           : TColor;
    procedure   SetModuleColor           ( aValue: TColor);
    procedure   SetStandardColors        ( aValue: Boolean);
    function    GetModuleOpacity         : Byte;
    procedure   SetModuleOpacity         ( aValue: Byte);
    procedure   SetPrioLevel             ( aValue: Integer);
    function    GetWaveDebug             : Boolean;
    procedure   SetWaveDebug             ( aValue: Boolean);
    function    GetSampleRate            : Integer;
    procedure   SetSampleRate            ( aValue: Integer);
    procedure   SetLightsActive          ( aValue: Boolean);
    procedure   SetAbsTimeStamps         ( aValue: Boolean);
    procedure   SetUseGraphs             ( aValue: Boolean);
    procedure   SetGraphStairs           ( aValue: Boolean);
    procedure   SetHistoryCount          ( aValue: Integer);
    function    GetSourceFileName        : string;
    procedure   SetSourceFileName        ( const aValue: string);
    function    GetPatchName             : string;
    procedure   SetPatchName             ( const aValue: string);
    procedure   SetReloadLastPatch       ( aValue: Boolean);
    procedure   SetAutoRun               ( aValue: Boolean);
    procedure   SetClearVUOnStop         ( aValue: Boolean);
    procedure   SetClearVUOnRecompile    ( aValue: Boolean);
    procedure   SetRenderToFile          ( aValue: Boolean);
    procedure   SetPatchChanged          ( aValue: Boolean);
    procedure   SetWarnOnPatchChange     ( aValue: Boolean);
    procedure   SetWarnChangeOnLoad      ( aValue: Boolean);
    procedure   SetUndoAfterSave         ( aValue: Boolean);
    procedure   SetUndoAfterLoad         ( aValue: Boolean);
    procedure   SetUseWheelOnKnobs       ( aValue: Boolean);
    procedure   SetWheelSensitivity      ( aValue: Integer);
    procedure   SetUseUnFocus            ( aValue: Boolean);
    procedure   SetUsePortAudio          ( aValue: Boolean);
    procedure   SetTuningChanged         ( aValue: Boolean);
  private
    procedure   SetNetMidiServer         ( const aValue: string);
    procedure   SetNetMidiPort           ( const aValue: string);
    procedure   SetNetMidiAutoConnect    ( aValue: Boolean);
    procedure   SetNetMidiConnected      ( aValue: Boolean);
    procedure   SetNetMidiChanged        ( aValue: Boolean);
    procedure   SetLogMidi               ( aValue: Boolean);
    procedure   SetLogMidiMsgs           ( aValue: Boolean);
    procedure   SetMidiChannel           ( aValue: Byte   );
  private
    procedure   SetOSCServer             ( const aValue: string);
    procedure   SetOSCPort               ( const aValue: string);
    procedure   SetUseOSC                ( aValue: Boolean);
    procedure   SetOSCChanged            ( aValue: Boolean);
    procedure   SetLogOSC                ( aValue: Boolean);
    procedure   SetLogOSCMsgs            ( aValue: Boolean);
  private
    procedure   SetCompilerDebug         ( aValue: Boolean);
    procedure   PaDebugProc              ( const aMsg: string);
  private
    function    GetInVolume1             : Integer;
    procedure   SetInVolume1             ( aValue: Integer);
    function    GetOutVolume1            : Integer;
    procedure   SetOutVolume1            ( aValue: Integer);
    function    GetInVolume2             : Integer;
    procedure   SetInVolume2             ( aValue: Integer);
    function    GetOutVolume2            : Integer;
    procedure   SetOutVolume2            ( aValue: Integer);
    function    GetInVolume3             : Integer;
    procedure   SetInVolume3             ( aValue: Integer);
    function    GetOutVolume3            : Integer;
    procedure   SetOutVolume3            ( aValue: Integer);
    function    GetInVolume4             : Integer;
    procedure   SetInVolume4             ( aValue: Integer);
    function    GetOutVolume4            : Integer;
    procedure   SetOutVolume4            ( aValue: Integer);
  private
    procedure   StartRendering;
    procedure   StopRendering;
    procedure   AddRenderData( const aLeft, aRight: TSignal);
  private
    procedure   OpenRecentFile( const anIndex: Integer);
    procedure   DorecentMenuItemClick( aSender: TObject);
    procedure   AddRecentMenuItem( anIndex: Integer; const aFileName: string);
    procedure   RemoveRecentMenuItems;
    procedure   SetRecentMenuItems;
    procedure   SetMostRecentFile( const aFileName: string);
    procedure   DoSelectorMenuItemClick( aSender: TObject);
    procedure   AddSelectorMenuItem( anIndex: Integer; const aName: string);
    procedure   RemoveSelectorMenuItems;
    procedure   LoadIni;
    procedure   SaveIni;
    procedure   ShowHelp;
    function    FixHtmlTokens( const S: string): string;
    procedure   ShowModuleHelp( aModule: TKnobsCustomModule);
    function    MustMakeDocs: Boolean;
    procedure   MakeDocs( const aFolder : string);
    procedure   ShowAcknowledgements;
    procedure   CheckForUpdates;
  private
    function    LogTimeStamp: string;
    procedure   WriteFileLog( const aMsg: string);
    procedure   Log( const aMsg: string; TimeStamped: Boolean = True);                                 overload;
    procedure   Log( const aMsgs: TStrings; DoClear: Boolean);                                         overload;
    procedure   LogFmt( const aFmt: string; const anArgs: array of const);
    procedure   MidiLog( const aMsg: string);
    procedure   MidiLogFmt( const aFmt: string; const anArgs: array of const);
    procedure   MidiMsgLog( const aMsg: string);
    procedure   MidiMsgLogFmt( const aFmt: string; const anArgs: array of const);
    procedure   OSCLog( const aMsg: string);
    procedure   OSCLogFmt( const aFmt: string; const anArgs: array of const);
    procedure   OSCMsgLog( const aMsg: string);
    procedure   OSCMsgLogFmt( const aFmt: string; const anArgs: array of const);
    procedure   ViewEditor;
    procedure   ViewDebug;
    procedure   ViewSettings;
    procedure   ViewGraphs;
    procedure   ClearLog;
    procedure   ClearGraphs;
    procedure   BuildGraphs;
    procedure   ShowPatch;
    procedure   ProfilePatch;
    procedure   FixModuleStatics;
    function    FixTalkieStatics    ( const aControl: TControl; aControlClass: TControlClass; const aUserData: TObject): Boolean;
    function    FixGranulatorStatics( const aControl: TControl; aControlClass: TControlClass; const aUserData: TObject): Boolean;
    function    FixSeqRandomStatics ( const aControl: TControl; aControlClass: TControlClass; const aUserData: TObject): Boolean;
    function    ChangeSynthPatch( const aSynthPatch: TSynthPatch): Boolean;
    procedure   ExecutePatch;
    procedure   ChartOutput( anIndex: Integer; aValue: TSignal);
    procedure   ChartOoutputs;
    procedure   DebugRunStop;
    procedure   FixLocalWheelSettings;
  private
    procedure   DeZipper;
    procedure   UpdateStats;
    procedure   UpdateLights;
    procedure   SetVuSampleCount( aCount: Integer);
    procedure   UpdateVUMeters;
    procedure   UpdateDbLabels;
    function    HandleAudioInOnBufferFilled( aBuffer: pAnsiChar; var aSize: Integer): Boolean;
    function    HandleAudioOutOnFillBuffer ( aBuffer: pAnsiChar; var aSize: Integer): Boolean;
    procedure   HandleAudioInOnStart       ( aSender: TObject);
    procedure   HandleAudioInOnStop        ( aSender: TObject);
    procedure   HandleAudioOutOnStart      ( aSender: TObject);
    procedure   HandleAudioOutOnStop       ( aSender: TObject);
    function    HandleAudioIOPA            ( anInput, anOutput: Pointer; aFrameCount: culong; aTimeInfo: PPaStreamCallbackTimeInfo; aStatusFlags: TPaStreamCallbackFlags; UserData: Pointer): cint;
    procedure   HandleAudioOnStartPA       ( userdata: Pointer);
    procedure   HandleAudioOnStopPA        ( userdata: Pointer);
    procedure   WaveShowAsioPanel( aSender: TObject; aDevice: TPaDeviceIndex; aHandle: HWND);
    procedure   WaveRestartAudio( aSender: TObject; aDebug: Boolean);
    procedure   WaveLog( aSender: TObject; const aMsg: string);
    procedure   CreateDevices;
    procedure   FreeDevices;
    procedure   HookDevices;
    procedure   UnhookDevices;
    procedure   StopAudioIn;
    procedure   StopAudioOut;
    procedure   StartAudioIn;
    procedure   StartAudioOut;
    procedure   StartStopAudioIo;
    procedure   VerifyDevices;
    procedure   SelectDevices;
    procedure   ClearVolumeIndicators;
    procedure   ShowOverUnderFlows;
    procedure   ClearOverUnderFlows;
    procedure   ShowRunTime;
    procedure   ResetRuntime;
    function    GetDefaultModuleColor( const aSender: TObject; const aModuleType: TKnobsModuleType): TColor;
    procedure   ConnectorDelete    ( const aConnector    : TKnobsConnector    );
    procedure   ConnectorBreak     ( const aConnector    : TKnobsConnector    );
    procedure   ConnectorDisconnect( const aConnector    : TKnobsConnector    );
    procedure   SetWireColor       ( const aConnector    : TKnobsConnector; const aColor: TColor);
    procedure   SetWireColorDefault( const aConnector    : TKnobsConnector    );
    procedure   SetWireColorCustom ( const aConnector    : TKnobsConnector    );
    procedure   ModuleCut          ( const aModule       : TKnobsModule       );
    procedure   ModuleCopy         ( const aModule       : TKnobsModule       );
    procedure   ModuleDelete       ( const aModule       : TKnobsModule       );
    procedure   ChangeModuleColor  ( const aModule       : TKnobsModule       );
    procedure   ModuleColorDefault ( const aModule       : TKnobsModule       );
    procedure   KnobSetDefaultValue( const aValuedControl: TKnobsValuedControl);
    procedure   KnobChangeLock     ( const aKnob         : TKnobsKnob         );
    procedure   AssignMidiCC       ( const aValuedControl: TKnobsValuedControl);
    procedure   AssignLastCCToKnob ( const aValuedControl: TKnobsValuedControl);
    procedure   UnAssignMidiCC     ( const aValuedControl: TKnobsValuedControl);
    procedure   ViewMIDIAssignments;
  private
    procedure   SetUseConfigHints( aValue: Boolean);
    procedure   SetWireThickness ( aValue: Integer);
    procedure   SetCurvedLines   ( aValue: Boolean);
    procedure   SetControlMode   ( aValue: TDistanceMode);
    procedure   SetLightsRate    ( aValue: TSignal);
    procedure   SetReferenceA    ( aValue: TSignal);
    procedure   SetNotesPerOctave( aValue: TSignal);
    procedure   SetMiddleNote    ( aValue: TSignal);
    procedure   SetResetOnRender ( aValue: Boolean);
    procedure   SetShowLightsTime( aValue: Boolean);
    function    GetTitleFont     : TFont;
    procedure   SetTitleFont     ( const aValue: TFont);
    function    GetModuleFont    : TFont;
    procedure   SetModuleFont    ( const aValue: TFont);
  private
    procedure   SetSynthNameInCaption   ( aValue: Boolean);
    procedure   SetPatchChangedInCaption( aValue: Boolean);
    procedure   SetProfiledInCaption    ( aValue: Boolean);
    procedure   SetAudioStatusInCaption ( aValue: Boolean);
    procedure   SetProgramNameInCaption ( aValue: Boolean);
    procedure   SetFileVersionInCaption ( aValue: Boolean);
    procedure   SetPatchNameInCaption   ( aValue: Boolean);
    procedure   SetSourceNameInCaption  ( aValue: Boolean);
    procedure   SetPortAudioInCaption   ( aValue: Boolean);
  private
    procedure   DoDesignerLog   ( const aSender: TObject; const aMsg: string);
    procedure   DoWirePanelLog  ( const aSender: TObject; const aMsg: string);
    procedure   DoHistoryChanged( const aSender: TObject; anUndoCount, aRedoCount, aSavedMarker: Integer);
    procedure   DoShowHint( var aHintStr: string; var CanShow: Boolean; var aHintInfo: Vcl.Controls.THintInfo);
    function    DoCreateModuleBitmap( const aModuleType: TKnobsModuleType; UseCache: Boolean): TBitmap;
    function    DoReadModuleComment ( const aModuleType: TKnobsModuleType): string;
    procedure   DoValueChanged( const aSender: TObject; const aPath, aControlType: string; aValue: TSignal; IsFinal, IsAutomation: Boolean);
    procedure   DoTextChanged ( const aSender: TObject; const aPath, aValue: string);
  private
    function    SplitValueInfo     ( const aPath: string; var aModule: TKnobsCustomModule; var aModuleType, aSignalName: string): Boolean;
    procedure   HandleSpecialValues( const aPath, aControlType: string; aValue: TSignal);
    procedure   ChangeRangeFor     ( const aModule: TKnobsCustomModule; const aModuleType, aRangeType: string; aValue: TSignal);
    procedure   ChangeModeFor      ( const aModule: TKnobsCustomModule; const aModuleType: string; aValue: TSignal);
  private
    procedure   DoLights       ( const aSender: TMod; const aMsg: string);
    procedure   DoData         ( const aSender: TMod; const aPath: string; const aData: TSignalArray);
    procedure   DoXYData       ( const aSender: TMod; const aPath: string; const aData: TSignalPairFifo);
    procedure   DoInfo         ( const aSender: TMod; const aMsg: string);
    procedure   DoPatchChanged ( const aSender: TKnobsWirePanel);
    procedure   DoWiresChanged ( const aSender: TKnobsWirePanel);
    procedure   DoShowPopupMenu( const aSender: TKnobsWirePanel; const aControl: TControl);
    procedure   DoUnFocus( const aSender: TObject);
    function    Template1Name: string;
    function    Template2Name: string;
    function    CheckDiscardPatchChanges( const aReason: string; MustAsk: Boolean): Boolean;
    function    SavePatchNamed( const aFileName: string; WriteAlways: Boolean)  : Boolean;
    function    SavePatch  : Boolean;
    function    SavePatchAs: Boolean;
    function    SaveAsTemplate( const aFileName: string): Boolean;
    function    SaveAsTemplate1: Boolean;
    function    SaveAsTemplate2: Boolean;
    procedure   ExportModules;
    procedure   DoLoadPatch( const aFileName: string; ChangePatchName: Boolean);
    procedure   DoImportPatch( const aFileName: string);
    procedure   LoadPatch;
    procedure   ImportPatch;
    procedure   NewPatch;
    procedure   DeleteModules;
    procedure   CutModules;
    procedure   CopyModules;
    procedure   PasteModules;
    procedure   PasteParameters;
    procedure   SelectAll;
    procedure   SelectNone;
    procedure   InvertSelection;
    procedure   WiggleWires;
    procedure   SearchPatch( const aValue: string);
    procedure   FindUnconnectedModules;
    procedure   CollectSmallValues;
  private
    function    FunctionalPinName( const aName: string): string;
    function    SplitConnectorName( const aName: string; var aMod, aPin: string): Boolean;
    function    ModuleTypeToModule( aType: Integer; const aParent: TSynthPatch; const aName: string): TMod;
    procedure   CompilePatch;
    procedure   RegisterMidiControls;
  private
    procedure   FixTuningAndSampleRate;
    procedure   ApplyTuning;
    procedure   CancelTuning;
  private
    procedure   InitializeCPUCounter;
    procedure   FinalizeCPUCounter;
    procedure   TickCPUCounter;
  private
    procedure   StartNetMidiConnectTimer;
    procedure   StopNetMidiConnectTimer;
    procedure   NetMidiConnectTimerFired;
    procedure   NetMidiConnect;
    procedure   NetMidiDisconnect;
    procedure   NetMidiApply;
    procedure   NetMidiCancel;
    procedure   ReceiveNetMidi;
    procedure   SendNetMidi  ( const aData: TBytes);
  private
    procedure   DoMidiRxMessage( const aSender: TObject; const aMsg: TMidiMessage);
    procedure   DoMidiTxMessage( const aSender: TObject; const aMsg: TMidiMessage);
    procedure   DoSynthLog     ( const aSender: TObject; const aMsg: string);
    procedure   DoSynthError   ( const aSender: TObject; const aMsg: string);
  private
    procedure   ResetInPeaks;
    procedure   ResetOutPeaks;
    procedure   ResetPeaks;
    procedure   ClearVUMeters;
    procedure   MemoDebugWindowProc( var aMsg: TMessage);
  private
    procedure   UMOSCString( var aMsg: TMsgOSCData);                                                 message UM_OSCDATA;
    procedure   SendOSCBytes( const aMsg: TBytes);
    procedure   QueueOSCBytes( const aMsg: TBytes);
    procedure   DoSendOSCBytes( const aSender: TObject; const aMsg: TBytes);
    procedure   SendOSCTestMessage;
 // procedure   SendOScMidi( const anAddress: string; aPort, aChannel, aMessage: Byte; aParam1: Byte = $ff; aParam2: Byte = $ff);
    procedure   HandleLocalOSCPacket( anOSCPacket: TOSCPacket);
    function    OscHandler( const aControl: TControl; aControlClass: TControlClass; const aUserData: TObject): Boolean;
    procedure   AcceptOSCBytes( const aMsg: TBytes);
    procedure   LogOSCMessage( const aMsg: TBytes; const aLabel: string);
    procedure   HandleOSCReception;
    procedure   OSCCancel;
    procedure   OSCApply;
    procedure   OSCEnable;
    procedure   OSCDisable;
    procedure   StartOSCGuard;
    procedure   StopOSCGuard;
    procedure   OSCGuardFired;
  public
    // IsShortCut needs be public or otherwise 'less visible than in base class' compiler naggings.
    function    IsShortCut( var aMessage: TWMKey): Boolean; override;
  private
    property    SynthName              : string        read FSynthName              write SetSynthName;
    property    CanLog                 : Boolean       read FCanLog                 write SetCanLog;
    property    LogToFile              : Boolean       read FLogToFile              write SetLogToFile;
    property    OffsetLeft             : Integer       read GetOffsetLeft           write SetOffsetLeft;
    property    OffsetTop              : Integer       read GetOffsetTop            write SetOffsetTop;
    property    ModuleColor            : TColor        read GetModuleColor          write SetModuleColor;
    property    StandardColors         : Boolean       read FStandardColors         write SetStandardColors;
    property    ModuleOpacity          : Byte          read GetModuleOpacity        write SetModuleOpacity;
    property    PrioLevel              : Integer       read FPrioLevel              write SetPrioLevel;
    property    WaveDebug              : Boolean       read GetWaveDebug            write SetWaveDebug;
    property    BufferSize             : Integer       read FBufferSize             write FBufferSize;
    property    Samplerate             : Integer       read GetSampleRate           write SetSampleRate;
    property    LightsActive           : Boolean       read FLightsActive           write SetLightsActive;
    property    AbsTimeStamps          : Boolean       read FAbsTimeStamps          write SetAbsTimeStamps;
    property    UseGraphs              : Boolean       read FUseGraphs              write SetUseGraphs;
    property    GraphStairs            : Boolean       read FGraphStairs            write SetGraphStairs;
    property    HistoryCount           : Integer       read FHistoryCount           write SetHistoryCount;
    property    SourceFileName         : string        read GetSourceFileName       write SetSourceFileName;
    property    PatchName              : string        read GetPatchName            write SetPatchName;
    property    ReloadLastPatch        : Boolean       read FReloadLastPatch        write SetReloadLastPatch;
    property    AutoRun                : Boolean       read FAutoRun                write SetAutoRun;
    property    ClearVUOnStop          : Boolean       read FClearVUOnStop          write SetClearVUOnStop;
    property    ClearVUOnRecompile     : Boolean       read FClearVUOnRecompile     write SetClearVUOnRecompile;
    property    RenderToFile           : Boolean       read FRenderToFile           write SetRenderToFile;
    property    PatchChanged           : Boolean       read FPatchChanged           write SetPatchChanged;
    property    WarnOnPatchChange      : Boolean       read FWarnOnPatchChange      write SetWarnOnPatchChange;
    property    WarnChangeOnLoad       : Boolean       read FWarnChangeOnLoad       write SetWarnChangeOnLoad;
    property    UndoAfterSave          : Boolean       read FUndoAfterSave          write SetUndoAfterSave;
    property    UndoAfterLoad          : Boolean       read FUndoAfterLoad          write SetUndoAfterLoad;
    property    UseWheelOnKnobs        : Boolean       read FUseWheelOnKnobs        write SetUseWheelOnKnobs;
    property    WheelSensitivity       : Integer       read FWheelSensitivity       write SetWheelSensitivity;
    property    UseUnFocus             : Boolean       read FUseUnfocus             write SetUseUnFocus;
    property    UsePortAudio           : Boolean       read FUsePortAudio           write setUsePortAudio;
    property    TuningChanged          : Boolean       read FTuningChanged          write SetTuningChanged;
  private
    property    NetMidiServer          : string        read FNetMidiServer          write SetNetMidiServer;
    property    NetMidiPort            : string        read FNetMidiPort            write SetNetMidiPort;
    property    NetMidiAutoConnect     : Boolean       read FNetMidiAutoConnect     write SetNetMidiAutoConnect;
    property    NetMidiConnected       : Boolean       read FNetMidiConnected       write SetNetMidiConnected;
    property    NetMidiChanged         : Boolean       read FNetMidiChanged         write SetNetMidiChanged;
    property    LogMidi                : Boolean       read FLogMidi                write SetLogMidi;
    property    LogMidiMsgs            : Boolean       read FLogMidiMsgs            write SetLogMidiMsgs;
    property    MidiChannel            : Byte          read FMidiChannel            write SetMidiChannel;
  private
    property    OSCServer              : string        read FOSCServer              write SetOSCServer;
    property    OSCPort                : string        read FOSCPort                write SetOSCPort;
    property    UseOSC                 : Boolean       read FUSeOSC                 write SetUseOSC;
    property    OSCChanged             : Boolean       read FOSCChanged             write SetOSCChanged;
    property    LogOSC                 : Boolean       read FLogOSC                 write SetLogOSC;
    property    LogOSCMsgs             : Boolean       read FLogOSCMsgs             write SetLogOSCMsgs;
  private
    property    CompilerDebug          : Boolean       read FCompilerDebug          write SetCompilerDebug;
  private
    property    InVolume1              : Integer       read GetInVolume1            write SetInVolume1;
    property    OutVolume1             : Integer       read GetOutVolume1           write SetOutVolume1;
    property    InVolume2              : Integer       read GetInVolume2            write SetInVolume2;
    property    OutVolume2             : Integer       read GetOutVolume2           write SetOutVolume2;
    property    InVolume3              : Integer       read GetInVolume3            write SetInVolume3;
    property    OutVolume3             : Integer       read GetOutVolume3           write SetOutVolume3;
    property    InVolume4              : Integer       read GetInVolume4            write SetInVolume4;
    property    OutVolume4             : Integer       read GetOutVolume4           write SetOutVolume4;
  private
    property    UseConfigHints         : Boolean       read FUseConfigHints         write SetUseConfigHints;
    property    WireThickness          : Integer       read FWireThickness          write SetWireThickness;
    property    CurvedLines            : Boolean       read FCurvedLines            write SetCurvedLines;
    property    ControlMode            : TDistanceMode read FControlMode            write SetControlMode;
    property    LightsRate             : TSignal       read FLightsRate             write SetLightsRate;
    property    ReferenceA             : TSignal       read FReferenceA             write SetReferenceA;
    property    NotesPerOctave         : TSignal       read FNotesPerOctave         write SetNotesPerOctave;
    property    MiddleNote             : TSignal       read FMiddleNote             write SetMiddleNote;
    property    ResetOnRender          : Boolean       read FResetOnRender          write SetResetOnRender;
    property    ShowLightsTime         : Boolean       read FShowLightsTime         write SetShowLightsTime;
    property    TitleFont              : TFont         read GetTitleFont            write SetTitleFont;
    property    ModuleFont             : TFont         read GetModuleFont           write SetModuleFont;
  private
    property    SynthNameInCaption     : Boolean       read FSynthNameInCaption     write SetSynthNameInCaption   ;
    property    PatchChangedInCaption  : Boolean       read FPatchChangedInCaption  write SetPatchChangedInCaption;
    property    ProfiledInCaption      : Boolean       read FProfiledInCaption      write SetProfiledInCaption    ;
    property    AudioStatusInCaption   : Boolean       read FAudioStatusInCaption   write SetAudioStatusInCaption ;
    property    ProgramNameInCaption   : Boolean       read FProgramNameInCaption   write SetProgramNameInCaption ;
    property    FileVersionInCaption   : Boolean       read FFileVersionInCaption   write SetFileVersionInCaption ;
    property    PatchNameInCaption     : Boolean       read FPatchNameInCaption     write SetPatchNameInCaption   ;
    property    SourceNameInCaption    : Boolean       read FSourceNameInCaption    write SetSourceNameInCaption  ;
    property    PortAudioInCaption     : Boolean       read FPortAudioInCaption     write SetPortAudioInCaption   ;
  end;

var

  FormWren: TFormWren;



implementation



type

  TSample    = SmallInt;                 // External value type for OS samples
  TSamples   = packed array[ 0 .. MaxInt div SizeOf( TSample) - 1] of TSample;
  PSamples   = ^TSamples;

const

  SAMP_MAX         =   High( TSample);   // Maximum value for a sample
  SAMP_MIN         = - High( TSample);   // Minimum value for a sample
  MAX_IN_CHANNELS  = 8;                  // Maximum number of input  channels to use
  MAX_OUT_CHANNELS = 8;                  // Maximum number of output channels to use
  MIN_DB           = -100.0;             // Minimum dB value to be shown on Main VU meters
  MAX_DB           =   20.0;             // Maximum dB value to be shown on Main VU meters
  DB_DECAY_RATE    =    1.0;             // Decay rate for peak indicators on VU meters (seconds)
  TEST_PACKET_NAME = '/*/testmessage';   // Pattern for the OSC test message

{$R *.dfm}

// User area

    function    SocketStateToStr( aValue: TSocketState): string;
    begin
      Result := GetEnumName( TypeInfo( TSocketState), Integer( aValue));
    end;

    function ClipSample( aSample: TSignal): TSample; inline;
    begin
      if aSample > SAMP_MAX
      then Result := SAMP_MAX
      else if aSample < SAMP_MIN
      then Result := SAMP_MIN
      else Result := Round( aSample);
    end;

    function SampleToUnits( aSample: TSample): TSignal; inline;
    begin
      Result := aSample / SAMP_MAX;
    end;

    function SignalToSample( aUnit: TSignal): TSample; inline;
    begin
      Result := ClipSample( aUnit * SAMP_MAX);
    end;

    // PortAudio callbacks

    function    GHandleAudioOnBufferFilledPA( anInput, anOutput: Pointer; aFrameCount: culong; aTimeInfo: PPaStreamCallbackTimeInfo; aStatusFlags: TPaStreamCallbackFlags; UserData: Pointer): cint; cdecl;
    begin
      if Assigned( FormWren)
      then Result := FormWren.HandleAudioIOPA( anInput, anOutput, aFrameCount, aTimeInfo, aStatusFlags, UserData)
      else Result := paAbort;
    end;

    procedure   GHandleAudioOnStopPA( userdata: Pointer); cdecl;
    begin
      if Assigned( FormWren)
      then FormWren.HandleAudioOnStopPA( userdata);
    end;

    procedure   GPaDebugProc( const aMsg: PAnsiChar); cdecl;
    begin
      if Assigned( FormWren)
      then FormWren.PaDebugProc( string( aMsg));
    end;

    function    MakeMidiCCName( const aValuedControl: TKnobsValuedControl): string;
    var
      aParts : TStringList;
    begin
      if Assigned( aValuedControl)
      then begin
        Result := aValuedControl.Name;
        aParts := Explode( Result, '_');
        try
          if ( aParts.Count = 2)
          then begin
            if Assigned( aValuedControl.Parent) and ( aValuedControl.Parent is TKnobsModule)
            then Result := TKnobsModule( aValuedControl.Parent).Name + '_' + aParts[ 1]
            else Result := 'global_' + aParts[ 1];
          end
        finally
          aParts.DisposeOf;
        end;
      end;
    end;



{ ========
  TPageControl = class( Vcl.ComCtrls.TPageControl)
  private
}

    // Some stuff to fix the border width for TPageControls

    procedure   TPageControl.TCMAdjustRect( var Msg: TMessage); // message TCM_ADJUSTRECT;
    begin
      inherited;
      if Msg.WParam = 0
      then InflateRect( PRect( Msg.LParam)^,  4,  4)
      else InflateRect( PRect( Msg.LParam)^, -4, -4);
    end;



{ ========
  TFormModules = class( TForm)
  private
}

    procedure   TFormWren.UpdateCaptions;

      procedure Addpart( const aParts: TStringList; const aPart: string);
      begin
        if aPart <> ''
        then aParts.Add( aPart);
      end;

    const
    {$ifdef DEBUG}
      Changed   : array[ Boolean] of string = ( 'DEBUG'  , '*** DEBUG'                                               );
    {$else}
      Changed   : array[ Boolean] of string = ( ''       , '***'                                                     );
    {$endif}
      Runs      : array[ Boolean] of string = ( 'STOPPED', ''                                                        );
      PortAudio : array[ Boolean] of string = ( 'Legacy' , 'PortAudio'                                               );
      Caps      : array[ Boolean] of string = ( 'run'    , 'stop'                                                    );
      Pleases1  : array[ Boolean] of string = ( ''       , 'Please stop audio processing before making changes here,');
      Pleases2  : array[ Boolean] of string = ( ''       , 'and stop and restart the program after making changes.'  );

    {$IFDEF PATCH_PROFILER}
      Profiled = 'PROFILED';
    {$ELSE}
      Profiled = '';
    {$ENDIF}

    var
      aParts : TStringList;
    begin
      aparts := TStringList.Create;
      try
    {$ifdef DEBUG}
        if SynthNameInCaption    then Addpart( aParts, SynthName);
        if PatchChangedInCaption then Addpart( aParts, Changed[ PatchChanged]);
    {$else}
        if PatchChangedInCaption then Addpart( aParts, Changed[ PatchChanged]);
        if SynthNameInCaption    then Addpart( aParts, SynthName);
    {$endif}
        if ProfiledInCaption     then AddPart( aParts, Profiled);
        if AudioStatusInCaption  then Addpart( aParts, Runs[ FAudioInRunning and FAudioOutRunning]);
        if ProgramNameInCaption  then AddPart( aParts, FOrigCaption);
        if FileVersionInCaption  then AddPart( aParts, GetFileVersion);
        if PatchNameInCaption    then AddPart( aParts, PatchName);
        if SourceNameInCaption   then Addpart( aparts, ExtractFileName( SourceFileName));
        if PortAudioInCaption    then Addpart( aParts, portaudio[ FPortAudioSelected]);

        Caption := Implode( aParts, '  ::  ');

        LabelPleaseStopAudio1  .Caption := Pleases1[ FAudioInRunning or  FAudioOutRunning];
        LabelPleaseStopAudio2  .Caption := Pleases2[ FAudioInRunning or  FAudioOutRunning];
        BitBtnAudioRunning     .Caption := Caps    [ FAudioInRunning and FAudioOutRunning];
        MenuActionRunStop      .Caption := Caps    [ FAudioInRunning and FAudioOutRunning];
        MenuActionRunStop      .Checked :=           FAudioInRunning and FAudioOutRunning;
        GroupBoxAudioProperties.Enabled := not(      FAudioInRunning and FAudioOutRunning);
      finally
        aParts.DisposeOf;
      end;
    end;

    procedure   TFormWren.FixFoldButton;
    const
      Captions : array[ Boolean] of string = ( '', '');
    begin
      SpeedButtonChangeControlPanel.Caption := Captions[ PanelControl.Width <> 0];
    end;

    //  private

    procedure   TFormWren.SetSynthName( const aValue: string);
    begin
      if aValue <> FSynthName
      then begin
        FSynthName         := aValue;
        EditSynthName.Text := aValue;
        UpdateCaptions;
      end;
    end;

    procedure   TFormWren.SetCanLog( aValue: Boolean);
    begin
      if aValue <> FCanLog
      then begin
        FCanLog := aValue;
        if CanLog
        then Log( FSavedLogs, True);     // This will clear FSavedLogs
      end;
    end;

    procedure   TFormWren.SetLogToFile( aValue: Boolean);
    begin
      if aValue <> FLogToFile
      then begin
        FLogToFile                := aValue;
        CheckBoxLogToFile.Checked := aValue;
      end;
    end;

    function    TFormWren.GetOffsetLeft: Integer;
    begin
      if Assigned( PatchEditor)
      then Result := PatchEditor.OffsetLeft
      else Result := 4;
    end;

    procedure   TFormWren.SetOffsetLeft( aValue: Integer);
    begin
      if Assigned( PatchEditor)
      then PatchEditor.OffsetLeft           := aValue;
      KnobsSmallKnob_LeftOffset.KnobPosition := aValue;
    end;

    function    TFormWren.GetOffsetTop: Integer;
    begin
      if Assigned( PatchEditor)
      then Result := PatchEditor.OffsetTop
      else Result := 4;
    end;

    procedure   TFormWren.SetOffsetTop( aValue: Integer);
    begin
      if Assigned( PatchEditor)
      then PatchEditor.OffsetTop           := aValue;
      KnobsSmallKnob_TopOffset.KnobPosition := aValue;
    end;

    function    TFormWren.GetModuleColor: TColor;
    begin
      Result := PatchEditor.ModuleColor;
    end;

    procedure   TFormWren.SetModuleColor( aValue: TColor);
    begin
      PatchEditor        .ModuleColor := aValue;
      KnobsLedModuleColor.ColorOn     := aValue;
    end;

    procedure   TFormWren.SetStandardColors( aValue: Boolean);
    begin
      if aValue <> FStandardColors
      then begin
        FStandardColors                := aValue;
        CheckboxStandardColors.Checked := aValue;
      end;
    end;

    function    TFormWren.GetModuleOpacity: Byte;
    begin
      Result := PatchEditor.ModuleOpacity;
    end;

    procedure   TFormWren.SetModuleOpacity( aValue: Byte);
    begin
      PatchEditor                .ModuleOpacity := aValue;
      KnobsSmallKnobModuleOpacity.KnobPosition  := aValue;
    end;

    procedure   TFormWren.SetPrioLevel( aValue: Integer);

      function PriorityLevelToStr( aValue : Integer): string;
      begin
        case aValue of
         -1  : Result := 'idle';
          0  : Result := 'normal';
          1  : Result := 'higher';
          2  : Result := 'real time';
          else Result := Format( 'unknown (%d)', [ aValue]);
        end;
      end;

    begin
      if aValue <> FPrioLevel
      then begin
        if SetPriorityLevel( aValue)
        then begin
          FPrioLevel := aValue;
          LogFmt( 'priority level was set to "%s".', [ PriorityLevelToStr( FPrioLevel)]);
        end
        else LogFmt( 'could not set priority level to "%s".', [ PriorityLevelToStr( aValue)]);
      end;
      RadioGroupPrioLevel.ItemIndex := FPrioLevel;
    end;

    function    TFormWren.GetWaveDebug: Boolean;
    begin
      if Assigned( FormWaveDeviceSelect)
      then Result := FormWaveDeviceSelect.Debug
      else Result := False;
    end;

    procedure   TFormWren.SetWaveDebug( aValue: Boolean);
    begin
      if Assigned( FormWaveDeviceSelect)
      then FormWaveDeviceSelect.Debug := aValue;
    end;

    function    TFormWren.GetSampleRate: Integer;
    begin
      Result := System_Rate;;
    end;

    procedure   TFormWren.SetSampleRate( aValue: Integer);
    begin
      Assert( not( FAudioInRunning or FAudioOutRunning), 'Audio must be stopped for changing the system rate');
      if
        ( aValue <> 44100) and
        ( aValue <> 48000) and
        ( aValue <> 88200) and
        ( aValue <> 96000)
      then aValue := 44100;

      if aValue <> System_Rate
      then begin
        FreeDevices;                // Recreate devices for new sample rate
        SetSystemRate( aValue);     // Recalculate lookup tables and such
        FixTuningAndSampleRate;
        CreateDevices;
        case aValue of
          44100 : RadioGroupSampleRate.ItemIndex := 0;
          48000 : RadioGroupSampleRate.ItemIndex := 1;
          88200 : RadioGroupSampleRate.ItemIndex := 2;
          96000 : RadioGroupSampleRate.ItemIndex := 3;
        end;
      end;
    end;

    procedure   TFormWren.SetUseGraphs( aValue: Boolean);
    begin
      if aValue <> FUseGraphs
      then begin
        FUseGraphs                := aValue;
        CheckBoxUseGraphs.Checked := aValue;
        TabSheetGraphs   .Visible := aValue;
        MenuViewGraphs   .Visible := aValue;
        BuildGraphs;
      end;
    end;

    procedure   TFormWren.SetLightsActive( aValue: Boolean);
    begin
      if aValue <> FLightsActive
      then begin
        FLightsActive                := aValue;
        CheckBoxLightsActive.Checked := aValue;
      end;
    end;

    procedure   TFormWren.SetAbsTimeStamps( aValue: Boolean);
    begin
      if aValue <> FAbsTimeStamps
      then begin
        FAbsTimeStamps                := aValue;
        CheckBoxAbsTimeStamps.Checked := aValue;
      end;
    end;

    procedure   TFormWren.SetGraphStairs( aValue: Boolean);
    var
      i : Integer;
    begin
      if aValue <> FGraphStairs
      then begin
        FGraphStairs                := aValue;
        CheckBoxGraphStairs.Checked := aValue;
        for i := 0 to Length( FChartSeries) - 1
        do FChartSeries[ i].Stairs := aValue;
      end;
    end;

    procedure   TFormWren.SetHistoryCount( aValue: Integer);
    begin
      if aValue <> FHistoryCount
      then begin
        FHistoryCount                         := aValue;
        KnobsNoKnob_HistoryCount.KnobPosition := aValue - 1;
        if Assigned( FRecentSourceFiles)
        then FRecentSourceFiles.MaxDepth := aValue;
      end;
    end;

    function    TFormWren.GetSourceFileName : string;
    begin
      if Assigned( PatchEditor)
      then Result := PatchEditor.Filename
      else Result := '';
    end;

    procedure   TFormWren.SetSourceFileName( const aValue: string);
    begin
      if ( aValue <> SourceFileName) and Assigned( PatchEditor)
      then begin
        PatchEditor.Filename := aValue;
        SetMostRecentFile( aValue);
        UpdateCaptions;
      end;
    end;

    function    TFormWren.GetPatchName: string;
    begin
      if Assigned( PatchEditor)
      then Result := PatchEditor.Title
      else Result := 'no name';
    end;

    procedure   TFormWren.SetPatchName( const aValue: string);
    begin
      if ( aValue <> PatchName) and Assigned( PatchEditor)
      then begin
        PatchEditor.Title := aValue;
        UpdateCaptions;
      end;
      EditPatchName.Text  := aValue;
    end;

    procedure   TFormWren.SetPatchChanged( aValue: Boolean);
    begin
      if aValue <> FPatchChanged
      then begin
        FPatchChanged := aValue;
        UpdateCaptions;
      end;
    end;

    procedure   TFormWren.SetWarnOnPatchChange( aValue: Boolean);
    begin
      if aValue <> FWarnOnPatchChange
      then begin
        FWarnOnPatchChange                := aValue;
        CheckBoxWarnOnPatchChange.Checked := aValue;
      end;
    end;

    procedure   TFormWren.SetWarnChangeOnLoad( aValue: Boolean);
    begin
      if aValue <> FWarnChangeOnLoad
      then begin
        FWarnChangeOnLoad                := aValue;
        CheckBoxWarnChangeOnLoad.Checked := aValue;
      end;
    end;

    procedure   TFormWren.SetUndoAfterSave( aValue: Boolean);
    begin
      if aValue <> FUndoAfterSave
      then begin
        FUndoAfterSave                := aValue;
        CheckBoxUndoAfterSave.Checked := aValue;
      end;
    end;

    procedure   TFormWren.SetUndoAfterLoad( aValue: Boolean);
    begin
      if aValue <> FUndoAfterLoad
      then begin
        FUndoAfterLoad                := aValue;
        CheckBoxUndoAfterLoad.Checked := aValue;
      end;
    end;

    procedure   TFormWren.SetUseWheelOnKnobs( aValue: Boolean);
    begin
      if aValue <> FUseWheelOnKnobs
      then begin
        FUseWheelOnKnobs                := aValue;
        CheckBoxUseWheelOnKnobs.Checked := aValue;
        if Assigned( PatchEditor)
        then PatchEditor.WheelSupportOnKnobs := aValue;
        if Assigned( FormSelectMidiCC)
        then FormSelectMidiCC.UseWheelOnKnobs := aValue;
        FixLocalWheelSettings;
        CheckBoxUseUnFocus.Enabled := aValue;
      end;
    end;

    procedure   TFormWren.SetWheelSensitivity( aValue: Integer);
    begin
      if aValue <> FWheelSensitivity
      then begin
        FWheelSensitivity                  := aValue;
        knob_WheelSensitivity.KnobPosition := aValue;
        if Assigned( PatchEditor)
        then PatchEditor.WheelSensitivity := aValue;
        if Assigned( FormSelectMidiCC)
        then FormSelectMidiCC.WheelSensitivity := aValue;
        FixLocalWheelSettings;
      end;
    end;

    procedure   TFormWren.SetUseUnFocus( aValue: Boolean);
    begin
      if aValue <> FUSeUnFocus
      then begin
        FUSeUnFocus                := aValue;
        CheckBoxUseUnFocus.Checked := aValue;
      end;
    end;

    procedure   TFormWren.SetUsePortAudio( aValue: Boolean);
    begin
      if aValue <> FUsePortAudio
      then begin
        FUsePortAudio                       := aValue;
        CheckBoxUsePortAudio.Checked        := aValue;
        FormWaveDeviceSelect.AllowPortAudio := UsePortAudio;
        VerifyDevices;
      end;
    end;

    procedure   TFormWren.SetTuningChanged( aValue: Boolean);
    begin
      if aValue <> FTuningChanged
      then begin
        FTuningChanged             := aValue;
        BitBtnApplyTuning .Enabled := aValue;
        BitBtnCancelTuning.Enabled := aValue;
      end;
    end;

    procedure   TFormWren.SetReloadLastPatch( aValue: Boolean);
    begin
      if aValue <> FReloadLastPatch
      then begin
        FReloadLastPatch                := aValue;
        CheckBoxReloadLastPatch.Checked := aValue;
      end;
    end;

    procedure   TFormWren.SetAutoRun( aValue: Boolean);
    begin
      if aValue <> FAutoRun
      then begin
        FAutoRun                := aValue;
        CheckBoxAutoRun.Checked := aValue;
        if AutoRun And FCanCreateAudio
        then begin
          if not FAudioInRunning
          then StartAudioIn;
          if not FAudioOutRunning
          then StartAudioOut;
        end;
      end;
    end;

    procedure   TFormWren.SetClearVUOnStop( aValue: Boolean);
    begin
      if aValue <> FClearVUOnStop
      then begin
        FClearVUOnStop                := aValue;
        CheckBoxClearVUOnStop.Checked := aValue;
      end;
    end;

    procedure   TFormWren.SetClearVUOnRecompile( aValue: Boolean);
    begin
      if aValue <> FClearVUOnRecompile
      then begin
        FClearVUOnRecompile                := aValue;
        CheckBoxClearVUOnRecompile.Checked := aValue;
      end;
    end;

    procedure   TFormWren.SetRenderToFile( aValue: Boolean);
    const
      Caps : array[ Boolean] of string = (
        'Start file rendering',
        'Stop file rendering'
      );
    begin
      if aValue <> FRenderToFile
      then begin
        FRenderToFile := aValue;
        KnobsSelectorFileRender.KnobPosition := Ord( aValue);
        MenuActionStartfilerender.Caption := Caps[ aValue];
        if aValue
        then StartRendering;
      end;
    end;

//  private

    procedure   TFormWren.SetNetMidiServer( const aValue: string);
    var
      WasConnected : Boolean;
    begin
      if aValue <> FNetMidiServer
      then begin
        EditNetMidiServer.Text := aValue;
        WasConnected := NetMidiConnected;
        NetMidiDisconnect;
        FNetMidiServer := aValue;
        if WasConnected
        then NetMidiConnect;
      end;
    end;

    procedure   TFormWren.SetNetMidiPort( const aValue: string);
    var
      WasConnected : Boolean;
    begin
      if aValue <> FNetMidiPort
      then begin
        EditNetMidiPort.Text := aValue;
        WasConnected := NetMidiConnected;
        NetMidiDisconnect;
        FNetMidiPort := aValue;
        if WasConnected
        then NetMidiConnect;
      end;
    end;

    procedure   TFormWren.SetNetMidiAutoConnect( aValue: Boolean);
    begin
      if aValue <> FNetMidiAutoConnect
      then begin
        FNetMidiAutoConnect                := aValue;
        CheckBoxNetMidiAutoConnect.Checked := aValue;
        if NetMidiAutoConnect and not NetMidiConnected
        then StartNetMidiConnectTimer;
      end;
    end;

    procedure   TFormWren.SetNetMidiConnected( aValue: Boolean);
    const
      Caps : array[ Boolean] of string = (
        'connect',
        'disconnect'
      );
    begin
      if aValue <> FNetMidiConnected
      then begin
        FNetMidiConnected            := aValue;
        LedNetMidiConnect1  .Active  := aValue;
        LedNetMidiConnect2  .Active  := aValue;
        BitBtnNetMidiConnect.Caption := Caps[ aValue];
      end;
    end;

    procedure   TFormWren.SetNetMidiChanged( aValue: Boolean);
    begin
      if aValue <> FNetMidiChanged
      then begin
        FNetMidiChanged             := aValue;
        BitBtnApplyNetMidi .Enabled := aValue;
        BitBtnCancelNetMidi.Enabled := aValue;
      end;
    end;

    procedure   TFormWren.SetLogMidi( aValue: Boolean);
    begin
      if  aValue <> FLogMidi
      then begin
        FLogMidi                := aValue;
        CheckBoxLogMidi.Checked := aValue;
      end;
    end;

    procedure   TFormWren.SetLogMidiMsgs( aValue: Boolean);
    begin
      if  aValue <> FLogMidiMsgs
      then begin
        FLogMidiMsgs                := aValue;
        CheckBoxLogMidiMsgs.Checked := aValue;
      end;
    end;

    procedure   TFormWren.SetMidiChannel( aValue: Byte);
    begin
      if  aValue <> FMidiChannel
      then begin
        FMidiChannel             := aValue;
        main_midich.KnobPosition := aValue;
        if Assigned( FSynthPatch)
        then FSynthPatch.MidiChannel := MidiChannel;
      end;
    end;

//  private

    procedure   TFormWren.SetOSCServer( const aValue: string);
    begin
      if aValue <> FOSCServer
      then begin
        EditOSCServer.Text := aValue;
        FOSCServer         := aValue;
      end;
    end;

    procedure   TFormWren.SetOSCPort( const aValue: string);
    begin
      if aValue <> FOSCPort
      then begin
        EditOSCPort.Text := aValue;
        FOSCPort         := aValue;
      end;
    end;

    procedure   TFormWren.SetUseOSC( aValue: Boolean);
    begin
      if aValue <> FUSeOSC
      then begin
        CheckBoxUseOSC.Checked := aValue;
        FUSeOSC                := aValue;
      end;
    end;

    procedure   TFormWren.SetOSCChanged( aValue: Boolean);
    begin
      if aValue <> FOSCChanged
      then begin
        FOSCChanged             := aValue;
        BitBtnApplyOSC .Enabled := aValue;
        BitBtnCancelOSC.Enabled := aValue;
      end;
    end;

    procedure   TFormWren.SetLogOSC( aValue: Boolean);
    begin
      if aValue <> FLogOSC
      then begin
        FLogOSC                := aValue;
        CheckBoxLogOSC.Checked := aValue;
      end;
    end;

    procedure   TFormWren.SetLogOSCMsgs( aValue: Boolean);
    begin
      if aValue <> FLogOSCMsgs
      then begin
        FLogOSCMsgs                := aValue;
        CheckBoxLogOSCMsgs.Checked := aValue;
      end;
    end;

//  private

    procedure   TFormWren.SetCompilerDebug( aValue: Boolean);
    begin
      if  aValue <> FCompilerDebug
      then begin
        FCompilerDebug                := aValue;
        CheckBoxCompilerDebug.Checked := aValue;
      end;
    end;

    procedure   TFormWren.PaDebugProc( const aMsg: string);
    begin
      Log( aMsg);
    end;

//  private

    function    TFormWren.GetInVolume1: Integer;
    begin
      Result := knob_inputlevel1.KnobPosition;
    end;

    procedure   TFormWren.SetInVolume1( aValue: Integer);
    begin
      knob_inputlevel1.KnobPosition := aValue;
      FInShadow1                    := knob_inputlevel1.AsValue;
    end;

    function    TFormWren.GetOutVolume1: Integer;
    begin
      Result := knob_outputlevel1.KnobPosition;
    end;

    procedure   TFormWren.SetOutVolume1( aValue: Integer);
    begin
      knob_outputlevel1.KnobPosition := aValue;
      FOutShadow1                    := knob_outputlevel1.AsValue;
    end;

    function    TFormWren.GetInVolume2: Integer;
    begin
      Result := knob_inputlevel2.KnobPosition;
    end;

    procedure   TFormWren.SetInVolume2( aValue: Integer);
    begin
      knob_inputlevel2.KnobPosition := aValue;
      FInShadow2                    := knob_inputlevel2.AsValue;
    end;

    function    TFormWren.GetOutVolume2: Integer;
    begin
      Result := knob_outputlevel2.KnobPosition;
    end;

    procedure   TFormWren.SetOutVolume2( aValue: Integer);
    begin
      knob_outputlevel2.KnobPosition := aValue;
      FOutShadow2                    := knob_outputlevel2.AsValue;
    end;

    function    TFormWren.GetInVolume3: Integer;
    begin
      Result := knob_inputlevel3.KnobPosition;
    end;

    procedure   TFormWren.SetInVolume3( aValue: Integer);
    begin
      knob_inputlevel3.KnobPosition := aValue;
      FInShadow3                    := knob_inputlevel3.AsValue;
    end;

    function    TFormWren.GetOutVolume3: Integer;
    begin
      Result := knob_outputlevel3.KnobPosition;
    end;

    procedure   TFormWren.SetOutVolume3( aValue: Integer);
    begin
      knob_outputlevel3.KnobPosition := aValue;
      FOutShadow3                    := knob_outputlevel3.AsValue;
    end;

    function    TFormWren.GetInVolume4: Integer;
    begin
      Result := knob_inputlevel4.KnobPosition;
    end;

    procedure   TFormWren.SetInVolume4( aValue: Integer);
    begin
      knob_inputlevel4.KnobPosition := aValue;
      FInShadow4                    := knob_inputlevel4.AsValue;
    end;

    function    TFormWren.GetOutVolume4: Integer;
    begin
      Result := knob_outputlevel4.KnobPosition;
    end;

    procedure   TFormWren.SetOutVolume4( aValue: Integer);
    begin
      knob_outputlevel4.KnobPosition := aValue;
      FOutShadow4                    := knob_outputlevel4.AsValue;
    end;

//  private

    procedure   TFormWren.StartRendering;
    // Start recording
    const
      FRAME_SIZE = 512;
    var
      WasRunning : Boolean;
      i          : Integer;
      OldPrio    : Integer;
      aLeft      : TSignal;
      aRight     : TSignal;
      aMaxLeft   : TSignal;
      aMaxRight  : TSignal;
      aTimeLimit : TSignal;
    begin
      with SaveDialogWave
      do begin
        WasRunning := FAudioInRunning or FAudioOutRunning;

        if WasRunning
        then begin
          StopAudioIn;
          StopAudioOut;
        end;

        FileName := FRenderFileName;
        if
          Assigned( FSynthPatch) and
          Execute                and
          InputQuery(
            'Please give a maximum duration for recording',
            'Duration in minutes (may be fractional; 0 or blank means: file size limited to 2 GiB)',
            FRenderDuration
          )
        then begin
          StopRendering; // Close any render file that would still be open for whatever reason ...
          FRenderFileName := FileName;
          FRenderFile     := TStereoWaveWriter.Create( FRenderFileName, System_Rate);
          ResetRunTime;
          KnobsLedrendering.Visible := True;
          FOutShadow1 := knob_outputlevel1.AsValue;
          aTimeLimit  := StrToFloatDef( FRenderDuration, 0) * 60 * 1000;

          OldPrio   := PrioLevel;
          PrioLevel := -1;             // Set 'idle' priority level for rendering

          LogFmt( 'Rendering to file %s', [ FRenderFileName]);
          try
            try
              FSynthPatch.FixZippers;
              if ResetOnRender
              then FSynthPatch.Reset;

              while RenderToFile and not ( FAudioInRunning or FAudioOutRunning)
              do begin
                Application.ProcessMessages;
                DeZipper;
                aMaxLeft  := 0;
                aMaxRight := 0;

                for i := 1 to FRAME_SIZE
                do begin
                  DeZipper;
                  if FRenderFile.Size >= 2 * Int64( GIBI)
                  then begin
                    Log( 'Rendering stopped, file size >= 2 GiB');
                    RenderToFile := False;
                    Break;
                  end;

                  with FSynthPatch
                  do begin
                    Tick;
                    aLeft  := FOutVolume1 * Output[ 0];
                    aRight := FOutVolume1 * Output[ 1];
                  end;

                  AddRenderData( aLeft, aRight);
                  aMaxLeft  := Max( aMaxLeft , Abs( aLeft ));
                  aMaxRight := Max( aMaxRight, Abs( aRight));
                  SetVuSampleCount( FRAME_SIZE);
                  FDbMinMaxOut[ 1].Tick( aMaxLeft );
                  FDbMinMaxOut[ 2].Tick( aMaxRight);
                end;

                if aTimeLimit > 0
                then begin
                  if FRenderFile.Duration >= aTimeLimit
                  then RenderToFile := False;
                  LabelRunTime.Caption := FormatDateTime( '"R" hh:mm:ss', ( aTimeLimit - FRenderFile.Duration) / ( 1000 * 60 * 60 * 24), AppLocale);
                  LabelRunTime.Hint    := 'Remaining time for current recording, abort by clicking the stop file render button';
                end
                else begin
                  LabelRunTime.Caption := FormatDateTime( '"D" hh:mm:ss', FRenderFile.Duration / ( 1000 * 60 * 60 * 24), AppLocale);
                  LabelRunTime.Hint    := 'Duration of current recording, abort by clicking the stop file render button';
                end;
              end;
            except
              on E: Exception
              do begin
                LogFmt( 'Rendering stopped with error: %s', [ E.Message]);
                RenderToFile := False;
              end;
            end;
          finally
            PrioLevel := OldPrio;
            StopRendering;
          end;
        end
        else begin
          // File dialog or time dialog was cancelled, do not start a rendering
          // cleanup visuals and restart audio when it was running before.
          RenderToFile              := False;
          KnobsLedrendering.Visible := False;
          if WasRunning
          then begin
            StartAudioIn;
            StartAudioOut;
          end;
        end;
      end;
    end;

    procedure   TFormWren.StopRendering;
    // End a recording
    begin
      KnobsLedrendering.Visible := False;
      FreeAndNil( FRenderFile);
    end;

    procedure   TFormWren.AddRenderData( const aLeft, aRight: TSignal);
    begin
      if Assigned( FRenderFile)
      then FRenderFile.WriteSample( SignalToSample( aLeft) + ( SignalToSample( aRight) shl 16));
    end;


//  private

    procedure   TFormWren.OpenRecentFile( const anIndex: Integer);
    var
      aFileName: string;
    begin
      if
        Assigned( FRecentSourceFiles)         and
        ( anIndex >= 0)                       and
        ( anIndex < FRecentSourceFiles.Count)
      then begin
        aFileName := FRecentSourceFiles[ anIndex];
        if FileExists( aFileName)
        then DoLoadPatch( aFileName, True)
        else begin
          FRecentSourceFiles.Delete( anIndex);
          SetRecentMenuItems;
        end;
      end;
    end;

    procedure   TFormWren.DorecentMenuItemClick( aSender: TObject);
    var
      aMenuItem: TMenuItem;
    begin
      aMenuItem := aSender as TMenuItem;
      if Assigned( aMenuItem)
      then OpenRecentFile( aMenuItem.Tag);
    end;

    procedure   TFormWren.AddRecentMenuItem( anIndex: Integer; const aFileName: string);
    var
      aMenuItem : TMenuItem;
      aHotKey   : Char;
    begin
      if FileExists( aFileName)
      then begin
        aMenuItem := TMenuItem.Create( MenuFileReopen);
        with aMenuItem
        do begin
          if anIndex >= 10
          then aHotKey := Char( anIndex + Ord( 'A'))
          else aHotKey := Char( anIndex + Ord( '0'));
          Caption := Format( '&%s %s', [ aHotKey, aFileName], AppLocale);
          Tag     := anIndex;
          OnClick := DorecentMenuItemClick;
        end;
        MenuFileReopen.Add( aMenuItem);
      end;
    end;

    procedure   TFormWren.RemoveRecentMenuItems;
    begin
      while MenuFileReopen.Count > 0
      do MenuFileReopen[ 0].DisposeOf;
    end;

    procedure   TFormWren.SetRecentMenuItems;
    var
      i : Integer;
    begin
      RemoveRecentMenuItems;
      for i := 0 to FRecentSourceFiles.Count - 1
      do AddrecentMenuItem( i, FRecentSourceFiles[ i]);
    end;

    procedure   TFormWren.SetMostRecentFile( const aFileName: string);
    begin
      FRecentSourceFiles.SetMostRecent( aFileName);
      SetRecentMenuItems;
    end;

    procedure   TFormWren.DoSelectorMenuItemClick( aSender: TObject);
    var
      aSelector : TKnobsSelector;
      aMenuItem : TMenuItem;
    begin
      aMenuItem := aSender as TMenuItem;
      if Assigned( aMenuItem)
      then begin
        aSelector := TKnobsSelector( FPopupSender);
        aSelector.KnobPosition := aMenuItem.Tag;
        aSelector.FixPeers;
      end;
    end;

    procedure   TFormWren.AddSelectorMenuItem( anIndex: Integer; const aName: string);
    var
      aMenuItem : TMenuItem;
      aHotKey   : Char;
    begin
      aMenuItem := TMenuItem.Create( PopupMenuSelector);
      with aMenuItem
      do begin
        if ( anIndex < 10) and ( aName <> '-')
        then aHotKey := Char( anIndex + Ord( '0'))
        else aHotKey := ' ';
        if aName = '-'
        then Caption := '-'
        else Caption := Format( '&%s %s', [ aHotKey, aName], AppLocale);
        Tag        := anIndex;
        ImageIndex := anIndex;
        if aName <> '-'
        then OnClick := DoSelectorMenuItemClick;
      end;
      PopupMenuSelector.Items.Add( aMenuItem);
    end;

    procedure   TFormWren.RemoveSelectorMenuItems;
    var
      i : Integer;
    begin
      with PopupMenuSelector
      do begin
        for i := Items.Count - 1 downto 0
        do Items.Delete( i);
      end;
    end;

const

  sdfs = 'settings';

    procedure   TFormWren.LoadIni;
    var
      L, T, W, H   : Integer;
      anIniFile    : TMemIniFile;
      DoAutoRun    : Boolean;
      WinState     : TWindowState;
      LRate        : Integer;
      ControlWidth : Integer;
      aCount       : Integer;
      i            : Integer;
    begin
      logFmt( 'Loading inifile: %s', [ IniFileName]);

      anIniFile         := TMemIniFile.Create( IniFileName);
      LRate             := KnobsSmallKnob_LightsRate.KnobPosition;
      ControlWidth      := PanelControl.Width;
      FLastControlWidth := ControlWidth;

      with anIniFile
      do begin
        try
          FRecentSourceFiles.LoadFromIni( anIniFile, 'RecentFiles');
          HistoryCount           := FRecentSourceFiles.MaxDepth;

          L                      :=                ReadInteger( sdfs, 'Left'                  ,          Left                 );
          T                      :=                ReadInteger( sdfs, 'Top'                   ,          Top                  );
          W                      :=                ReadInteger( sdfs, 'Width'                 ,          Width                );
          H                      :=                ReadInteger( sdfs, 'Height'                ,          Height               );
          WinState               := TWindowState ( ReadInteger( sdfs, 'WindowState'           , Integer( WindowState        )));
          LogToFile              :=                ReadBool   ( sdfs, 'LogToFile'             ,          LogToFile            );
          SynthName              :=                ReadString ( sdfs, 'SynthName'             ,          SynthName            );
          ControlWidth           :=                ReadInteger( sdfs, 'ControlWidth'          ,          ControlWidth         );
          FLastControlWidth      :=                ReadInteger( sdfs, 'LastControlWidth'      ,          FLastControlWidth    );
          OffsetLeft             :=                ReadInteger( sdfs, 'OffsetLeft'            ,          OffsetLeft           );
          OffsetTop              :=                ReadInteger( sdfs, 'OffsetTop'             ,          OffsetTop            );
          ModuleColor            := TColor       ( ReadInteger( sdfs, 'ModuleColor'           , Integer( ModuleColor        )));
          StandardColors         :=                ReadBool   ( sdfs, 'StandardColors'        ,          StandardColors       );
          ModuleOpacity          :=                ReadInteger( sdfs, 'ModuleOpacity'         ,          ModuleOpacity        );
          PrioLevel              :=                ReadInteger( sdfs, 'PrioLevel'             ,          PrioLevel            );
          ReloadLastPatch        :=                ReadBool   ( sdfs, 'ReloadLastPatch'       ,          ReloadLastPatch      );
          DoAutoRun              :=                ReadBool   ( sdfs, 'AutoRun'               ,          AutoRun              );
          ClearVUOnStop          :=                ReadBool   ( sdfs, 'ClearVUOnStop'         ,          ClearVUOnStop        );
          ClearVUOnRecompile     :=                ReadBool   ( sdfs, 'ClearVUOnRecompile'    ,          ClearVUOnRecompile   );
          FRenderFileName        :=                ReadString ( sdfs, 'RenderFileName'        ,          FRenderFileName      );
          FRenderDuration        :=                ReadString ( sdfs, 'RenderDuration'        ,          FRenderDuration      );
          SourceFileName         :=                ReadString ( sdfs, 'SourceFileName'        ,          SourceFileName       );
          AbsTimeStamps          :=                ReadBool   ( sdfs, 'AbsTimeStamps'         ,          AbsTimeStamps        );
          UseGraphs              :=                ReadBool   ( sdfs, 'UseGraphs'             ,          UseGraphs            );
          GraphStairs            :=                ReadBool   ( sdfs, 'GraphStairs'           ,          GraphStairs          );
          InVolume1              :=                ReadInteger( sdfs, 'InVolume1'             ,          InVolume1            );
          InVolume2              :=                ReadInteger( sdfs, 'InVolume2'             ,          InVolume2            );
          InVolume3              :=                ReadInteger( sdfs, 'InVolume3'             ,          InVolume3            );
          InVolume4              :=                ReadInteger( sdfs, 'InVolume4'             ,          InVolume4            );
          OutVolume1             :=                ReadInteger( sdfs, 'OutVolume1'            ,          OutVolume1           );
          OutVolume2             :=                ReadInteger( sdfs, 'OutVolume2'            ,          OutVolume2           );
          OutVolume3             :=                ReadInteger( sdfs, 'OutVolume3'            ,          OutVolume3           );
          OutVolume4             :=                ReadInteger( sdfs, 'OutVolume4'            ,          OutVolume4           );
          UseConfigHints         :=                ReadBool   ( sdfs, 'UseConfigHints'        ,          UseConfigHints       );
          WireThickness          :=                ReadInteger( sdfs, 'WireThickness'         ,          WireThickness        );
          CurvedLines            :=                ReadBool   ( sdfs, 'CurvedLines'           ,          CurvedLines          );
          ControlMode            := TDistanceMode( ReadInteger( sdfs, 'ControlMode'           , Integer( ControlMode        )));
          LRate                  :=                ReadInteger( sdfs, 'LightsRate'            ,          LRate                );
          SampleRate             :=                ReadInteger( sdfs, 'SampleRate'            ,          Samplerate           );
          WaveDebug              :=                ReadBool   ( sdfs, 'WaveDebug'             ,          WaveDebug            );
          BufferSize             :=                ReadInteger( sdfs, 'BufferSize'            ,          BufferSize           );
          ReferenceA             :=                ReadFloat  ( sdfs, 'ReferenceA'            ,          ReferenceA           );
          NotesPerOctave         :=                ReadFloat  ( sdfs, 'NotesPerOctave'        ,          NotesPerOctave       );
          MiddleNote             :=                ReadFloat  ( sdfs, 'MiddleNote'            ,          MiddleNote           );
          FSelectedAPIID         :=                ReadInteger( sdfs, 'SelectedAPIID'         ,          FSelectedAPIID       );
          FSelectedInputId       := DWORD(         ReadInteger( sDfs, 'SelectedInput'         ,          FSelectedInputId    ));
          FSelectedOutputId      := DWORD(         ReadInteger( sDfs, 'SelectedOutput'        ,          FSelectedOutputId   ));
          FSelectedInputIdPA     := DWORD(         ReadInteger( sDfs, 'SelectedInputPA'       ,          FSelectedInputIdPA  ));
          FSelectedOutputIdPA    := DWORD(         ReadInteger( sDfs, 'SelectedOutputPA'      ,          FSelectedOutputIdPA ));
          NetMidiServer          :=                ReadString ( sdfs, 'NetMidiServer'         ,          NetMidiServer        );
          NetMidiPort            :=                ReadString ( sdfs, 'NetMidiPort'           ,          NetMidiPort          );
          NetMidiAutoConnect     :=                ReadBool   ( sdfs, 'NetMidiAutoConnect'    ,          NetMidiAutoConnect   );
          LogMidi                :=                ReadBool   ( sdfs, 'LogMidi'               ,          LogMidi              );
          LogMidiMsgs            :=                ReadBool   ( sdfs, 'LogMidiMsgs'           ,          LogMidiMsgs          );
          MidiChannel            :=                ReadInteger( sdfs, 'MidiChannel'           ,          MidiChannel          );
          LogOSC                 :=                ReadBool   ( sdfs, 'LogOSC'                ,          LogOSC               );
          LogOSCMsgs             :=                ReadBool   ( sdfs, 'LogOSCMsgs'            ,          LogOSCMsgs           );
          OSCServer              :=                ReadString ( sdfs, 'OSCServer'             ,          OSCServer            );
          OSCPort                :=                ReadString ( sdfs, 'OSCPort'               ,          OSCPort              );
          UseOSC                 :=                ReadBool   ( sdfs, 'UseOSC'                ,          UseOSC               );
          CompilerDebug          :=                ReadBool   ( sdfs, 'CompilerDebug'         ,          CompilerDebug        );
          WarnOnPatchChange      :=                ReadBool   ( sdfs, 'WarnOnPatchChange'     ,          WarnOnPatchChange    );
          WarnChangeOnLoad       :=                ReadBool   ( sdfs, 'WarnChangeOnLoad'      ,          WarnChangeOnLoad     );
          UndoAfterSave          :=                ReadBool   ( sdfs, 'UndoAfterSave'         ,          UndoAfterSave        );
          UndoAfterLoad          :=                ReadBool   ( sdfs, 'UndoAfterLoad'         ,          UndoAfterLoad        );
          UseWheelOnKnobs        :=                ReadBool   ( sdfs, 'UseWheelOnKnobs'       ,          UseWheelOnKnobs      );
          WheelSensitivity       :=                ReadInteger( sdfs, 'WheelSensitivity'      ,          WheelSensitivity     );
          UseUnFocus             :=                ReadBool   ( sdfs, 'UseUnFocus'            ,          UseUnFocus           );
          FPortAudioSelected     :=                ReadBool   ( sdfs, 'PortAudioSelected'     ,          FPortAudioSelected   );
          UsePortAudio           :=                ReadBool   ( sdfs, 'UsePortAudio'          ,          UsePortAudio         );
          ResetOnRender          :=                ReadBool   ( sdfs, 'ResetOnRender'         ,          ResetOnRender        );
          ShowLightsTime         :=                ReadBool   ( sdfs, 'ShowLightsTime'        ,          ShowLightsTime       );
          SynthNameInCaption     :=                ReadBool   ( sdfs, 'SynthNameInCaption'    ,          SynthNameInCaption   );
          PatchChangedInCaption  :=                ReadBool   ( sdfs, 'PatchChangedInCaption' ,          PatchChangedInCaption);
          ProfiledInCaption      :=                ReadBool   ( sdfs, 'ProfiledInCaption'     ,          ProfiledInCaption    );
          AudioStatusInCaption   :=                ReadBool   ( sdfs, 'AudioStatusInCaption'  ,          AudioStatusInCaption );
          ProgramNameInCaption   :=                ReadBool   ( sdfs, 'ProgramNameInCaption'  ,          ProgramNameInCaption );
          FileVersionInCaption   :=                ReadBool   ( sdfs, 'FileVersionInCaption'  ,          FileVersionInCaption );
          PatchNameInCaption     :=                ReadBool   ( sdfs, 'PatchNameInCaption'    ,          PatchNameInCaption   );
          SourceNameInCaption    :=                ReadBool   ( sdfs, 'SourceNameInCaption'   ,          SourceNameInCaption  );
          PortAudioInCaption     :=                ReadBool   ( sdfs, 'PortAudioInCaption'    ,          PortAudioInCaption   );

          if Assigned( TitleFont)
          then begin
            TitleFont.Name  :=         ReadString ( sdfs, 'TitleFont.Name' ,          TitleFont.Name   );
            TitleFont.Size  :=         ReadInteger( sdfs, 'TitleFont.Size' ,          TitleFont.Size   );
            TitleFont.Color := TColor( ReadInteger( sdfs, 'TitleFont.Color', Integer( TitleFont.Color)));
            TitleFont := TitleFont;
          end;
          if Assigned( ModuleFont)
          then begin
            ModuleFont.Name  :=         ReadString ( sdfs, 'ModuleFont.Name' ,          ModuleFont.Name   );
            ModuleFont.Size  :=         ReadInteger( sdfs, 'ModuleFont.Size' ,          ModuleFont.Size   );
            ModuleFont.Color := TColor( ReadInteger( sdfs, 'ModuleFont.Color', Integer( ModuleFont.Color)));
            ModuleFont := ModuleFont;
          end;

          NetMidiCancel;
          OSCApply;

          if ( L < 0) or ( L > Screen.Width  - 20) then L := 0;
          if ( T < 0) or ( T > Screen.Height - 20) then T := 0;
          if W > Screen.Width                      then W := Screen.Width  - 20;
          if H > Screen.Height                     then H := Screen.Height - 20;

          SetBounds( L, T, W, H);
          if WinState = wsMaximized
          then WindowState := wsMaximized;

          PanelControl.Width := ControlWidth;
          FixFoldButton;

          ApplyTuning;

          FCanCreateAudio := True;
          VerifyDevices;
          with FormWaveDeviceSelect
          do begin
            aCount := ReadInteger( sdfs, 'InMaskCount', 0);
            for i := 0 to aCount - 1
            do InMasks[ i] := ReadInteger( sdfs, Format( 'InMask%d', [ i]), i);
            aCount := ReadInteger( sdfs, 'OutMaskCount', 0);
            for i := 0 to aCount - 1
            do OutMasks[ i] := ReadInteger( sdfs, Format( 'OutMask%d', [ i]), i);
          end;
          VerifyDevices;

          if ReloadLastPatch and FileExists( SourceFileName)
          then begin
            LogFmt( 'Reopening last used patch [%s]', [ SourceFileName]);
            DoLoadPatch( SourceFileName, True);
            PatchEditor.ClearUndoRedo;            // This prevents undo to a blank patch when undo after load is in effect
          end
          else begin
            LogFmt( 'Could not find last used patch [%s] - starting a new patch', [ SourceFileName]);
            PatchName      := 'new patch';
            SourceFileName := 'new_patch';
          end;

          AutoRun := DoAutoRun;
          UpdateCaptions;
          KnobsSmallKnob_LightsRate.KnobPosition := LRate;
          LightsRate := KnobsSmallKnob_LightsRate.AsValue;

          FIniLoaded := True;
        finally
          DisposeOf;
        end;
      end;
    end;

    procedure   TFormWren.SaveIni;
    var
      anIniFile    : TMemIniFile;
      LRate        : Integer;
      ControlWidth : Integer;
      aCount       : Integer;
      i            : Integer;
    begin
      CancelTuning;
      anIniFile    := TMemIniFile.Create( IniFileName);
      LRate        := KnobsSmallKnob_LightsRate.KnobPosition;
      ControlWidth := PanelControl.Width;
      with anIniFile
      do begin
        try
          EraseSection( sdfs);
          WriteInteger( sdfs, 'Left'                  ,          Left                 );
          WriteInteger( sdfs, 'Top'                   ,          Top                  );
          WriteInteger( sdfs, 'Width'                 ,          Width                );
          WriteInteger( sdfs, 'Height'                ,          Height               );
          WriteInteger( sdfs, 'WindowState'           , Integer( WindowState         ));
          WriteBool   ( sdfs, 'LogToFile'             ,          LogToFile            );
          WriteString ( sdfs, 'SynthName'             ,          SynthName            );
          WriteInteger( sdfs, 'ControlWidth'          ,          ControlWidth         );
          WriteInteger( sdfs, 'LastControlWidth'      ,          FLastControlWidth    );
          WriteInteger( sdfs, 'PrioLevel'             ,          PrioLevel            );
          WriteInteger( sdfs, 'OffsetLeft'            ,          OffsetLeft           );
          WriteInteger( sdfs, 'OffsetTop'             ,          OffsetTop            );
          WriteInteger( sdfs, 'ModuleColor'           , Integer( ModuleColor         ));
          WriteBool   ( sdfs, 'StandardColors'        ,          StandardColors       );
          WriteInteger( sdfs, 'ModuleOpacity'         ,          ModuleOpacity        );
          WriteBool   ( sdfs, 'ReloadLastPatch'       ,          ReloadLastPatch      );
          WriteBool   ( sdfs, 'AutoRun'               ,          AutoRun              );
          WriteBool   ( sdfs, 'ClearVUOnStop'         ,          ClearVUOnStop        );
          WriteBool   ( sdfs, 'ClearVUOnRecompile'    ,          ClearVUOnRecompile   );
          WriteBool   ( sdfs, 'RenderToFile'          ,          RenderToFile         );
          WriteString ( sdfs, 'RenderFileName'        ,          FRenderFileName      );
          WriteString ( sdfs, 'RenderDuration'        ,          FRenderDuration      );
          WriteString ( sdfs, 'SourceFileName'        ,          SourceFileName       );
          WriteBool   ( sdfs, 'AbsTimeStamps'         ,          AbsTimeStamps        );
          WriteBool   ( sdfs, 'UseGraphs'             ,          UseGraphs            );
          WriteBool   ( sdfs, 'GraphStairs'           ,          GraphStairs          );
          WriteFloat  ( sdfs, 'InVolume1'             ,          InVolume1            );
          WriteFloat  ( sdfs, 'InVolume2'             ,          InVolume2            );
          WriteFloat  ( sdfs, 'InVolume3'             ,          InVolume3            );
          WriteFloat  ( sdfs, 'InVolume4'             ,          InVolume4            );
          WriteFloat  ( sdfs, 'OutVolume1'            ,          OutVolume1           );
          WriteFloat  ( sdfs, 'OutVolume2'            ,          OutVolume2           );
          WriteFloat  ( sdfs, 'OutVolume3'            ,          OutVolume3           );
          WriteFloat  ( sdfs, 'OutVolume4'            ,          OutVolume4           );
          WriteBool   ( sdfs, 'UseConfigHints'        ,          UseConfigHints       );
          WriteInteger( sdfs, 'WireThickness'         ,          WireThickness        );
          WriteBool   ( sdfs, 'CurvedLines'           ,          CurvedLines          );
          WriteInteger( sdfs, 'ControlMode'           , Integer( ControlMode         ));
          WriteInteger( sdfs, 'LightsRate'            ,          LRate                );
          WriteInteger( sdfs, 'SampleRate'            ,          Samplerate           );
          WriteBool   ( sdfs, 'WaveDebug'             ,          WaveDebug            );
          WriteInteger( sdfs, 'BufferSize'            ,          BufferSize           );
          WriteFloat  ( sdfs, 'ReferenceA'            ,          ReferenceA           );
          WriteFloat  ( sdfs, 'NotesPerOctave'        ,          NotesPerOctave       );
          WriteFloat  ( sdfs, 'MiddleNote'            ,          MiddleNote           );
          WriteInteger( sdfs, 'SelectedAPIID'         ,          FSelectedAPIID       );
          WriteInteger( sDfs, 'SelectedInput'         , Integer( FSelectedInputId    ));
          WriteInteger( sDfs, 'SelectedOutput'        , Integer( FSelectedOutputId   ));
          WriteInteger( sDfs, 'SelectedInputPA'       , Integer( FSelectedInputIdPA  ));
          WriteInteger( sDfs, 'SelectedOutputPA'      , Integer( FSelectedOutputIdPA ));
          WriteString ( sdfs, 'NetMidiServer'         ,          NetMidiServer        );
          WriteString ( sdfs, 'NetMidiPort'           ,          NetMidiPort          );
          WriteBool   ( sdfs, 'NetMidiAutoConnect'    ,          NetMidiAutoConnect   );
          WriteBool   ( sdfs, 'LogMidi'               ,          LogMidi              );
          WriteBool   ( sdfs, 'LogMidiMsgs'           ,          LogMidiMsgs          );
          WriteInteger( sdfs, 'MidiChannel'           ,          MidiChannel          );
          WriteBool   ( sdfs, 'LogOSC'                ,          LogOSC               );
          WriteBool   ( sdfs, 'LogOSCMsgs'            ,          LogOSCMsgs           );
          WriteString ( sdfs, 'OSCServer'             ,          OSCServer            );
          WriteString ( sdfs, 'OSCPort'               ,          OSCPort              );
          WriteBool   ( sdfs, 'UseOSC'                ,          UseOSC               );
          WriteBool   ( sdfs, 'CompilerDebug'         ,          CompilerDebug        );
          WriteBool   ( sdfs, 'WarnOnPatchChange'     ,          WarnOnPatchChange    );
          WriteBool   ( sdfs, 'WarnChangeOnLoad'      ,          WarnChangeOnLoad     );
          WriteBool   ( sdfs, 'UndoAfterSave'         ,          UndoAfterSave        );
          WriteBool   ( sdfs, 'UndoAfterLoad'         ,          UndoAfterLoad        );
          WriteBool   ( sdfs, 'UseWheelOnKnobs'       ,          UseWheelOnKnobs      );
          WriteInteger( sdfs, 'WheelSensitivity'      ,          WheelSensitivity     );
          WriteBool   ( sdfs, 'UseUnFocus'            ,          UseUnFocus           );
          WriteBool   ( sdfs, 'PortAudioSelected'     ,          FPortAudioSelected   );
          WriteBool   ( sdfs, 'UsePortAudio'          ,          UsePortAudio         );
          WriteBool   ( sdfs, 'ResetOnRender'         ,          ResetOnRender        );
          WriteBool   ( sdfs, 'ShowLightsTime'        ,          ShowLightsTime       );
          WriteBool   ( sdfs, 'SynthNameInCaption'    ,          SynthNameInCaption   );
          WriteBool   ( sdfs, 'PatchChangedInCaption' ,          PatchChangedInCaption);
          WriteBool   ( sdfs, 'ProfiledInCaption'     ,          ProfiledInCaption    );
          WriteBool   ( sdfs, 'AudioStatusInCaption'  ,          AudioStatusInCaption );
          WriteBool   ( sdfs, 'ProgramNameInCaption'  ,          ProgramNameInCaption );
          WriteBool   ( sdfs, 'FileVersionInCaption'  ,          FileVersionInCaption );
          WriteBool   ( sdfs, 'PatchNameInCaption'    ,          PatchNameInCaption   );
          WriteBool   ( sdfs, 'SourceNameInCaption'   ,          SourceNameInCaption  );
          WriteBool   ( sdfs, 'PortAudioInCaption'    ,          PortAudioInCaption   );

          if Assigned( TitleFont)
          then begin
            WriteString ( sdfs, 'TitleFont.Name' ,          TitleFont.Name  );
            WriteInteger( sdfs, 'TitleFont.Size' ,          TitleFont.Size  );
            WriteInteger( sdfs, 'TitleFont.Color', Integer( TitleFont.Color));
          end;
          if Assigned( ModuleFont)
          then begin
            WriteString ( sdfs, 'ModuleFont.Name' ,          ModuleFont.Name  );
            WriteInteger( sdfs, 'ModuleFont.Size' ,          ModuleFont.Size  );
            WriteInteger( sdfs, 'ModuleFont.Color', Integer( ModuleFont.Color));
          end;

          with FormWaveDeviceSelect
          do begin
            aCount := InMaskCount;
            WriteInteger( sdfs, 'InMaskCount', aCount);
            for i := 0 to aCount - 1
            do WriteInteger( sdfs, Format( 'InMask%d', [ i]), InMasks[ i]);
            aCount := OutMaskCount;
            WriteInteger( sdfs, 'OutMaskCount', aCount);
            for i := 0 to aCount - 1
            do WriteInteger( sdfs, Format( 'OutMask%d', [ i]), OutMasks[ i]);
          end;

          FRecentSourceFiles.SaveToIni( anIniFile, 'RecentFiles');
        finally
          UpdateFile;
          DisposeOf;
        end;
      end;
    end;

    procedure   TFormWren.ShowHelp;
    var
      aHelpIndex : string;
      aModule    : TKnobsCustomModule;
      anURL      : string;
    begin
      aHelpIndex := '';
      if Assigned( PatchEditor)
      then begin
        aModule := PatchEditor.FindFirstSelectedModule;
        if Assigned( aModule)
        then aHelpIndex := Format( '#%d', [ aModule.ModuleType]);
      end;
      if MustMakeDocs
      then begin
        if MessageDlg(
          Format(
            'I''d need to make some folders and files for that inside my application folder:'^M^M'%s,'^M^M'is that okay?',
            [ ApplicationPath],
            AppLocale
          ),
          mtInformation,
          [ mbYes, mbNo],
          0
        ) = mrYes
        then MakeDocs( DocsPath);
      end;
      if FileExists( DocsPath + '\modules.html')
      then begin
        anURL := Format( '"file:///%s/modules.html%s"', [ DocsPath, aHelpIndex]);
        anURL := StringReplace( anURL, '\', '/', [ rfReplaceAll]);
        if not BrowseURL( anURL)
        then MessageDlg( Format( 'Could not open the docs [%s] in the default web browser ...', [ anURL], AppLocale), mtError, [ mbOK], 0);
      end
      else MessageDlg( Format( 'Could not create docs in [%s]', [ DocsPath], AppLocale), mtError, [ mbOK], 0);
    end;

    function    TFormWren.FixHtmlTokens( const S: string): string;
    begin
      Result := ReplaceText( S     , '&quot;', '"' );
      Result := ReplaceText( Result, '&apos;', '''');
      Result := ReplaceText( Result, '&gt;',   '>' );
      Result := ReplaceText( Result, '&lt;',   '<' );
      Result := ReplaceText( Result, '&amp;',  '&' );
    end;

    procedure   TFormWren.ShowModuleHelp( aModule: TKnobsCustomModule);
    begin
      ShowMessage( FixHtmlTokens( aModule.Docs.GetText));
    end;

    function    TFormWren.MustMakeDocs: Boolean;
    begin
      if not FileExists( DocsPath + '\modules.html')
      then Result := True
      else begin
        if DirectoryExists( DocsPath + '\images')
        then begin
          if FileExists( Format( '%s\images\%s', [ DocsPath, GetFileVersion], AppLocale))
          then Result := False
          else Result := True;
        end
        else Result := True;
      end;
    end;

    procedure   TFormWren.MakeDocs( const aFolder : string);
    const
      Images = '\images';
    var
      aFileNames   : TStrings;
      aFileName    : string;
      aFile        : TextFile;
      aFileVersion : string;
      aVersion     : string;
    begin
      aFileVersion := GetFileVersion;

      if not DirectoryExists( aFolder)
      then begin
        ForceDirectories( aFolder);
      end;
      if not DirectoryExists( aFolder + Images)
      then begin
        ForceDirectories( aFolder + Images);
      end;

      aFileNames := CreateFileNames( aFolder + Images, '*.*');
      if Assigned( aFileNames)
      then begin
        try
          for aFileName in aFileNames
          do DeleteFile( aFileName);
        finally
          aFileNames.DisposeOf;
        end;
      end;

      FormStore.Show;
      try
        FormStore.Document( aFolder, Images, aFileVersion);
      finally
        FormStore.Hide;
      end;

      aVersion := Format( '%s\%s\%s', [ aFolder, Images, aFileVersion], AppLocale);
      AssignFile( aFile, aVersion);
      Rewrite( aFile);
      try
        WriteLn( aFile, 'this file is for WREN documentation version checking');
        WriteLn( aFile, aVersion);
        WriteLn( aFile, 'when the path above is not my actual position and name, just delete me please.');
      finally
        CloseFile( aFile);
      end;
    end;

    procedure   TFormWren.ShowAcknowledgements;
    const
      URL = BaseURL + 'index.php#acknowledgements';
    begin
      ShellExecute(
        Handle,
        Nil,
        PChar( URL),
        Nil,
        Nil,
        SW_SHOWNORMAL
      );
    end;

    procedure   TFormWren.CheckForUpdates;
    const
      URL = BaseURL + 'index.php';
    begin
      ShellExecute(
        Handle,
        Nil,
        PChar( Format( '%s?user_version=%s', [ URL, GetFileVersion])),
        Nil,
        Nil,
        SW_SHOWNORMAL
      );
    end;


//  private

    function    TFormWren.LogTimeStamp: string;
    begin
      if AbsTimeStamps
      then Result := FormatDateTime( 'yyyy-mm-dd hh:nn:ss:zzz', Now, AppLocale)  // Current PC time
      else Result := GetDebugTimeStr;                                            // Time since program start
    end;

    procedure   TFormWren.WriteFileLog( const aMsg: string);
    var
      aFile : TextFile;
    begin
      try
        AssignFile( aFile, LogFileName);
        if FileExists( LogFileName)
        then Append ( aFile)
        else Rewrite( aFile);
        try
          WriteLn( aFile, aMsg);
        finally
          CloseFile( aFile);
        end;
      except
        on E: Exception
        do KilledException( E);
      end;
    end;

    procedure   TFormWren.Log( const aMsg: string; TimeStamped: Boolean = True); // overloadl
    var
      S : string;
    begin
      if TimeStamped
      then S := Format( '%s %s', [ LogTimeStamp, aMsg], AppLocale)
      else S := aMsg;

      if LogToFile
      then WriteFileLog( S);

      if CanLog                                                        // We can not log before the form is constructed
      then MemoDebug.Lines.Add( S)
      else begin
        if not Assigned( FSavedLogs)                                   // When we can not log logs are stored on a string
        then FSavedLogs := TStringList.Create;                         // list to be logged later on.
        FSavedLogs.Add( S);
      end;
    end;

    procedure   TFormWren.Log( const aMsgs: TStrings; DoClear: Boolean); // overload;
    var
      S : string;
    begin
      if Assigned( aMsgs)
      then begin
        for S in aMsgs
        do Log( S, False);                                             // No TimeStamps - those were added before.
        if DoClear
        then aMsgs.Clear;
      end;
    end;

    procedure   TFormWren.LogFmt( const aFmt: string; const anArgs: array of const);
    begin
      Log( Format( aFmt, anArgs, AppLocale));
    end;

    procedure   TFormWren.MidiLog( const aMsg: string);
    begin
      if LogMidi
      then LogFmt( 'NET MIDI %s', [ aMsg]);
    end;

    procedure   TFormWren.MidiLogFmt( const aFmt: string; const anArgs: array of const);
    begin
      MidiLog( Format( aFmt, anArgs));
    end;

    procedure   TFormWren.MidiMsgLog( const aMsg: string);
    begin
      if LogMidiMsgs
      then LogFmt( 'NET MIDI msg %s', [ aMsg]);
    end;

    procedure   TFormWren.MidiMsgLogFmt( const aFmt: string; const anArgs: array of const);
    begin
      MidiMsgLog( Format( aFmt, anArgs));
    end;

    procedure   TFormWren.OSCLog( const aMsg: string);
    begin
      if LogOSC
      then LogFmt( 'OSC %s', [ aMsg]);
    end;

    procedure   TFormWren.OSCLogFmt( const aFmt: string; const anArgs: array of const);
    begin
      OSCLog( Format( aFmt, anArgs));
    end;

    procedure   TFormWren.OSCMsgLog( const aMsg: string);
    begin
      if LogOSCMsgs
      then LogFmt( 'OSC msg %s', [ aMsg]);
    end;

    procedure   TFormWren.OSCMsgLogFmt( const aFmt: string; const anArgs: array of const);
    begin
      OSCMsgLog( Format( aFmt, anArgs));
    end;

    procedure   TFormWren.ViewEditor;
    begin
      PageControlMain.ActivePage := TabSheetEditor;
    end;

    procedure   TFormWren.ViewDebug;
    begin
      PageControlMain.ActivePage := TabSheetDebug;
    end;

    procedure   TFormWren.ViewSettings;
    begin
      PageControlMain.ActivePage := TabSheetSettings;
    end;

    procedure   TFormWren.ViewGraphs;
    begin
      if UseGraphs
      then begin
        PageControlMain.ActivePage := TabSheetGraphs;
      end;
    end;

    procedure   TFormWren.ClearLog;
    begin
      MemoDebug.Clear;
    end;

    procedure   TFormWren.ClearGraphs;
    var
      i : Integer;
    begin
      for i := 0 to Length( FChartSeries) - 1
      do FChartSeries[ i].Clear;
    end;

    procedure   TFormWren.BuildGraphs;
    const
      Colors : array[ 0 .. 7] of TColor = ( clRed, clBlue, clGreen, clPurple, clLime, clNavy, clBlack, clGray);
    var
      aChartCount : Integer;
      i           : Integer;
      aSeries     : TChartSeries;
    begin

      while ChartDebug.SeriesList.Count > 0
      do begin
        aSeries := ChartDebug.SeriesList[ ChartDebug.SeriesList.Count - 1];
        ChartDebug.RemoveSeries( aSeries);
        aSeries.DisposeOf;
      end;

      if UseGraphs
      then begin
        // RemoveAllSeries does not work ... well, it frees them not ... do it manually
        if Assigned( FSynthPatch)
        then begin
          aChartCount := FSynthPatch.OutputCount;
          SetLength( FChartSeries, aChartCount);
          for i := 0 to aChartCount - 1
          do begin
            FChartSeries[ i]                := TFastLineSeries.Create( ChartDebug);
            FChartSeries[ i].Name           := Format( 'out_%d', [ i], AppLocale);
            FChartSeries[ i].Stairs         := GraphStairs;
            FChartSeries[ i].InvertedStairs := True;
            FChartSeries[ i].LinePen.Width  := 2;
            FChartSeries[ i].Active         := True;
            FChartSeries[ i].Visible        := True;
            if i < Length( Colors)
            then FChartSeries[ i].Color := Colors[ i];
            ChartDebug.AddSeries( FChartSeries[ i]);
          end;
        end;
      end;
    end;

    procedure   TFormWren.ShowPatch;
    var
      S : string;
    begin
      S := '';
      if Assigned( FSynthPatch)
      then begin
        FSynthPatch.Save( 0, S);
        LogFmt( '%s', [ S]);
      end
      else Log( 'FSynthPatch not assigned, can not dump patch')
    end;

    procedure   TFormWren.ProfilePatch;
    var
      aProfile : TStringList;
      aPath    : string;
    begin
      CollectSmallValues;

      if not HAS_PATCH_PROFILER
      then Exit;

      if Assigned( FSynthPatch)
      then begin
        aProfile := FSynthPatch.CreateProfileHtml;
        if Assigned( aProfile)
        then begin
          try
            aPath := IncludeTrailingPathDelimiter( IncludeTrailingPathDelimiter( ApplicationPath) + 'data');
            if not DirectoryExists( aPath)
            then ForceDirectories( aPath);
            aProfile.SaveToFile( aPath + 'profile.html');
            if FileExists( aPath + 'profile.html')
            then begin
              ShellExecute(
                Handle,
                Nil,
                PChar( Format( 'file://%s', [ aPath + 'profile.html'])),
                Nil,
                Nil,
                SW_SHOWNORMAL
              );
            end
          finally
            FreeAndNil( aProfile);
          end;
        end;
      end
      else Log( 'No synth patch avaialable, can not profile');
    end;

    procedure   TFormWren.FixModuleStatics;
    // This is to fix controls with a dynamic step count. These are set from here with a stringlist for their captions,
    // setting the string list will change the step count. At load time of a patch this information is not available yet
    // so there is an additional clutch, the DynamicStepCount property which should be set to true for the
    // ValuedControls handled here.
    begin
      if Assigned( PatchEditor)
      then begin
        try
          PatchEditor.VisitControls(  510, TKnobsSelector, 'talkie_bank'             , FixTalkieStatics    , nil);
          PatchEditor.VisitControls(  709, TKnobsSelector, 'rndgranulator_envtype'   , FixGranulatorStatics, nil);
          PatchEditor.VisitControls(  710, TKnobsSelector, 'granulator_envtype'      , FixGranulatorStatics, nil);
          PatchEditor.VisitControls(  711, TKnobsSelector, 'simplegranulator_envtype', FixGranulatorStatics, nil);
          PatchEditor.VisitControls( 1208, TKnobsSelector, 'seqrandom_scale'         , FixSeqRandomStatics , nil);
        except
          on E: Exception
          do KilledException( E);
        end;
      end;
    end;

    function    TFormWren.FixTalkieStatics( const aControl: TControl; aControlClass: TControlClass; const aUserData: TObject): Boolean;
    var
      aSelector   : TKnobsSelector;
      aPhraseSets : TTalkiePhraseSets;
      aStringList : TStringList;
    begin
      Result      := True;
      aStringList := nil;
      aSelector   := aControl as TKnobsSelector;
      aPhraseSets := TalkiePhraseSets;
      try
        if Assigned( aPhraseSets)
        then aStringList := aPhraseSets.CreateBankNames;

        if not Assigned( aStringList)
        then begin
          aStringList := TStringList.Create;
          aStringList.Add( 'words.lpc missing?');
        end;

        if Assigned( aStringList)
        then aSelector.Captions := aStringList;
      finally
        FreeAndNil( aStringList);
      end;
    end;

    function    TFormWren.FixGranulatorStatics( const aControl: TControl; aControlClass: TControlClass; const aUserData: TObject): Boolean;
    var
      aSelector   : TKnobsSelector;
      aStringList : TStringList;
    begin
      Result    := True;
      aSelector := aControl as TKnobsSelector;

      if Assigned( aSelector)
      then begin
        aStringList := CreateEnvelopeTypeNames;
        try
          aSelector.Captions := aStringList;
        finally
          FreeAndNil( aStringList);
        end;
      end;
    end;

    function    TFormWren.FixSeqRandomStatics( const aControl: TControl; aControlClass: TControlClass; const aUserData: TObject): Boolean;
    var
      aSelector   : TKnobsSelector;
      aStringList : TStringList;
    begin
      Result      := True;
      aSelector   := aControl as TKnobsSelector;
      aStringList := SystemScales.CreateScaleNames;

      try
        if Assigned( aStringList)
        then aSelector.Captions := aStringList;
      finally
        FreeAndNil( aStringList);
      end;
    end;

    function    TFormWren.ChangeSynthPatch( const aSynthPatch: TSynthPatch): Boolean;
    var
      OldSynth : TSynthPatch;
    begin
      Result := False;
      if Assigned( aSynthPatch)
      then begin
        if not aSynthPatch.IsSamePatch( FSynthPatch) // Do not change the patch if it's 'the same' .. equivalent ...
        then begin
          PatchEditor.BlockScreenUpdates;
          try
            OldSynth := FSynthPatch;
            if Assigned( OldSynth)
            then begin
              OldSynth.OnSendMidi      := nil;
              OldSynth.OnSendOSCString := nil;
            end;

            aSynthPatch.GatherLights( '', DoLights);
            aSynthPatch.GatherData  ( '', DoData  );
            aSynthPatch.GatherXYData( '', DoXYData);
            aSynthPatch.GatherInfo  ( '', DoInfo  );
            aSynthPatch.OnSendMidi      := DoMidiTxMessage;
            aSynthPatch.OnSendOSCString := DoSendOSCBytes;
            aSynthPatch.FixZippers;

            OldSynth := AtomicExchange( Pointer( FSynthPatch), Pointer( aSynthPatch));

            PatchName := FSynthPatch.Name;
            PatchEditor.FixAllSynthParams;
            BuildGraphs;

            if Assigned( OldSynth)
            then FreeAndNil( OldSynth);

            Result := True;
          finally
            PatchEditor.UnblockScreenUpdates;
          end;
        end;
      end
      else ViewDebug;
    end;

    procedure   TFormWren.ExecutePatch;
    begin
      if Assigned( FSynthPatch)
      then FSynthPatch.Tick;
      if not ( FAudioInRunning and FAudioOutRunning) and UseGraphs
      then ChartOoutputs;
    end;

    procedure   TFormWren.ChartOutput( anIndex: Integer; aValue: TSignal);
    begin
      if Assigned( FSynthPatch)
      then begin
        if FChartSeries[ anIndex].Count > 409600
        then FChartSeries[ anIndex].Clear;
        FChartSeries[ anIndex].AddXY( SampleCountToTime( FSynthPatch.SamplesFast) * 1000, anIndex + aValue); // in ms
      end;
    end;

    procedure   TFormWren.ChartOoutputs;
    var
      i : Integer;
      V : TSignal;
    begin
      if Assigned( FSynthPatch)
      then begin
        for i := 0 to Length( FChartSeries) - 1
        do begin
          V := FSynthPatch.Output[ i];
          if not IsNan( V)
          then ChartOutput( i, Clip( V, -256.0, 256.0));
        end;
      end;
    end;

    procedure   TFormWren.DebugRunStop;
    const
      FRAME_SIZE = 512;
    var
      i : Integer;
    begin
      if FAudioInRunning or FAudioOutRunning
      then Log( 'can not do a debug run while real time audio generation is on')
      else begin
        if FDebugRunning
        then begin
          FDebugRunning          := False;
          BitBtnDebugRun.Caption := 'debug Run';
          Log( 'DebugRun stopped');
        end
        else begin
          Assert( Assigned( FSynthPatch), 'FSynthPatch should be assigned here');
          FDebugRunning          := True;
          BitBtnDebugRun.Caption := 'debug Stop';
          Log( 'DebugRun started');
          try
            while FDebugRunning and not ( FAudioInRunning or FAudioOutRunning)
            do begin
              Application.ProcessMessages;
              for i := 1 to FRAME_SIZE
              do ExecutePatch;
            end;
          except
            on E: Exception
            do KilledException( E);
          end;
          FDebugRunning := False;
          BitBtnDebugRun.Caption := 'debug Run';
        end;
      end;
    end;

    procedure   TFormWren.FixLocalWheelSettings;
    var
      i : Integer;
    begin
      for i := 0 to ComponentCount - 1
      do begin
        if Components[ i] is TKnobsKnob
        then begin
          TKnobsKnob( Components[ i]).WheelSupport     := UseWheelOnKnobs;
          TKnobsKnob( Components[ i]).WheelSensitivity := WheelSensitivity;
        end;
      end;
    end;

//   private

    procedure   TFormWren.DeZipper;
    begin
      FOutVolume1 := ( FOutShadow1 + FOutVolume1 * 1023) / 1024;
      FInVolume1  := ( FInShadow1  + FInVolume1  * 1023) / 1024;
      FOutVolume2 := ( FOutShadow2 + FOutVolume2 * 1023) / 1024;
      FInVolume2  := ( FInShadow2  + FInVolume2  * 1023) / 1024;
      FOutVolume3 := ( FOutShadow3 + FOutVolume3 * 1023) / 1024;
      FInVolume3  := ( FInShadow3  + FInVolume3  * 1023) / 1024;
      FOutVolume4 := ( FOutShadow4 + FOutVolume4 * 1023) / 1024;
      FInVolume4  := ( FInShadow4  + FInVolume4  * 1023) / 1024;
    end;

    procedure   TFormWren.UpdateStats;
    var
      anError : TPaError;
    begin
      TickCPUCounter;

      if FProcessTime > 0 // ProcessTime < 0 => makes no sense
      then LabelCpuUsage.Caption := Format( 'CPU: %.1f%%', [ FProcessTime * CpuCount], AppLocale);

      UpdateDbLabels;
      ShowOverUnderFlows;

      if FAudioInRunning and FAudioOutRunning
      then ShowRunTime;

      if RenderToFile
      then begin
        with KnobsLedrendering
        do Active := not Active;
      end;

      if FRequestAsioPanel
      then begin
        if not FAudioInRunning and not FAudioOutRunning
        then begin
          FRequestAsioPanel := False;
          anError           := PaAsio_ShowControlPanel( FAsioPanelDevice, FAsioPanelPointer);
          if anError = paNoError
          then Log( 'ASIO panel opened')
          else begin
            ViewDebug;
            LogFmt( 'Error opening ASIO panel: "%s"', [ string( Pa_GetErrorText( anError))]);
          end;
          if FPanelAudioWasRunning
          then begin
            FreeDevices;
            FPanelAudioWasRunning := False;
            FRequestAudioRestart  := True;
            CreateDevices;
          end;
        end;
      end;

      if FRequestAudioStart
      then begin
        if not FAudioInRunning and not FAudioOutRunning
        then begin
          FreeDevices;
          FRequestAudioStart   := False;
          FRequestAudioRestart := True;
          CreateDevices;
        end;
      end;

      if FRequestAudioRestart
      then begin
        FRequestAudioRestart := False;
        if not FAudioInRunning or not FAudioOutRunning
        then StartStopAudioIo;
      end;

      // if Assigned( PatchEditor)
      // then LabelPaintCount.Caption := Format( 'paint count: %d %d', [ PatchEditor.PaintCount, PatchEditor.PaintClocks div 1000]);
    end;

    procedure   TFormWren.UpdateLights;
    const
      DECAY = 0.001;
    var
      aClocks : Int64;
      aTime   : TSignal;
    begin
      if Assigned( FSynthPatch) and LightsActive
      then begin
        aClocks := FSynthPatch.SamplesFast;

        FUpdateCounter := ( FUpdateCounter + 1) and 1;
        case FUpdateCounter of
          0 : FSynthPatch.GatherLights( '', DoLights);
          1 : begin
              FSynthPatch.GatherData  ( '', DoData  );
              FSynthPatch.GatherXYData( '', DoXYData);
              FSynthPatch.GatherInfo  ( '', DoInfo  );
            end;
        end;
        UpdateVUMeters;

        aTime := (( FSynthPatch.SamplesFast - aClocks) * System_Rate_Rec) * 1000;
        if aTime > FLightsTime
        then FLightsTime := aTime
        else FLightsTime := DECAY * ( aTime - FlightsTime) + FLightsTime;
      end;
    end;

    procedure   TFormWren.SetVuSampleCount( aCount: Integer);
    var
      aCallRate : TSignal;
      i         : Integer;
    begin
      if ( aCount > 0) and (( aCount <> FVuSampleCount) or ( System_Rate <> FVuSystemRate))
      then begin
        FVuSampleCount := aCount;
        FVuSystemRate  := System_Rate;
        aCallRate      := FVuSystemRate / FVuSampleCount;
        for i := Low( FDbMinMaxIn) to High( FDbMinMaxIn)
        do FDbMinMaxIn[ i].CallRate := aCallRate;
        for i := Low( FDbMinMaxOut) to High( FDbMinMaxOut)
        do FDbMinMaxOut[ i].CallRate := aCallRate;
      end;
    end;

    procedure   TFormWren.UpdateVUMeters;

      procedure ShowVU( const aVU: TKnobsIndicatorBar; const aDbMinMax: TDbMinMax);
      begin
        aVU.     Value := aDbMinMax.ValueRanged( 0, aVU.IndicatorCount);
        aVU.ValeyValue := aDbMinMax.ValeyRanged( 0, aVU.IndicatorCount);
        aVU. PeakValue := aDbMinMax.PeakRanged ( 0, aVU.IndicatorCount);
      end;

    begin
      ShowVU( IndicatorBarVolumeInLeft1  , FDbMinMaxIn [ 1]);
      ShowVU( IndicatorBarVolumeInRight1 , FDbMinMaxIn [ 2]);
      ShowVU( IndicatorBarVolumeInLeft2  , FDbMinMaxIn [ 3]);
      ShowVU( IndicatorBarVolumeInRight2 , FDbMinMaxIn [ 4]);
      ShowVU( IndicatorBarVolumeInLeft3  , FDbMinMaxIn [ 5]);
      ShowVU( IndicatorBarVolumeInRight3 , FDbMinMaxIn [ 6]);
      ShowVU( IndicatorBarVolumeInLeft4  , FDbMinMaxIn [ 7]);
      ShowVU( IndicatorBarVolumeInRight4 , FDbMinMaxIn [ 8]);

      ShowVU( IndicatorBarVolumeOutLeft1 , FDbMinMaxOut[ 1]);
      ShowVU( IndicatorBarVolumeOutRight1, FDbMinMaxOut[ 2]);
      ShowVU( IndicatorBarVolumeOutLeft2 , FDbMinMaxOut[ 3]);
      ShowVU( IndicatorBarVolumeOutRight2, FDbMinMaxOut[ 4]);
      ShowVU( IndicatorBarVolumeOutLeft3 , FDbMinMaxOut[ 5]);
      ShowVU( IndicatorBarVolumeOutRight3, FDbMinMaxOut[ 6]);
      ShowVU( IndicatorBarVolumeOutLeft4 , FDbMinMaxOut[ 7]);
      ShowVU( IndicatorBarVolumeOutRight4, FDbMinMaxOut[ 8]);
    end;

    procedure   TFormWren.UpdateDbLabels;

      procedure FixDbLabels( const aDbMinMaxL, aDbMinMaxR : TDbMinMax; aLabelPeak, aLabelValey, aLabelAbsMax, aLabelAbsMin: TLabel);
      var
        aPeak    : TSignal;
        aValey   : TSignal;
        anAbsMax : TSignal;
        anAbsMin : TSignal;
      begin
        aPeak    := Max( aDbMinMaxL.Peak  , aDbMinMaxR.Peak  );
        aValey   := Min( aDbMinMaxL.Valey , aDbMinMaxR.Valey );
        anAbsMax := Max( aDbMinMaxL.AbsMax, aDbMinMaxR.AbsMax);
        anAbsMin := Min( aDbMinMaxL.AbsMin, aDbMinMaxR.AbsMin);

        if   aPeak    <= MIN_DB                           then aLabelPeak  .Caption := '---' else aLabelPeak  .Caption := Format( '%.1f dB', [ aPeak   ], AppLocale);
        if   aValey   <= MIN_DB                           then aLabelValey .Caption := '---' else aLabelValey .Caption := Format( '%.1f dB', [ aValey  ], AppLocale);
        if   anAbsMax <= MIN_DB                           then aLabelAbsMax.Caption := '---' else aLabelAbsMax.Caption := Format( '%.1f dB', [ anAbsMax], AppLocale);
        if ( anAbsMin >= MAX_DB) or ( anAbsMin <= MIN_DB) then aLabelAbsMin.Caption := '---' else aLabelAbsMin.Caption := Format( '%.1f dB', [ anAbsMin], AppLocale);

        if aPeak    > 0 then aLabelPeak  .Font.Color := clYellow else aLabelPeak  .Font.Color := clBlack;
        if anAbsMax > 0 then aLabelAbsMax.Font.Color := clYellow else aLabelAbsMax.Font.Color := clBlack;
      end;

    begin
      FixDbLabels( FDbMinMaxIn [ 1], FDbMinMaxIn [ 2], LabeldBInPeak1 , LabeldBInValey1 , LabeldBInMax1 , LabeldBInMin1 );
      FixDbLabels( FDbMinMaxIn [ 3], FDbMinMaxIn [ 4], LabeldBInPeak2 , LabeldBInValey2 , LabeldBInMax2 , LabeldBInMin2 );
      FixDbLabels( FDbMinMaxIn [ 5], FDbMinMaxIn [ 6], LabeldBInPeak3 , LabeldBInValey3 , LabeldBInMax3 , LabeldBInMin3 );
      FixDbLabels( FDbMinMaxIn [ 7], FDbMinMaxIn [ 8], LabeldBInPeak4 , LabeldBInValey4 , LabeldBInMax4 , LabeldBInMin4 );

      FixDbLabels( FDbMinMaxOut[ 1], FDbMinMaxOut[ 2], LabeldbOutPeak1, LabeldbOutValey1, LabeldBOutMax1, LabeldBOutMin1);
      FixDbLabels( FDbMinMaxOut[ 3], FDbMinMaxOut[ 4], LabeldbOutPeak2, LabeldbOutValey2, LabeldBOutMax2, LabeldBOutMin2);
      FixDbLabels( FDbMinMaxOut[ 5], FDbMinMaxOut[ 6], LabeldbOutPeak3, LabeldbOutValey3, LabeldBOutMax3, LabeldBOutMin3);
      FixDbLabels( FDbMinMaxOut[ 7], FDbMinMaxOut[ 8], LabeldbOutPeak4, LabeldbOutValey4, LabeldBOutMax4, labeldboutmin4);
    end;

    function    TFormWren.HandleAudioInOnBufferFilled( aBuffer: pAnsiChar; var aSize: Integer): Boolean;
    // Handle legacy audio input and drive the local dezippers
    var
      i           : Integer;
      aFrameCount : Integer;
      aLeft       : TSignal;
      aRight      : TSignal;
      aMaxLeft    : TSignal;
      aMaxRight   : TSignal;
    begin
      Result := False;
      try
        aFrameCount := aSize div 4; // 16 bit samples and two channels, so 4 times a byte
        {$Q-R-}Inc( FIOBalance);{$Q+R+}
        aMaxLeft  := 0;
        aMaxRight := 0;

        if Assigned( FSynthPatch)
        then begin
          for i := 0 to aFrameCount - 1
          do begin
            DeZipper;
            aLeft     := FInVolume1 * SampleToUnits( PSamples( aBuffer)[ 2 * i + 0]);
            aRight    := FInVolume1 * SampleToUnits( PSamples( aBuffer)[ 2 * i + 1]);
            aMaxLeft  := Max( aMaxLeft , Abs( aLeft ));
            aMaxRight := Max( aMaxRight, Abs( aRight));
            FSynthPatch.AcceptSamplePair1( aLeft, aRight);
          end;
        end;
        SetVuSampleCount( aFrameCount);
        FDbMinMaxIn[ 1].Tick( aMaxLeft );
        FDbMinMaxIn[ 2].Tick( aMaxRight);
        Result := True;
      except
        on E: Exception
        do begin
          StopAudioIn;
          StopAudioOut;
          LogFmt( 'Execution error: ''%s'', synth engine was stopped.', [ E.Message]);
        end;
      end;
    end;


    function    TFormWren.HandleAudioOutOnFillBuffer( aBuffer: pAnsiChar; var aSize: Integer): Boolean;
    // Collect legacy audio output from synth and send it to the output device
    // Drive the synth, an output channel must always be active
    var
      i           : Integer;
      aLeft       : TSignal;
      aRight      : TSignal;
      aFrameCount : Integer;
      aMaxLeft    : TSignal;
      aMaxRight   : TSignal;
    begin
      Result := False;
      try
        aFrameCount := aSize div 4; // 16 bit samples and two channels, so 4 times a byte
        {$Q-R-}Dec( FIOBalance);{$Q+R+}
        aMaxLeft  := 0;
        aMaxRight := 0;

        if Assigned( FSynthPatch)
        then begin
          for i := 0 to aFrameCount - 1
          do begin
            with FSynthPatch
            do begin
              Tick;
              aLeft  := FOutVolume1 * Output[ 0];
              aRight := FOutVolume1 * Output[ 1];
            end;
            PSamples( aBuffer)[ 2 * i + 0] := SignalToSample( aLeft );
            PSamples( aBuffer)[ 2 * i + 1] := SignalToSample( aRight);
            aMaxLeft  := Max( aMaxLeft , Abs( aLeft ));
            aMaxRight := Max( aMaxRight, Abs( aRight));
          end;
        end
        else begin
          for i := 0 to aFrameCount - 1
          do begin
            PSamples( aBuffer)[ 2 * i + 0] := 0;
            PSamples( aBuffer)[ 2 * i + 1] := 0;
          end;
        end;
        SetVuSampleCount( aFrameCount);
        FDbMinMaxOut[ 1].Tick( aMaxLeft );
        FDbMinMaxOut[ 2].Tick( aMaxRight);
        Result := True;
      except
        on E: Exception
        do begin
          StopAudioIn;
          StopAudioOut;
          LogFmt( 'Execution error: ''%s'', synth engine was stopped.', [ E.Message]);
        end;
      end;
    end;

    procedure   TFormWren.HandleAudioInOnStart( aSender: TObject);
    begin
      Log( 'legacy audio in was started');
      FAudioInRunning := True;
      UpdateCaptions;
    end;

    procedure   TFormWren.HandleAudioInOnStop( aSender: TObject);
    begin
      Log( 'legacy audio in was stopped');
      FAudioInRunning := False;
      UpdateCaptions;
    end;

    procedure   TFormWren.HandleAudioOutOnStart( aSender: TObject);
    begin
      Log( 'legacy audio out was started');
      FAudioOutRunning := True;
      UpdateCaptions;
    end;

    procedure   TFormWren.HandleAudioOutOnStop( aSender: TObject);
    begin
      Log( 'legacy audio out was stopped');
      FAudioOutRunning := False;
      UpdateCaptions;
    end;

    function    TFormWren.HandleAudioIOPA( anInput, anOutput: Pointer; aFrameCount: culong; aTimeInfo: PPaStreamCallbackTimeInfo; aStatusFlags: TPaStreamCallbackFlags; UserData: Pointer): cint;
    // ** This function is called from the PortAudio thread **
    // Handle PortAudio audio input and drive the local dezippers
    // Collect PortAudio audio output from synth and send it to the output device
    // Drive the synth, an output channel must always be active
    var
      i          : Integer;
      j          : Integer;
      InValues   : array[ 0 .. MAX_IN_CHANNELS       - 1] of TSignal;
      InMaxima   : array[ 0 .. MAX_IN_CHANNELS       - 1] of TSignal;
      InVolumes  : array[ 0 .. MAX_IN_CHANNELS div 2 - 1] of TSignal;
      InChCount  : Integer;
      OutValues  : array[ 0 .. MAX_OUT_CHANNELS - 1] of TSignal;
      OutMaxima  : array[ 0 .. MAX_OUT_CHANNELS - 1] of TSignal;
      OutChCount : Integer;
    begin
      Result := paContinue;
      try
        for j := 0 to MAX_IN_CHANNELS - 1
        do InMaxima[ j] := 0;

        for j := 0 to MAX_OUT_CHANNELS - 1
        do OutMaxima[ j] := 0;

        InVolumes[ 0] := FInVolume1;
        InVolumes[ 1] := FInVolume2;
        InVolumes[ 2] := FInVolume3;
        InVolumes[ 3] := FInVolume4;

        InChCount  := FPaInstreamParameters .channelCount;
        OutChCount := FPaOutstreamParameters.channelCount;

        if Assigned( FSynthPatch)
        then begin
          for i := 0 to aFrameCount - 1
          do begin
            DeZipper;

            for j := 0 to InChCount - 1
            do InValues[ j] := InVolumes[ j div 2] * SampleToUnits( PSamples( anInput)[ InChCount * i + j]);

            for j := InChCount to MAX_IN_CHANNELS - 1
            do InValues[ j] := 0;

            for j := 0 to MAX_IN_CHANNELS - 1
            do InMaxima[ j] := Max( InMaxima[ j], Abs( InValues[ j]));

            FSynthPatch.AcceptSamplePair1( InValues[ 0], InValues[ 1]);
            FSynthPatch.AcceptSamplePair2( InValues[ 2], InValues[ 3]);
            FSynthPatch.AcceptSamplePair3( InValues[ 4], InValues[ 5]);
            FSynthPatch.AcceptSamplePair4( InValues[ 6], InValues[ 7]);

            FSynthPatch.Tick;

            OutValues[ 0] := FOutVolume1 * FSynthPatch.Output[ 0];
            OutValues[ 1] := FOutVolume1 * FSynthPatch.Output[ 1];
            OutValues[ 2] := FOutVolume2 * FSynthPatch.Output[ 2];
            OutValues[ 3] := FOutVolume2 * FSynthPatch.Output[ 3];
            OutValues[ 4] := FOutVolume3 * FSynthPatch.Output[ 4];
            OutValues[ 5] := FOutVolume3 * FSynthPatch.Output[ 5];
            OutValues[ 6] := FOutVolume4 * FSynthPatch.Output[ 6];
            OutValues[ 7] := FOutVolume4 * FSynthPatch.Output[ 7];

            for j := 0 to OutChCount - 1
            do PSamples( anOutput)[ OutChCount * i + j] := SignalToSample( OutValues[ j]);

            for j := 0 to MAX_OUT_CHANNELS - 1
            do OutMaxima[ j] := Max( OutMaxima[ j] , Abs( OutValues[ j]));

          end;
        end
        else begin
          for i := 0 to aFrameCount - 1
          do begin
            for j := 0 to OutChCount - 1
            do PSamples( anOutput)[ OutChCount * i + j] := 0;

            for j := 0 to MAX_OUT_CHANNELS - 1
            do OutMaxima[ j] := 0.0;
          end;
        end;

        SetVuSampleCount( aFrameCount);

        FDbMinMaxIn [ 1].Tick( InMaxima [ 0]);
        FDbMinMaxIn [ 2].Tick( InMaxima [ 1]);
        FDbMinMaxIn [ 3].Tick( InMaxima [ 2]);
        FDbMinMaxIn [ 4].Tick( InMaxima [ 3]);
        FDbMinMaxIn [ 5].Tick( InMaxima [ 4]);
        FDbMinMaxIn [ 6].Tick( InMaxima [ 5]);
        FDbMinMaxIn [ 8].Tick( InMaxima [ 6]);
        FDbMinMaxIn [ 8].Tick( InMaxima [ 7]);

        FDbMinMaxOut[ 1].Tick( OutMaxima[ 0]);
        FDbMinMaxOut[ 2].Tick( OutMaxima[ 1]);
        FDbMinMaxOut[ 3].Tick( OutMaxima[ 2]);
        FDbMinMaxOut[ 4].Tick( OutMaxima[ 3]);
        FDbMinMaxOut[ 5].Tick( OutMaxima[ 4]);
        FDbMinMaxOut[ 6].Tick( OutMaxima[ 5]);
        FDbMinMaxOut[ 7].Tick( OutMaxima[ 6]);
        FDbMinMaxOut[ 8].Tick( OutMaxima[ 7]);

        {$Q-R-}
        if aStatusFlags and paInputUnderflow  <> 0 then Inc( FPaInUnderflows );
        if aStatusFlags and paInputOverflow   <> 0 then Inc( FPaInoverflows  );
        if aStatusFlags and paOutputUnderflow <> 0 then Inc( FPaOutUnderflows);
        if aStatusFlags and paOutputOverflow  <> 0 then Inc( FPaOutoverflows );
        {$Q+R+}
      except
        on E: Exception
        do KilledException( E);
      end;
    end;

    procedure   TFormWren.HandleAudioOnStartPA( userdata: Pointer);
    begin
      Log( 'PortAudio was started'); // Not called from audio thread, ok to log
      FAudioInRunning  := True;
      FAudioOutRunning := True;
      UpdateCaptions;
    end;

    procedure   TFormWren.HandleAudioOnStopPA( userdata: Pointer);
    // ** This function is called from the PortAudio thread **
    begin
      FAudioInRunning  := False;
      FAudioOutRunning := False;
    end;

    procedure   TFormWren.WaveShowAsioPanel( aSender: TObject; aDevice: TPaDeviceIndex; aHandle: HWND);
    begin
      if FAudioInRunning or FAudioOutRunning
      then begin
        FPanelAudioWasRunning := True;
        StartStopAudioIo;
      end;
      FAsioPanelDevice  := aDevice;
      FAsioPanelPointer := Pointer( aHandle);
      FRequestAsioPanel := True;
    end;

    procedure   TFormWren.WaveRestartAudio( aSender: TObject; aDebug: Boolean);
    begin
      if aDebug
      then ViewDebug;

      if not FAudioInRunning and not FAudioOutRunning
      then StartStopAudioIo
      else begin
        StartStopAudioIo;
        FRequestAudioStart := True;
      end;
    end;

    procedure   TFormWren.WaveLog( aSender: TObject; const aMsg: string);
    begin
      LogFmt( 'WaveDlg: %s', [ aMsg]);
    end;

    procedure   TFormWren.CreateDevices;
    begin
      if not FCanCreateAudio
      then Exit;

      if FBufferSize = 0
      then FBufferSize := 4096;

      if FPortAudioSelected
      then begin
        Log(    'creating  PortAudio device');
        with FPaInstreamParameters
        do begin
          device           := FormWaveDeviceSelect.PaInDeviceId;
          sampleFormat     := paInt16;
          suggestedLatency := FormWaveDeviceSelect.PaInDevice.defaultLowInputLatency;
          if FormWaveDeviceSelect.IsAsioIn
          then begin
            PaAsio_GetAvailableBufferSizes( FPaInstreamParameters.device, FPaAsioMinFrames, FPaAsioMaxFrames, FPaAsioPrefFrames, FPaAsioGranFrames);
            FPaAsioInStreamInfo       := FormWaveDeviceSelect.CreateAsioInStreamInfo;
            hostApiSpecificStreamInfo := @ FPaAsioInStreamInfo;
            channelCount              := Min( MAX_IN_CHANNELS, FormWaveDeviceSelect.InMaskCount);
          end
          else begin
            FPaAsioMinFrames          := 0;
            FPaAsioMaxFrames          := 0;
            FPaAsioPrefFrames         := 0;
            FPaAsioGranFrames         := 0;
            hostApiSpecificStreamInfo := nil;
            channelCount              := Min( MAX_IN_CHANNELS, FormWaveDeviceSelect.PaInDevice.maxInputChannels);
          end;
        end;
        with FPaOutstreamParameters
        do begin
          device                    := FormWaveDeviceSelect.PaOutDeviceId;
          sampleFormat              := paInt16;
          suggestedLatency          := FormWaveDeviceSelect.PaOutDevice.defaultLowOutputLatency;
          if FormWaveDeviceSelect.IsAsioOut
          then begin
            PaAsio_GetAvailableBufferSizes( FPaOutstreamParameters.device, FPaAsioMinFrames, FPaAsioMaxFrames, FPaAsioPrefFrames, FPaAsioGranFrames);
            FPaAsioOutStreamInfo      := FormWaveDeviceSelect.CreateAsioOutStreamInfo;
            hostApiSpecificStreamInfo := @ FPaAsioOutStreamInfo;
            channelCount              := Min( MAX_OUT_CHANNELS, FormWaveDeviceSelect.OutMaskCount);
          end
          else begin
            FPaAsioMinFrames          := 0;
            FPaAsioMaxFrames          := 0;
            FPaAsioPrefFrames         := 0;
            FPaAsioGranFrames         := 0;
            hostApiSpecificStreamInfo := nil;
            channelCount              := Min( MAX_OUT_CHANNELS, FormWaveDeviceSelect.PaOutDevice.maxOutputChannels);
          end;
        end;
      end
      else begin
        Log(    'creating  legacy audio devices');
        FAudioOut := TAudioOut.Create( Self);
        FAudioIn  := TAudioIn .Create( Self);

        FAudioOut.BufferSize :=  BufferSize;
        FAudioOut.NumBuffers :=           4;
        FAudioOut.FrameRate  := System_Rate;
        FAudioOut.Stereo     :=        True;

        FAudioIn .BufferSize :=  BufferSize;
        FAudioIn .NumBuffers :=           4;
        FAudioIn .FrameRate  := System_Rate;
        FAudioIn .Stereo     :=        True;
      end;

      HookDevices;
    end;

    procedure   TFormWren.FreeDevices;
    begin
      if not FCanCreateAudio
      then Exit;

      StopAudioIn;
      StopAudioOut;
      UnhookDevices;
      if FPortAudioSelected
      then begin
        Log(    'freeing   PortAudio device');
        FormWaveDeviceSelect.FreeAsioStreamInfo( FPaAsioInStreamInfo );
        FormWaveDeviceSelect.FreeAsioStreamInfo( FPaAsioOutStreamInfo);
        FPaStream := nil; // Pa_CloseStream should have been closed by StopAudioIn, but we did not open it at this
                          // level, just to be sure set it to nil here so it will not be used anymore.
      end
      else begin
        Log(    'freeing   legacy audio devices');
        FAudioIn .DisposeOf;
        FAudioOut.DisposeOf;
      end;
    end;

    procedure   TFormWren.HookDevices;
    begin
      if not FPortAudioSelected and Assigned( FAudioIn) and Assigned( FAudioOut)
      then begin
        Log(    'hooking   legacy audio devices');
        FAudioIn .OnBufferFilled := HandleAudioInOnBufferFilled;
        FAudioIn .OnStart        := HandleAudioInOnStart;
        FAudioIn .OnStop         := HandleAudioInOnStop;

        FAudioOut.OnFillBuffer   := HandleAudioOutOnFillBuffer;
        FAudioOut.OnStart        := HandleAudioOutOnStart;
        FAudioOut.OnStop         := HandleAudioOutOnStop;
      end;
    end;

    procedure   TFormWren.UnhookDevices;
    begin
      if not FPortAudioSelected and Assigned( FAudioIn) and Assigned( FAudioOut)
      then begin
        Log(    'unhooking legacy audio devices');
        FAudioIn .OnBufferFilled := nil;
        FAudioIn .OnStart        := nil;
        FAudioIn .OnStop         := nil;

        FAudioOut.OnFillBuffer   := nil;
        FAudioOut.OnStart        := nil;
        FAudioOut.OnStop         := nil;
      end;
    end;

    procedure   TFormWren.StopAudioIn;
    begin
      if FPortAudioSelected
      then begin
        if Assigned( FPaStream)
        then begin
          if FAudioInRunning
          then begin
            LogFmt( 'stopping  PortAudio, patch "%s"', [ PatchName]);
            Pa_StopStream( FPaStream);
          end;
          Pa_CloseStream( FPaStream);
        end;
        FPaStream := nil;
      end
      else begin
        if Assigned( FAudioIn) and FAudioIn.Active
        then begin
          LogFmt( 'stopping  legacy audio in, patch "%s"', [ PatchName]);
          FAudioIn.StopGracefully;
        end;
      end;
      ClearVolumeIndicators;
      UpdateCaptions;
    end;

    procedure   TFormWren.StopAudioOut;
    begin
      FOutVolume1 := 0;
   // FOutShadow1 := 0;
      if not FPortAudioSelected
      then begin
        if Assigned( FAudioOut) and FAudioOut.Active
        then begin
          LogFmt( 'stopping  legacy audio out, patch "%s"', [ PatchName]);
          FAudioOut.StopGracefully;
        end;
      end;
      ClearVolumeIndicators;
      UpdateCaptions;
    end;

    procedure   TFormWren.StartAudioIn;
    var
      BufSize : Integer;
      anError : TPaError;
    begin
      if FPortAudioSelected
      then begin
        try
          if FPaAsioPrefFrames <> 0
          then BufSize := FPaAsioPrefFrames
          else BufSize := BufferSize;
          if ( FPaInstreamParameters.channelCount = 0) and ( FPaOutstreamParameters.channelCount = 0)
          then CreateDevices;

          LogFmt(
            'starting  PA [api: "%s", in: "%s" ch: %d, out: "%s" ch: %d], patch "%s" at %.1f ks/s with buffer size %d frames',
            [
              FormWaveDeviceSelect.SelectedAPI,
              FormWaveDeviceSelect.SelectedInputPA,
              FPaInstreamParameters.channelCount,
              FormWaveDeviceSelect.SelectedOutputPA,
              FPaOutstreamParameters.channelCount,
              PatchName,
              System_Rate / 1000,
              BufSize
            ]
          );

          anError := Pa_OpenStream( FPaStream, @ FPaInstreamParameters, @ FPaOutstreamParameters, System_Rate, BufSize, paNoFlag, @ GHandleAudioOnBufferFilledPA, nil);
          if anError = paNoError
          then begin
            anError := Pa_SetStreamFinishedCallback( FPaStream, @ GHandleAudioOnStopPA);
            if anError = paNoError
            then begin
              anError := Pa_StartStream( FPaStream);
              if anError = paNoError
              then HandleAudioOnStartPA( nil)
              else begin
                LogFmt( 'error starting PA stream: %s', [ string( Pa_GetErrorText( anError))]);
              end;
            end
            else begin
              LogFmt( 'error opening PA stream finished callback: %s', [ string( Pa_GetErrorText( anError))]);
            end;
          end
          else begin
            LogFmt( 'error opening PA stream: %s', [ string( Pa_GetErrorText( anError))]);
            FPaStream := nil;
          end;
          if anError <> paNoError
          then ViewDebug;
        except
          on E: Exception
          do begin
            ViewDebug;
            LogFmt( 'exception on opening PA stream: "%s"', [ E.Message]);
          end;
        end;
      end
      else begin
        if not Assigned( FAudioIn)
        then CreateDevices;
        if Assigned( FAudioIn)
        then begin
          FAudioIn.StopAtOnce;
          LogFmt( 'starting  legacy audio in, patch "%s"', [ PatchName]);
          FAudioIn.WaveDevice := FSelectedInputId;
          FAudioIn.Start;
        end
        else Log( 'No audio in device selected?');
      end;
      ClearVolumeIndicators;
      UpdateCaptions;
      FIOBalance       := 0;
      FPaInUnderflows  := 0;
      FPaInoverflows   := 0;
      FPaOutUnderflows := 0;
      FPaOutoverflows  := 0;
    end;

    procedure   TFormWren.StartAudioOut;
    begin
      if Assigned( FSynthPatch)
      then FSynthPatch.FixZippers;
      FOutShadow1 := knob_outputlevel1.AsValue;
      FOutShadow2 := knob_outputlevel2.AsValue;
      FOutShadow3 := knob_outputlevel3.AsValue;
      FOutShadow4 := knob_outputlevel4.AsValue;
      if not FPortAudioSelected
      then begin
        if not Assigned( FAudioOut)
        then CreateDevices;
        if Assigned( FAudioOut)
        then begin
          FAudioOut.StopAtOnce;
          LogFmt( 'starting  legacy audio out, patch "%s"', [ PatchName]);
          FAudioOut.WaveDevice := FSelectedOutputId;
          FAudioOut.Start;
        end
        else Log( 'No audio out device selected?');
      end;
      ClearVolumeIndicators;
      UpdateCaptions;
      FIOBalance       := 0;
      FPaInUnderflows  := 0;
      FPaInoverflows   := 0;
      FPaOutUnderflows := 0;
      FPaOutoverflows  := 0;
      if not RenderToFile
      then ResetRunTime;
    end;

    procedure   TFormWren.StartStopAudioIo;
    begin
      if FAudioOutRunning
      then begin
        StopAudioIn;
        StopAudioOut;
        if ClearVUOnStop
        then ClearVUMeters;
      end
      else begin
        StartAudioIn;
        StartAudioOut;
      end;
    end;

    procedure   TFormWren.VerifyDevices;
    begin
      FormWaveDeviceSelect.AllowPortAudio     := Self.UsePortAudio;
      FormWaveDeviceSelect.UsePortAudio       := Self.FPortAudioSelected;
      FormWaveDeviceSelect.SelectedInputId    := Self.FSelectedInputId;
      FormWaveDeviceSelect.SelectedOutputId   := Self.FSelectedOutputId;
      FormWaveDeviceSelect.SelectedAPIID      := Self.FSelectedAPIID;
      FormWaveDeviceSelect.SelectedInputIdPA  := Self.FSelectedInputIdPA;
      FormWaveDeviceSelect.SelectedOutputIdPA := Self.FSelectedOutputIdPA;
      FormWaveDeviceSelect.BufferSize         := Self.FBufferSize;
      SelectDevices;
    end;

    procedure   TFormWren.SelectDevices;
    var
      WasRunning   : Boolean;
    begin
      WasRunning := FAudioInRunning or FAudioOutRunning;

      if WasRunning
      then begin
        StopAudioIn;
        StopAudioOut;
      end;

      FreeDevices;
      FSelectedInputId     := FormWaveDeviceSelect.SelectedInputId;
      FSelectedOutputId    := FormWaveDeviceSelect.SelectedOutputId;
      FSelectedAPIID       := FormWaveDeviceSelect.SelectedAPIID;
      FSelectedInputIdPA   := FormWaveDeviceSelect.SelectedInputIdPA;
      FSelectedOutputIdPA  := FormWaveDeviceSelect.SelectedOutputIdPA;
      FBufferSize          := FormWaveDeviceSelect.BufferSize;
      FPortAudioSelected   := FormWaveDeviceSelect.UsePortAudio;
      CreateDevices;

      if WasRunning
      then begin
        StartAudioIn;
        StartAudioOut;
      end;
    end;

    procedure   TFormWren.ClearVolumeIndicators;
    begin
      IndicatorBarVolumeInLeft1  .Value := 0.0;
      IndicatorBarVolumeInRight1 .Value := 0.0;
      IndicatorBarVolumeOutLeft1 .Value := 0.0;
      IndicatorBarVolumeOutRight1.Value := 0.0;
      IndicatorBarVolumeInLeft2  .Value := 0.0;
      IndicatorBarVolumeInRight2 .Value := 0.0;
      IndicatorBarVolumeOutLeft2 .Value := 0.0;
      IndicatorBarVolumeOutRight2.Value := 0.0;
      IndicatorBarVolumeInLeft3  .Value := 0.0;
      IndicatorBarVolumeInRight3 .Value := 0.0;
      IndicatorBarVolumeOutLeft3 .Value := 0.0;
      IndicatorBarVolumeOutRight3.Value := 0.0;
      IndicatorBarVolumeInLeft4  .Value := 0.0;
      IndicatorBarVolumeInRight4 .Value := 0.0;
      IndicatorBarVolumeOutLeft4 .Value := 0.0;
      IndicatorBarVolumeOutRight4.Value := 0.0;
      ResetPeaks;
    end;

    procedure   TFormWren.ShowOverUnderFlows;
    var
      SynthUnderflows : Integer;
      SynthOverflows  : Integer;
    begin
      if Assigned( FSynthPatch)
      then begin
        SynthUnderflows := FSynthPatch.Underflows;
        SynthOverflows  := FSynthPatch.Overflows;
      end
      else begin
        SynthUnderflows := 0;
        SynthOverflows  := 0;
      end;

      LabelIOBalance         .Caption := Format( 'I/O balance  : %d'     , [ FIOBalance      ], AppLocale);
      LabelAudioInUnderflows .Caption := Format( 'ai_underflows: %d'     , [ FPaInUnderflows ], AppLocale);
      LabelAudioInOverflows  .Caption := Format( 'ai_overflows : %d'     , [ FPaInOverflows  ], AppLocale);
      LabelAudioOutUnderflows.Caption := Format( 'ao_underflows: %d'     , [ FPaOutUnderflows], AppLocale);
      LabelAudioOutOverflows .Caption := Format( 'ao_overflows : %d'     , [ FPaOutOverflows ], AppLocale);
      LabelSynthUnderflows   .Caption := Format( 's_underflows : %d'     , [ SynthUnderflows ], AppLocale);
      LabelSynthOverflows    .Caption := Format( 's_overflows  : %d'     , [ SynthOverflows  ], AppLocale);
      LabelExceptions        .Caption := Format( 'excepts      : %d'     , [ ExceptionCounter], AppLocale);
      LabelFrameSize         .Caption := Format( 'frame size   : %d'     , [ FVuSampleCount  ], AppLocale);
      LabelLightsTime        .Caption := Format( 'lights time  : %.2f ms', [ FLightsTime     ], AppLocale);

      if
        ( FLastAudioInUnderflows  <> FPaInUnderflows ) or
        ( FLastAudioInOverflows   <> FPaInOverflows  ) or
        ( FLastAudioOutUnderflows <> FPaOutUnderflows) or
        ( FLastAudioOutOverflows  <> FPaOutOverflows )
      then KnobsLedUnderflows.Active :=
        ( FPaInUnderflows  <> 0) or
        ( FPaInOverflows   <> 0) or
        ( FPaOutUnderflows <> 0) or
        ( FPaOutOverflows  <> 0);

      FLastAudioInUnderflows  := FPaInUnderflows;
      FLastAudioInOverflows   := FPaInOverflows;
      FLastAudioOutUnderflows := FPaOutUnderflows;
      FLastAudioOutOverflows  := FPaOutOverflows;
    end;

    procedure   TFormWren.ClearOverUnderFlows;
    begin
      FPaInUnderflows        := 0;
      FPaOutUnderflows       := 0;
      FPaInoverflows         := 0;
      FPaOutoverflows        := 0;
      if Assigned( FSynthPatch)
      then FSynthPatch.ClearOverUnderFlows;
    end;

    procedure   TFormWren.ShowRunTime;
    var
      Delta : TDateTime;
    begin
      Delta := Now - FStartTime;
      LabelRunTime.Caption := Format( FormatDateTime( '"D %.2d":hh:mm:ss', Delta), [ Floor( Delta)], AppLocale);
      LabelRunTime.Hint    := 'Current run time for the program, click to reset';
    end;

    procedure   TFormWren.ResetRuntime;
    begin
      FStartTime := Now;
      ShowRunTime;
    end;

    function    TFormWren.GetDefaultModuleColor( const aSender: TObject; const aModuleType: TKnobsModuleType): TColor;
    begin
      if Assigned( FormStore)
      then Result := FormStore.DefaultModuleColor( aModuleType, ModuleColor)
      else Result := ModuleColor;
    end;

    procedure   TFormWren.ConnectorDelete( const aConnector: TKnobsConnector);
    begin
      if Assigned( PatchEditor)
      then PatchEditor.ConnectorDelete( aConnector);
    end;

    procedure   TFormWren.ConnectorBreak( const aConnector: TKnobsConnector);
    begin
      if Assigned( PatchEditor)
      then PatchEditor.ConnectorBreak( aConnector);
    end;

    procedure   TFormWren.ConnectorDisconnect( const aConnector: TKnobsConnector);
    begin
      if Assigned( PatchEditor)
      then PatchEditor.ConnectorDisconnect( aConnector);
    end;

    procedure   TFormWren.SetWireColor( const aConnector : TKnobsConnector; const aColor: TColor);
    begin
      if Assigned( PatchEditor)
      then PatchEditor.SetWireColor( aConnector, aColor);
    end;

    procedure   TFormWren.SetWireColorDefault( const aConnector: TKnobsConnector);
    begin
      if Assigned( PatchEditor)
      then PatchEditor.SetWireColorDefault( aConnector);
    end;

    procedure   TFormWren.SetWireColorCustom( const aConnector: TKnobsConnector);
    begin
      if Assigned( PatchEditor) and Assigned( aConnector)
      then begin
        with ColorDialogModule
        do begin
          Color := aConnector.WireColor;
          if Execute
          then PatchEditor.SetWireColor( aConnector, Color);
        end;
      end;
    end;

    procedure   TFormWren.ModuleCut( const aModule: TKnobsModule);
    begin
      if Assigned( PatchEditor) and Assigned( aModule)
      then begin
        aModule.FixSelection;
        CutModules;
      end;
    end;

    procedure   TFormWren.ModuleCopy( const aModule: TKnobsModule);
    begin
      if Assigned( PatchEditor) and Assigned( aModule)
      then begin
        aModule.FixSelection;
        CopyModules;
      end;
    end;

    procedure   TFormWren.ModuleDelete( const aModule: TKnobsModule);
    begin
      if Assigned( PatchEditor) and Assigned( aModule)
      then begin
        aModule.FixSelection;
        DeleteModules;
      end;
    end;

    procedure   TFormWren.ChangeModuleColor( const aModule: TKnobsModule);
    begin
      if Assigned( PatchEditor) and Assigned( aModule)
      then begin
        aModule.FixSelection;
        with ColorDialogModule
        do begin
          Color := aModule.Color;
          if Execute
          then PatchEditor.SetSelectedModuleColor( Color);
        end;
      end;
    end;

    procedure   TFormWren.ModuleColorDefault ( const aModule: TKnobsModule);
    begin
      if Assigned( PatchEditor) and Assigned( FormStore) and Assigned( aModule)
      then begin
        aModule.FixSelection;
        PatchEditor.SetSelectedModuleColorDefault( GetDefaultModuleColor);
      end;
    end;

    procedure   TFormWren.KnobSetDefaultValue( const aValuedControl: TKnobsValuedControl);
    begin
      if Assigned( aValuedControl)
      then aValuedControl.SetDefault;
    end;

    procedure   TFormWren.KnobChangeLock( const aKnob: TKnobsKnob);
    begin
      if Assigned( aKnob)
      then aKnob.Locked := not aKnob.Locked;
    end;

    procedure   TFormWren.AssignMidiCC( const aValuedControl: TKnobsValuedControl);
    begin
      if Assigned( FormSelectMidiCC)
      then begin
        if Assigned( aValuedControl) and ( aValuedControl.AllowAutomation)
        then begin
          with FormSelectMidiCC
          do begin
            if Execute( MakeMidiCCName( aValuedControl), aValuedControl.AssignedMIDICC, aValuedControl)
            then begin
              if Assigned( PatchEditor)
              then PatchEditor.UnassignMidiCC( MidiCC);
              aValuedControl.AssignedMIDICC := MidiCC;
            end;
          end;
        end;
      end;
    end;

    procedure   TFormWren.AssignLastCCToKnob( const aValuedControl: TKnobsValuedControl);
    var
      aName : string;
    begin
      if Assigned( FormSelectMidiCC) and Assigned( aValuedControl)
      then begin
        aName := MakeMidiCCName( aValuedControl);
        FormSelectMidiCC.RegisterControlName( FLastFrozenCC, aName, aValuedControl);
        if Assigned( PatchEditor)
        then PatchEditor.UnassignMidiCC( FLastFrozenCC);
        aValuedControl.AssignedMIDICC := FLastFrozenCC;
      end;
    end;

    procedure   TFormWren.UnAssignMidiCC( const aValuedControl: TKnobsValuedControl);
    begin
      if Assigned( FormSelectMidiCC) and Assigned( aValuedControl)
      then begin
        FormSelectMidiCC.UnregisterCC( aValuedControl.AssignedMIDICC);
        if Assigned( PatchEditor)
        then PatchEditor.UnassignMidiCC( aValuedControl.AssignedMIDICC);
        aValuedControl.AssignedMIDICC := 0;
      end;
    end;

    procedure   TFormWren.ViewMIDIAssignments;
    begin
      if Assigned( FormSelectMidiCC)
      then FormSelectMidiCC.View;
    end;

//  private

    procedure   TFormWren.SetUseConfigHints( aValue: Boolean);
    begin
      if aValue <> FUseConfigHints
      then begin
        FUseConfigHints                := aValue;
        CheckBoxUseConfigHints.Checked := aValue;
        TabSheetSettings.ShowHint      := aValue;
        TabSheetGraphs  .ShowHint      := aValue;
        TabSheetDebug   .ShowHint      := aValue;
        PanelControl    .ShowHint      := aValue;
      end;
    end;

    procedure   TFormWren.SetWireThickness( aValue: Integer);
    begin
      if aValue <> FWireThickness
      then begin
        FWireThickness := aValue;
        if Assigned( PatchEditor)
        then PatchEditor.WireThickness := aValue;
      end;
    end;

    procedure   TFormWren.SetCurvedLines( aValue: Boolean);
    begin
      if aValue <> FCurvedLines
      then begin
        FCurvedLines := aValue;
        if Assigned( PatchEditor)
        then PatchEditor.CurvedLines := aValue;
        CheckBoxCurvedLines.Checked  := aValue;
      end;
    end;

    procedure   TFormWren.SetControlMode( aValue: TDistanceMode);
    begin
      if aValue <> FControlMode
      then begin
        FControlMode := aValue;
        if Assigned( PatchEditor)
        then PatchEditor.ControlMode := FControlMode;
        if Assigned( FormSelectMidiCC)
        then FormSelectMidiCC.ControlMode := FControlMode;
        RadioGroupControlMode.ItemIndex := Integer( FControlMode);
      end;
    end;

    procedure   TFormWren.SetLightsRate( aValue: TSignal);
    begin
      aValue := UnitsToLfoFastFrequency( aValue);
      PClip( aValue, 0.254, 401.8);
      if ( aValue <> FLightsRate) and Assigned( TimerLightsUpdate)
      then begin
        FLightsRate := aValue;
        TimerLightsUpdate.Interval := Round( 1000 / aValue);
      end;
    end;

    procedure   TFormWren.SetReferenceA( aValue: TSignal);
    begin
      if aValue <> FReferenceA
      then begin
        FReferenceA := aValue;
        EditReferenceA.Text := Format( '%.3f', [ aValue], AppLocale);
        TuningChanged := True;
      end;
    end;

    procedure   TFormWren.SetNotesPerOctave( aValue: TSignal);
    begin
      if aValue <> FNotesPerOctave
      then begin
        FNotesPerOctave := aValue;
        EditNotesPerOctave.Text := Format( '%.3f', [ aValue], AppLocale);
        TuningChanged := True;
      end;
    end;

    procedure   TFormWren.SetMiddleNote( aValue: TSignal);
    begin
      if aValue <> FMiddleNote
      then begin
        FMiddleNote := aValue;
        EditMiddleNote.Text := Format( '%.3f', [ aValue], AppLocale);
        TuningChanged := True;
      end;
    end;

    procedure   TFormWren.SetResetOnRender( aValue: Boolean);
    begin
      if aValue <> FResetOnRender
      then begin
        FResetOnRender                := aValue;
        CheckBoxResetOnRender.Checked := aValue;
      end;
    end;

    procedure   TFormWren.SetShowLightsTime( aValue: Boolean);
    begin
      if aValue <> FShowLightsTime
      then begin
        FShowLightsTime                := aValue;
        CheckBoxShowLightsTime.Checked := aValue;
        LabelLightsTime       .Visible := aValue;
      end;
    end;

    function    TFormWren.GetTitleFont: TFont;
    begin
      if Assigned( FormStore)
      then Result := FormStore.TitleFont
      else Result := nil;
    end;

    procedure   TFormWren.SetTitleFont( const aValue: TFont);
    begin
      if Assigned( aValue)
      then begin
        if Assigned( FormStore)
        then FormStore.TitleFont := aValue;
        LabelModuleTitleFont.Font.Assign( FormStore.TitleFont);
        if Assigned( PatchEditor)
        then PatchEditor.SetTitleFont( FormStore.TitleFont);
      end;
    end;

    function    TFormWren.GetModuleFont: TFont;
    begin
      if Assigned( FormStore)
      then Result := FormStore.ModuleFont
      else Result := nil;
    end;

    procedure   TFormWren.SetModuleFont( const aValue: TFont);
    begin
      if Assigned( aValue)
      then begin
        if Assigned( FormStore)
        then FormStore.ModuleFont := aValue;
        LabelModuleFont.Font.Assign( FormStore.ModuleFont);
        if Assigned( PatchEditor)
        then PatchEditor.SetModuleFont( FormStore.ModuleFont);
      end;
    end;

//  private

    procedure   TFormWren.SetSynthNameInCaption( aValue: Boolean);
    begin
      if aValue <> FSynthNameInCaption
      then begin
        FSynthNameInCaption                := aValue;
        CheckBoxSynthNameInCaption.Checked := aValue;
        UpdateCaptions;
      end;
    end;

    procedure   TFormWren.SetPatchChangedInCaption( aValue: Boolean);
    begin
      if aValue <> FPatchChangedInCaption
      then begin
        FPatchChangedInCaption                := aValue;
        CheckBoxPatchChangedInCaption.Checked := aValue;
        UpdateCaptions;
      end;
    end;

    procedure   TFormWren.SetProfiledInCaption( aValue: Boolean);
    begin
      if aValue <> FProfiledInCaption
      then begin
        FProfiledInCaption                := aValue;
        CheckBoxProfiledInCaption.Checked := aValue;
        UpdateCaptions;
      end;
    end;

    procedure   TFormWren.SetAudioStatusInCaption( aValue: Boolean);
    begin
      if aValue <> FAudioStatusInCaption
      then begin
        FAudioStatusInCaption                := aValue;
        CheckBoxAudioStatusInCaption.Checked := aValue;
        UpdateCaptions;
      end;
    end;

    procedure   TFormWren.SetProgramNameInCaption( aValue: Boolean);
    begin
      if aValue <> FProgramNameInCaption
      then begin
        FProgramNameInCaption                := aValue;
        CheckBoxProgramNameInCaption.Checked := aValue;
        UpdateCaptions;
      end;
    end;

    procedure   TFormWren.SetFileVersionInCaption( aValue: Boolean);
    begin
      if aValue <> FFileVersionInCaption
      then begin
        FFileVersionInCaption                := aValue;
        CheckBoxFileVersionInCaption.Checked := aValue;
        UpdateCaptions;
      end;
    end;

    procedure   TFormWren.SetPatchNameInCaption( aValue: Boolean);
    begin
      if aValue <> FPatchNameInCaption
      then begin
        FPatchNameInCaption                := aValue;
        CheckBoxPatchNameInCaption.Checked := aValue;
        UpdateCaptions;
      end;
    end;

    procedure   TFormWren.SetSourceNameInCaption( aValue: Boolean);
    begin
      if aValue <> FSourceNameInCaption
      then begin
        FSourceNameInCaption                := aValue;
        CheckBoxSourceNameInCaption.Checked := aValue;
        UpdateCaptions;
      end;
    end;

    procedure   TFormWren.SetPortAudioInCaption( aValue: Boolean);
    begin
      if aValue <> FPortAudioInCaption
      then begin
        FPortAudioInCaption                := aValue;
        CheckBoxPortAudioInCaption.Checked := aValue;
        UpdateCaptions;
      end;
    end;

//  private

    procedure   TFormWren.DoDesignerLog( const aSender: TObject; const aMsg: string);
    begin
      Log( aMsg);
    end;

    procedure   TFormWren.DoWirePanelLog( const aSender: TObject; const aMsg: string);
    begin
      Log( aMsg);
    end;

    procedure   TFormWren.DoHistoryChanged( const aSender: TObject; anUndoCount, aRedoCount, aSavedMarker: Integer);
    begin
      MenuEditUndo.Enabled := anUndoCount  > 0;
      MenuEditRedo.Enabled := aRedoCount   > 0;
      PatchChanged         := anUndoCount <> aSavedMarker;
    end;

    procedure   TFormWren.DoShowHint( var aHintStr: string; var CanShow: Boolean; var aHintInfo: Vcl.Controls.THintInfo);
    begin
      if Pos( '~', aHintStr) > 0
      then aHintInfo.HintWindowClass := TKnobsHintWindow
      else aHintInfo.HintWindowClass := THintWindow;
    end;

    function    TFormWren.DoCreateModuleBitmap( const aModuleType: TKnobsModuleType; UseCache: Boolean): TBitmap;
    var
      aModuleTypeName : string;
      anImageFileName : string;
      aJPEGImg        : TJPEGImage;
    begin
      // When help docs for the correct program version were created before and an image file is actually present
      // use that image file.
      aModuleTypeName := FormStore.BitmapName( aModuleType);
      anImageFileName := Format( '%s\images\%s', [ DocsPath, aModuleTypeName], AppLocale);
      if UseCache and FileExists( anImageFileName) and not MustMakeDocs
      then begin
        aJPEGImg := TJPEGImage.Create;
        try
          aJPEGImg.LoadFromFile( anImageFileName);
          Result := TBitmap.Create;
          Result.Assign( aJPEGImg);
        finally
          aJPEGImg.DisposeOf;
        end;
      end
      // and otherwise just create a (more basic) image.
      else Result := FormStore.CreateModuleBitmap( aModuleType);
    end;

    function    TFormWren.DoReadModuleComment( const aModuleType: TKnobsModuleType): string;
    begin
      Result := FormStore.ReadModuleComment( aModuleType);
    end;

    procedure   TFormWren.DoValueChanged( const aSender: TObject; const aPath, aControlType: string; aValue: TSignal; IsFinal, IsAutomation: Boolean);
    // An editor module's control changed value, to be reflected in a synth setting
    var
      aPrefix   : string;
      aFullname : string;
    begin
      if Assigned( FSynthPatch)
      then begin
        if IsFinal
        then HandleSpecialValues( aPath, aControlType, aValue);      // Handle some special cases here - stuff in the editor may need change

        ParsePrefix( aPath, aPrefix, aFullname);                     // Parse off the container prefix - and ignore that.

        if IsAutomation
        then FSynthPatch.AcceptAutomationParam( aFullname, aValue)   // Pass on the value to the Synth as an automation
        else FSynthPatch.AcceptParam          ( aFullname, aValue);  // Pass on the value to the Synth as a user action
      end;
    end;

    procedure   TFormWren.DoTextChanged( const aSender: TObject; const aPath, aValue: string);
    // An editor module's text control changed value, to be reflected in a synth setting
    // These changes are assumed to always be 'final' - i.e. 'inbetween' edits should
    // not make it to here.
    var
      aPrefix        : string;
      aRest          : string;
      aModuleName    : string;
      aFullParamName : string;
      aModuleIndex   : Integer;
      aModule        : TMod;
      aParts         : TStringList;
    begin
      if Assigned( FSynthPatch)
      then begin
        ParsePrefix( aPath, aPrefix, aRest);                   // Parse off the container prefix - and ignore that.
        ParsePrefix( aRest, aModuleName, aFullParamName);
        aModuleIndex := FSynthPatch.FindModule( aModuleName);
        if aModuleIndex >= 0
        then begin
          aModule := FSynthPatch.Module[ aModuleIndex];
          if Assigned( aModule)
          then begin

            if ( aModule is TModTextSequencer) and SameText( aFullParamName, 'textsequencer_values')
            then TModTextSequencer( aModule).SetStepValues( ParseTextSequencerValue( aValue))

            else if
              (( aModule is TModWavePlayer ) and SameText( aFullParamName, 'waveplayer_fileselector_filename' )) or
              (( aModule is TModCsvData    ) and SameText( aFullParamName, 'csvdata_fileselector_filename'    )) or
              (( aModule is TModMorse      ) and SameText( aFullParamName, 'morse_display_text'               )) or
              (( aModule is TModScala      ) and SameText( aFullParamName, 'scala_fileselector_mapping'       )) or
              (( aModule is TModScala      ) and SameText( aFullParamName, 'scala_fileselector_scale'         )) or
              (( aModule is TModMidiPlayer ) and SameText( aFullParamName, 'midiplayer_fileselector_filename' )) or
              (( aModule is TModNeuron     ) and SameText( aFullParamName, 'neural_fileselector_filename'     )) or
              (( aModule is TModInterpreter) and SameText( aFullParamName, 'interpreter_fileselector_filename')) or
              (( aModule is TModOscMessage ) and SameText( aFullParamName, 'oscmessage_display_address'       ))
            then begin
              aParts := Explode( aFullParamName, '_');
              try
                if aParts.Count = 3
                then aModule.StringValue[ aParts[ 2]] := aValue;
              finally
                aParts.DisposeOf;
              end;
            end

            else begin
              aParts := Explode( aFullParamName, '_');
              try
                if ( aParts.Count = 3) and SameText( aParts[ 1], 'display')
                then aModule.InternalStringValue[ aParts[ 2]] := aValue;   // Which can set both a param value or an internal value
              finally
                aParts.DisposeOf;
              end;
            end;

          end;
        end;
      end;
    end;

//  private

    function    TFormWren.SplitValueInfo( const aPath: string; var aModule: TKnobsCustomModule; var aModuleType, aSignalName: string): Boolean;
    var
      aParts      : TStringList;
      bParts      : TStringList;
      aModuleName : string;
      aMod        : TKnobsCustomModule;
    begin
      Result      := False;
      aModule     := nil;
      aModuleType := '';
      aSignalName := '';
      aParts := Explode( aPath, '/');
      try
        if aParts.Count >= 2
        then begin
          aModuleName := aParts[ aParts.Count - 2];
          aMod        := PatchEditor.FindModule( aModuleName);
          if Assigned( aMod)
          then begin
            aSignalName := aParts[ aParts.Count - 1];
            bParts      := Explode( aSignalName, '_');
            try
              if bParts.Count = 2
              then begin
                aModuleType := bParts[ 0];
                aSignalName := bParts[ 1];
                aModule     := aMod;
                Result      := True;
              end;
            finally
              bParts.DisposeOf;
            end;
          end;
        end;
      finally
        aParts.DisposeOf;
      end;
    end;

    procedure   TFormWren.HandleSpecialValues( const aPath, aControlType: string; aValue: TSignal);
    var
      aPostFix    : string;
      aModule     : TKnobsCustomModule;
      aModuleType : string;
      aSignalName : string;
    begin
      if SplitValueInfo( aPath, aModule, aModuleType, aSignalName)
      then begin
        aPostFix := ParsePostFix( aPath);
        if
          SameText( aPostFix, 'range' ) or
          SameText( aPostFix, 'arange') or
          SameText( aPostFix, 'hrange') or
          SameText( aPostFix, 'drange') or
          SameText( aPostFix, 'rrange') or
          SameText( aPostFix, 'rnd'   ) or
          SameText( aPostFix, 'clr'   )
        then ChangeRangeFor( aModule, aModuleType, aPostFix, aValue)
        else if
          SameText( aPostFix, 'mode'  ) or
          SameText( aPostFix, 'lock'  ) or
          SameText( aPostFix, 'lockxy')
        then ChangeModeFor( aModule, aModuleType, aValue);
      end;
    end;

    procedure   TFormWren.ChangeRangeFor( const aModule: TKnobsCustomModule; const aModuleType, aRangeType: string; aValue: TSignal);
    var
      aKnob       : TKnobsKnob;
      aSelector   : TKnobsSelector;
      aKnobName   : string;
      i           : Integer;
      anEnvRange  : TEnvRange;
      anLfoRange  : TLfoRange;
      aDelayRange : TDelayRange;
    begin
      if Assigned( aModule)
      then begin
        with aModule
        do begin

          if
            SameText( aModuleType, 'envahd' ) or
            SameText( aModuleType, 'envadsr')
          then begin
            anEnvRange := SignalToEnvRange( aValue);
            for i := 0 to ControlCount - 1
            do begin
              if Controls[ i] is TKnobsKnob
              then begin
                aKnob     := TKnobsKnob( Controls[ i]);
                aKnobName := aKnob.Name;
                if
                  ( SameText( aKnobName, 'envahd_attack'  ) and SameText( aRangeType, 'arange')) or
                  ( SameText( aKnobName, 'envahd_hold'    ) and SameText( aRangeType, 'hrange')) or
                  ( SameText( aKnobName, 'envahd_decay'   ) and SameText( aRangeType, 'drange')) or
                  ( SameText( aKnobName, 'envadsr_attack' ) and SameText( aRangeType, 'arange')) or
                  ( SameText( aKnobName, 'envadsr_decay'  ) and SameText( aRangeType, 'drange')) or
                  ( SameText( aKnobName, 'envadsr_release') and SameText( aRangeType, 'rrange'))
                then begin
                  case anEnvRange of
                    erFast   : aKnob.ControlType := 'EnvTimeFast'  ;
                    erMedium : aKnob.ControlType := 'EnvTimeMedium';
                    erSlow   : aKnob.ControlType := 'EnvTimeSlow'  ;
                  end;
                end;
              end;
            end;
          end

          else if
            SameText( aModuleType, 'lfo'           ) or
            SameText( aModuleType, 'squarelfo'     ) or
            SameText( aModuleType, 'lfotrig'       ) or
            SameText( aModuleType, 'squarelfotrig' ) or
            SameText( aModuleType, 'randsig'       ) or
            SameText( aModuleType, 'randomwalklfo' ) or
            SameText( aModuleType, 'attractorLfo'  ) or
            SameText( aModuleType, 'logisticmaplfo')
          then begin
            anLfoRange := SignalToLfoRange( aValue);
            for i := 0 to ControlCount - 1
            do begin
              if Controls[ i] is TKnobsKnob
              then begin
                aKnob     := TKnobsKnob( Controls[ i]);
                aKnobName := aKnob.Name;
                if
                  SameText( aKnobName, 'lfo_frequency'           ) or
                  SameText( aKnobName, 'lfotrig_frequency'       ) or
                  SameText( aKnobName, 'squarelfo_frequency'     ) or
                  SameText( aKnobName, 'squarelfotrig_frequency' ) or
                  SameText( aKnobName, 'randsig_frequency'       ) or
                  SameText( aKnobName, 'randomwalklfo_frequency' ) or
                  SameText( aKnobName, 'attractorlfo_frequency'  ) or
                  SameText( aKnobName, 'logisticmaplfo_frequency')
                then begin
                  case anLfoRange of
                    lsFast   : aKnob.ControlType := 'LfoFreqCoarseFast'  ;
                    lsMedium : aKnob.ControlType := 'LfoFreqCoarseMedium';
                    lsSlow   : aKnob.ControlType := 'LfoFreqCoarseSlow'  ;
                    lsBPM    : aKnob.ControlType := 'LfoFreqCoarseBPM'   ;
                    lsLin    : aKnob.ControlType := 'LfoFreqCoarseLin'   ;
                  end;
                end
              end;
            end;
          end

          else if
            SameText( aModuleType, 'delay'           ) or
            SameText( aModuleType, 'delay8'          ) or
            SameText( aModuleType, 'simplegranulator') or
            SameText( aModuleType, 'granulator'      ) or
            SameText( aModuleType, 'rndgranulator'   )
          then begin
            aDelayRange := SignalToDelayRange( aValue);
            for i := 0 to ControlCount - 1
            do begin
              if Controls[ i] is TKnobsKnob
              then begin
                aKnob     := TKnobsKnob( Controls[ i]);
                aKnobName := aKnob.Name;
                if
                  SameText( aKnobName, 'delay_length'              ) or
                  SameText( aKnobName, 'delay8_length'             ) or
                  SameText( aKnobName, 'simplegranulator_delaytime') or
                  SameText( aKnobName, 'granulator_delaytime'      ) or
                  SameText( aKnobName, 'rndgranulator_delaytime'   )
                then begin
                  case aDelayRange of
                    dsShort  : aKnob.ControlType := 'DelayTimeShort';
                    dsMedium : aKnob.ControlType := 'DelayTimeMedium';
                    dsLong   : aKnob.ControlType := 'DelayTimeLong';
                  end;
                end;
              end;
            end;
          end

          else if
            SameText( aModuleType, 'sequencer') or
            SameText( aModuleType, 'gateseq'  ) or
            SameText( aModuleType, 'seq16'    )
          then begin
            for i := 0 to ControlCount - 1
            do begin
              if Controls[ i] is TKnobsKnob
              then begin
                aKnob := TKnobsKnob( Controls[ i]);
                if aKnob.Tag = 1
                then begin
                  if SameText( aRangeType, 'rnd')
                  then aKnob.KnobPosition := Random( 128);
                  if SameText( aRangeType, 'clr')
                  then begin
                    if SameText( aKnob.ControlType, 'NoteName')
                    then aKnob.KnobPosition := 69
                    else aKnob.KnobPosition :=  0;
                  end;
                end;
              end
              else if Controls[ i] is TKnobsSelector
              then begin
                aSelector := TKnobsSelector( Controls[ i]);
                if aSelector.Tag = 1
                then begin
                  if SameText( aRangeType, 'rnd')
                  then aSelector.KnobPosition := Random( 3);
                  if SameText( aRangeType, 'clr')
                  then aSelector.KnobPosition := 0;
                end;
              end;
            end;
          end;
        end;
      end;
    end;

    procedure   TFormWren.ChangeModeFor( const aModule: TKnobsCustomModule; const aModuleType: string; aValue: TSignal);
    var
      aKnob : TKnobsKnob;
      i     : Integer;
    begin
      if Assigned( aModule)
      then begin
        if SameText( aModuleType, 'scaler')
        then begin
          aKnob := nil;
          with aModule
          do begin
            for i := 0 to ControlCount - 1
            do begin
              if Controls[ i] is TKnobsKnob
              then begin
                aKnob := TKnobsKnob( Controls[ i]); // Pick the first Knob found ... it should be paired in the designer already.
                Break;
              end;
            end;
          end;
          if Assigned( aKnob)
          then aKnob.PairingMode := TKnobsPairingMode( Round( aValue));
        end

        else if SameText( aModuleType, 'xyscope')
        then begin
          aKnob := nil;
          with aModule
          do begin
            for i := 0 to ControlCount - 1
            do begin
              if ( Controls[ i] is TKnobsKnob) and ( TKnobsKnob( Controls[ i]).Name = 'xyscope_levx')
              then begin
                aKnob := TKnobsKnob( Controls[ i]); // Pick the X level Knob ... it should be paired in the designer already with the Y level one.
                Break;
              end;
            end;
          end;
          if Assigned( aKnob)
          then aKnob.PairingMode := TKnobsPairingMode( Round( aValue));
        end

        else if SameText( aModuleType, 'hardclip')
        then begin
          aKnob := nil;
          with aModule
          do begin
            for i := 0 to ControlCount - 1
            do begin
              if ( Controls[ i] is TKnobsKnob) and ( TKnobsKnob( Controls[ i]).Name = 'hardclip_lowlevel')
              then begin
                aKnob := TKnobsKnob( Controls[ i]); // Pick the low level Knob ... it should be paired in the designer already with the high level one.
                Break;
              end;
            end;
          end;
          if Assigned( aKnob)
          then aKnob.PairingMode := TKnobsPairingMode( Round( aValue));
        end

        else if
          SameText( aModuletype, 'mixm4to1' ) or
          SameText( aModuletype, 'mixs2to1' ) or
          SameText( aModuletype, 'mixt1to1' ) or
          SameText( aModuletype, 'mixq1to1' ) or
          SameText( aModuletype, 'mixm6to6' )
        then begin
          with aModule
          do begin
            for i := 0 to ControlCount - 1
            do begin
              if Controls[ i] is TKnobsKnob
              then begin
                if Round( aValue) = 0
                then TKnobsKnob( Controls[ i]).ControlType := 'linear[-1,1]'
                else TKnobsKnob( Controls[ i]).ControlType := 'dB[0,1]'
              end;
            end;
          end;
        end

        else if SameText( aModuletype, 'mixm16to1')
        then begin
          with aModule
          do begin
            for i := 0 to ControlCount - 1
            do begin
              if Controls[ i] is TKnobsKnob
              then begin
                aKnob := TKnobsKnob( Controls[ i]);
                case Round( aValue) of
                  0 :  aKnob.ControlType := 'linear[-4,4]';
                  1 :  aKnob.ControlType := 'dB[0,4]';
                  2 :  aKnob.ControlType := 'linear[-1,1]';
                  3 :  aKnob.ControlType := 'dB[0,1]';
                  4 :  aKnob.ControlType := 'linear[0,4]';
                  5 :  aKnob.ControlType := 'linear[0,1]';
                end;
              end;
            end;
          end;
        end

        else if SameText( aModuletype, 'amplifier')
        then begin
          with aModule
          do begin
            for i := 0 to ControlCount - 1
            do begin
              if Controls[ i] is TKnobsKnob
              then begin
                if Round( aValue) = 0
                then TKnobsKnob( Controls[ i]).ControlType := 'linear[-4,4]'    // 0 : for compatibility with older patches
                else TKnobsKnob( Controls[ i]).ControlType := 'dB[0,4]'         // 1 : for compatibility with older patches
              end;
            end;
          end;
        end

        else if
          SameText( aModuletype, 'constant' ) or
          SameText( aModuletype, 'seq16'    )
        then begin
          with aModule
          do begin
            for i := 0 to ControlCount - 1
            do begin
              if Controls[ i] is TKnobsKnob
              then begin
                aKnob := TKnobsKnob( Controls[ i]);
                if aKnob.Tag = 1
                then begin
                  case Round( aValue) of
                    0 :  aKnob.ControlType := 'linear[-4,4]'; // 0 : for compatibility with older patches
                    1 :  aKnob.ControlType := 'dB[0,4]';      // 1 : for compatibility with older patches
                    2 :  aKnob.ControlType := 'linear[-1,1]';
                    3 :  aKnob.ControlType := 'dB[0,1]';
                    4 :  aKnob.ControlType := 'linear[0,4]';
                    5 :  aKnob.ControlType := 'linear[0,1]';
                    else aKnob.ControlType := 'NoteName';
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;

    procedure   TFormWren.DoLights( const aSender: TMod; const aMsg: string);
    // A synth signal to be reflected in a module light
    var
      aTmp    : string; // use aTmp to avoid crashes in optimized code - see comments in ParsePrefix code
      aPrefix : string;
      aRest   : string;
      aModule : string;
      aSignal : string;
      aValue  : string;
      aMod    : TKnobsCustomModule;
      aVal    : TSignal;
    begin
      ParsePrefix( aMsg, aPrefix, aTmp);                // Strip off the container prefix
      ParsePrefix( aTmp, aModule, aRest);               // Strip off the module
      aMod  := PatchEditor.FindModule( aModule);        // Find the module in the editor
      if Assigned( aMod)
      then begin
        ParsePrefix( aRest, aSignal, aValue);           // Strip off the signal name
        aVal := StrToFloatDef( aValue, -1);             // which leaves the value ...
        aMod.SetLight( aSignal, aVal);
      end;
    end;

    procedure   TFormWren.DoData( const aSender: TMod; const aPath: string; const aData: TSignalArray);
    // A synth signal to be reflected in a module control
    var
      aTmp    : string; // use aTmp to avoid crashes in optimized code - see comments in ParsePrefix code
      aPrefix : string;
      aModule : string;
      aSignal : string;
      aMod    : TKnobsCustomModule;
    begin
      ParsePrefix( aPath, aPrefix, aTmp);               // Strip off the container prefix
      ParsePrefix( aTmp, aModule, aSignal);             // Strip off the module, leaving the signal name
      aMod  := PatchEditor.FindModule( aModule);        // Find the module in the editor
      if Assigned( aMod)
      then aMod.SetData( aSignal, aData);
    end;

    procedure   TFormWren.DoXYData( const aSender: TMod; const aPath: string; const aData: TSignalPairFifo);
    var
      aTmp    : string; // use aTmp to avoid crashes in optimized code - see comments in ParsePrefix code
      aPrefix : string;
      aModule : string;
      aSignal : string;
      aMod    : TKnobsCustomModule;
    begin
      ParsePrefix( aPath, aPrefix, aTmp);               // Strip off the container prefix
      ParsePrefix( aTmp, aModule, aSignal);             // Strip off the module, leaving the signal name
      aMod  := PatchEditor.FindModule( aModule);        // Find the module in the editor
      if Assigned( aMod)
      then aMod.SetXYData( aSignal, aData);
    end;

    procedure   TFormWren.DoInfo( const aSender: TMod; const aMsg: string);
    // A synth signal to be reflected in a module light
    var
      aTmp    : string; // use aTmp to avoid crashes in optimized code - see comments in ParsePrefix code
      aPrefix : string;
      aRest   : string;
      aModule : string;
      aSignal : string;
      aValue  : string;
      aMod    : TKnobsCustomModule;
    begin
      ParsePrefix( aMsg, aPrefix, aTmp);                // Strip off the container prefix
      ParsePrefix( aTmp, aModule, aRest);               // Strip off the module
      aMod  := PatchEditor.FindModule( aModule);        // Find the module in the editor
      if Assigned( aMod)
      then begin
        ParsePrefix( aRest, aSignal, aValue);           // Strip off the signal name
        aMod.SetInfo( aSignal, aValue);                 // which leaves the value ...
      end;
    end;

    procedure   TFormWren.DoPatchChanged( const aSender: TKnobsWirePanel);
    // The patch changed module, module-type or wire wise.
    begin
      CompilePatch;
    end;

    procedure   TFormWren.DoWiresChanged( const aSender: TKnobsWirePanel);
    // Patch wireing changed, currently nothing to do for that.
    // todo : on wire removal or addition there is no need to recompile the synth patch
    begin
    end;

    procedure   TFormWren.DoShowPopupMenu( const aSender: TKnobsWirePanel; const aControl: TControl);

      procedure ShowPopupConnector( aPopup: TPopupMenu; aControl: TControl);
      begin
        FPopupSender := aControl;
        aPopup.Popup( aControl.ClientOrigin.X + 10, aControl.ClientOrigin.Y + 10);
      end;

      procedure ShowPopupModule( aPopup: TPopupMenu; aControl: TControl);
      begin
        FPopupSender := aControl;
        aPopup.Popup( aControl.ClientOrigin.X + 10, aControl.ClientOrigin.Y + 10);
      end;

      procedure ShowPopupSelector( aPopup: TPopupMenu; aControl: TControl);
      var
        aSelector : TKnobsSelector;
        i         : Integer;
        aMenuItem : TMenuItem;
      begin
        FPopupSender  := aControl;
        aSelector     := TKnobsSelector( aControl);
        aPopup.Images := aSelector.Glyphs;

        with aSelector
        do begin
          RemoveSelectorMenuItems;

          if AllowAutomation
          then begin
            aMenuItem := TMenuItem.Create( PopupMenuSelector);

            with aMenuItem
            do begin
              if AssignedMIDICC = 0
              then Caption := 'MIDI CC ...'
              else Caption := Format( 'MIDI CC [%d] ...', [ AssignedMIDICC], AppLocale);
              OnClick := KnobMIDICCClick;
              Enabled := Assigned( aSelector) and aSelector.AllowAutomation
            end;

            PopupMenuSelector.Items.Add( aMenuItem);

            FLastFrozenCC := FlastCC;
            aMenuItem     := TMenuItem.Create( PopupMenuSelector);

            with aMenuItem
            do begin
              Caption := Format( 'Assign CC %d', [ FlastFrozenCC], AppLocale);
              OnClick := AssigntoCCClick;
              Enabled := ( FlastCC > 0) and Assigned( aSelector) and aSelector.AllowAutomation;
            end;

            PopupMenuSelector.Items.Add( aMenuItem);

            aMenuItem := TMenuItem.Create( PopupMenuSelector);

            with aMenuItem
            do begin
              Caption := Format( 'Unassign CC %d', [ AssignedMIDICC], AppLocale);
              OnClick := UnassignCCClick;
              Enabled := Assigned( aSelector) and aSelector.AllowAutomation and ( aSelector.AssignedMIDICC > 0);
            end;

            PopupMenuSelector.Items.Add( aMenuItem);


            if Captions.Count > 0
            then AddSelectorMenuItem( 0, '-');
          end;

          for i := 0 to Captions.Count - 1
          do AddSelectorMenuItem( i, Captions[ i]);
        end;

        aPopup.Popup( aControl.ClientOrigin.X + 10, aControl.ClientOrigin.Y + 10);
      end;

      procedure ShowPopupKnob( aPopup: TPopupMenu; aControl: TControl);
      begin
        FPopupSender := aControl;

        if aControl is TKnobsKnob
        then LockKnob.Checked := TKnobsKnob( aControl).Locked
        else LockKnob.Visible := False;

        if aControl is TKnobsValuedControl
        then begin
          if TKnobsValuedControl( aControl).AssignedMIDICC = 0
          then KnobMIDICC.Caption := 'MIDI CC ...'
          else KnobMIDICC.Caption := Format( 'MIDI CC [%d] ...', [ TKnobsValuedControl( aControl).AssignedMIDICC], AppLocale);
          KnobMIDICC.Enabled := TKnobsValuedControl( aControl).AllowAutomation;

          FLastFrozenCC := FLastCC;
          AssigntoCC.Caption := Format( 'Assign to CC %d', [ FlastFrozenCC], AppLocale);
          AssigntoCC.Enabled := ( FLastFrozenCC > 0) and TKnobsValuedControl( aControl).AllowAutomation;

          UnAssignCC.Caption := Format( 'Unassign CC %d', [ TKnobsValuedControl( aControl).AssignedMIDICC], AppLocale);
          UnAssignCC.Enabled := TKnobsValuedControl( aControl).AssignedMIDICC > 0;
        end;

        aPopup.Popup( aControl.ClientOrigin.X + 10, aControl.ClientOrigin.Y + 10);
      end;

    begin
      if aControl is TKnobsConnector
      then ShowPopupConnector( PopupMenuConnector, aControl)
      else if aControl is TKnobsModule
      then ShowPopupModule( PopupMenuModule, aControl)
      else if aControl is TKnobsSelector
      then ShowPopupSelector( PopupMenuSelector, aControl)
      else if aControl is TKnobsValuedControl
      then ShowPopupKnob( PopupMenuKnob, aControl);
    end;

    procedure   TFormWren.DoUnFocus( const aSender: TObject);
    begin
      if UseUnFocus
      then EditPark.SetFocus;
    end;

    function    TFormWren.Template1Name: string;
    begin
      Result := ApplicationPath + 'template1.wren';
    end;

    function    TFormWren.Template2Name: string;
    begin
      Result := ApplicationPath + 'template2.wren';
    end;

    function    TFormWren.CheckDiscardPatchChanges( const aReason: string; MustAsk: Boolean): Boolean;
    var
      MResult : TModalResult;
    begin
      if FPatchChanged and MustAsk
      then begin
        MResult := MessageDlg
        (
          'Requested operation:' + aReason                                     + ^M^M +
          '** The current patch has unsaved changes **'                        + ^M^M +
          'Do you want to save your changes before proceeding?'                + ^M^M +
          '- Yes - to save and proceeed with the requested operation'          + ^M   +
          '- No - to not save and proceed with the requested operation anyway' + ^M   +
          '- Cancel - to not do anything',
          mtWarning,
          [ mbYes, mbNo, mbCancel],
          0,
          mbYes
        );
        if MResult = mrYes
        then Result := SavePatch
        else if MResult = mrNo
        then Result := True
        else Result := False;
      end
      else Result := True;
    end;

    function    TFormWren.SavePatchNamed( const aFileName: string; WriteAlways: Boolean): Boolean;
    begin
      if FileExists( aFileName) or WriteAlways
      then begin
        LogFmt( 'Saving "%s"', [ aFileName]);
        FPatchWriter.WriteFile( PatchEditor, aFileName);
        if UndoAfterSave
        then PatchEditor.SetSavedMarker
        else PatchEditor.ClearUndoRedo;
        Result := True;
      end
      else Result := SavePatchAs;
    end;

    function    TFormWren.SavePatch: Boolean;
    begin
      Result := SavePatchNamed( PatchEditor.Filename, False);
    end;

    function    TFormWren.SavePatchAs: Boolean;
    begin
      Result := False;
      with SaveDialogPatch
      do begin
        if FileName = ''
        then Filename := PatchEditor.Filename;
        InitialDir := ExtractFilePath( Filename);
        FileName   := ExtractFileName( Filename);
        if InitialDir = ''
        then InitialDir := ApplicationPath + 'patches';
        if Execute
        then begin
          SourceFileName := FileName;
          PatchName      := CleanFileName( FileName);
          LogFmt( 'Saving patch as "%s"', [ FileName]);
          FPatchWriter.WriteFile( PatchEditor, FileName);
          if UndoAfterSave
          then PatchEditor.SetSavedMarker
          else PatchEditor.ClearUndoRedo;
          Result := True;
        end;
      end;
    end;

    function    TFormWren.SaveAsTemplate( const aFileName: string): Boolean;
    var
      DoSave  : Boolean;
      OldName : string;
    begin
      if FileExists( aFileName)
      then DoSave := MessageDlg( Format( '"%s" already exists, overwrite it?', [ aFileName]), mtConfirmation, [ mbYes, mbNo], 0) = mrYes
      else DoSave := True;
      if DoSave
      then begin
        OldName   := PatchName;
        Result    := SavePatchNamed( aFileName, True);
        PatchName := OldName;
      end
      else Result := False;
    end;

    function    TFormWren.SaveAsTemplate1: Boolean;
    begin
      Result := SaveAsTemplate( Template1Name);
    end;

    function    TFormWren.SaveAsTemplate2: Boolean;
    begin
      Result := SaveAsTemplate( Template2Name);
    end;

    procedure   TFormWren.ExportModules;
    begin
      with SaveDialogPatch
      do begin
        if FileName = ''
        then Filename := PatchEditor.Filename;
        InitialDir := ExtractFilePath( Filename);
        FileName   := ExtractFileName( Filename);
        if InitialDir = ''
        then InitialDir := ApplicationPath + 'patches';
        if Execute
        then begin
          SourceFileName := FileName;
          PatchName      := CleanFileName( FileName);
          LogFmt( 'Exporting selected modules to "%s"', [ FileName]);
          FPatchWriter.WriteFile( PatchEditor, FileName, wmSelected);
        end;
      end;
    end;

    procedure   TFormWren.DoLoadPatch( const aFileName: string; ChangePatchName: Boolean);
    var
      OldName   : string;
      OldSource : string;
    begin
      if FileExists( aFileName)
      then begin
        if CheckDiscardPatchChanges( 'Load a new patch', WarnChangeOnLoad)
        then begin
          OldName   := PatchName;
          OldSource := SourceFileName;
          PatchEditor.BlockScreenUpdates;
          try
            LogFmt( 'loading file %s', [ aFileName]);
            SourceFileName := aFileName;
            try
              FPatchReader.ReadFile( aFileName, PatchEditor, rmReplace);
              if ChangePatchName
              then PatchName := PatchEditor.Title
              else begin
                PatchName      := OldName;
                SourceFileName := OldSource;
              end;
              if UndoAfterLoad
              then PatchEditor.SetSavedMarker
              else PatchEditor.ClearUndoRedo;
              PatchEditor.UnSelectAllModules;
              RegisterMidiControls;
            except
              on E: Exception
              do begin
                LogFmt( 'loading failed with message ''%s''', [ E.Message]);
                PatchEditor.Undo;
                MessageDlg( Format( 'Patch load failed with message ''%s''', [ E.Message], AppLocale), mtError, [ mbOK], 0);
              end;
            end;
            ClearVolumeIndicators;
          finally
            PatchEditor.UnblockScreenUpdates;
          end;
        end;
      end;
    end;

    procedure   TFormWren.DoImportPatch( const aFileName: string);
    // todo : modules need be in drag mode after paste ...
    begin
      if FileExists( aFileName)
      then begin
        PatchEditor.BlockScreenUpdates;
        try
          LogFmt( 'importing file %s', [ aFileName]);
          try
            FPatchReader.ReadFile( aFileName, PatchEditor, rmAppend);
            RegisterMidiControls;
          except
            on E: Exception
            do begin
              LogFmt( 'importing failed with message ''%s''', [ E.Message]);
              PatchEditor.Undo;
              MessageDlg( Format( 'Patch import fialed with message ''%s''', [ E.Message], AppLocale), mtError, [ mbOK], 0);
            end;
          end;
        finally
          PatchEditor.UnblockScreenUpdates;
        end;
      end;
    end;

    procedure   TFormWren.LoadPatch;
    begin
      with OpenDialogPatch
      do begin
        if FileName = ''
        then Filename := PatchEditor.Filename;
        InitialDir := ExtractFilePath( Filename);
        FileName   := ExtractFileName( Filename);
        if InitialDir = ''
        then InitialDir := ApplicationPath + 'patches';
        if Execute
        then DoLoadPatch( FileName, True);
      end;
    end;

    procedure   TFormWren.ImportPatch;
    begin
      with OpenDialogPatch
      do begin
        InitialDir := ApplicationPath;
        if Execute
        then DoImportPatch( FileName);
      end;
    end;

    procedure   TFormWren.NewPatch;
    begin
      SourceFileName := 'new';
      if Assigned( PatchEditor)
      then begin
        PatchEditor.FreeModules;
        PatchEditor  .Title := 'new';
        EditPatchName.Text  := 'new';
      end;
    end;

    procedure   TFormWren.DeleteModules;
    begin
      if Assigned( PatchEditor)
      then PatchEditor.FreeSelectedModules;
    end;

    procedure   TFormWren.CutModules;
    begin
      CopyModules;
      DeleteModules;
    end;

    procedure   TFormWren.CopyModules;
    begin
      if Assigned( FPatchWriter)
      then FPatchWriter.WriteToClipboard( PatchEditor, wmSelected);
    end;

    procedure   TFormWren.PasteModules;
    begin
      // Note : PasteModules (ReadFromClipboard) should not alter Midi CC assignments.
      if Assigned( FPatchReader)
      then FPatchReader.ReadFromClipboard( PatchEditor, rmAppend);
    end;

    procedure   TFormWren.PasteParameters;
    begin
      // Note : PasteParameters (ParamsFromClipboard) should not alter Midi CC assignments.
      if Assigned( FPatchReader)
      then FPatchReader.ParamsFromClipboard( PatchEditor);
    end;

    procedure   TFormWren.SelectAll;
    begin
      if Assigned( PatchEditor)
      then PatchEditor.SelectAllModules;
    end;

    procedure   TFormWren.SelectNone;
    begin
      if Assigned( PatchEditor)
      then PatchEditor.UnselectAllModules;
    end;

    procedure   TFormWren.InvertSelection;
    begin
      if Assigned( PatchEditor)
      then PatchEditor.InvertModuleSelection;
    end;

    procedure   TFormWren.WiggleWires;
    begin
      if Assigned( PatchEditor)
      then PatchEditor.WiggleWires;
    end;

    procedure   TFormWren.SearchPatch( const aValue: string);
    begin
      if Assigned( PatchEditor)
      then PatchEditor.Search( aValue);
    end;

    procedure   TFormWren.FindUnconnectedModules;
    begin
      if Assigned( PatchEditor)
      then PatchEditor.FindUnconnectedModules;
    end;

    procedure   TFormWren.CollectSmallValues;
    var
      aMap      : TPinMaps;
      aList     : TStringList;
      i         : Integer;
      j         : Integer;
      S         : string;
      anIns     : string;
      anOuts    : string;
      aName     : string;
      aTitle    : string;
      aPin      : string;
    begin
      if Assigned( FSynthPatch)
      then begin
        aList := TStringList.Create;
        try
          if Assigned( PatchEditor)
          then PatchEditor.UnSelectAllModules;

          FSynthPatch.CollectSmallValues( SMALL_VALUE, aMap);

          for i := 0 to Length( aMap) - 1
          do begin
            if ( aMap[ i].Ins <> []) or ( aMap[ i].Outs <> [])
            then begin
              aName := FSynthPatch.ModuleName( aMap[ i].ModuleIndex);

              if Assigned( PatchEditor)
              then aTitle := PatchEditor.FindTitle( aName)
              else aTitle := '';

              anIns := '[';
              for j := 0 to FSynthPatch.Module[ aMap[ i].ModuleIndex].InputCount - 1
              do begin
                if j in aMap[ i].Ins
                then begin
                  if Assigned( PatchEditor)
                  then aPin := FSynthPatch.InputPinName( aMap[ i].ModuleIndex, j)
                  else aPin := IntToStr( j);
                  anIns := Format( '%s %s', [ anIns, aPin]);
                end;
              end;
              anIns := anIns + ']';

              anOuts := '[';
              for j := 0 to FSynthPatch.Module[ aMap[ i].ModuleIndex].OutputCount - 1
              do begin
                if j in aMap[ i].Outs
                then begin
                  if Assigned( PatchEditor)
                  then aPin := FSynthPatch.OutputPinName( aMap[ i].ModuleIndex, j)
                  else aPin := IntToStr( j);
                  anOuts := Format( '%s %s', [ anOuts, aPin]);
                end;
              end;
              anOuts := anOuts + ']';

              S := Format( '  %s [%s] %s %s', [ aName, aTitle, anIns, anOuts]);
              aList.Add( S);

              if Assigned( PatchEditor)
              then PatchEditor.AddToSelection( aName);
            end;
          end;
          if aList.Count > 0
          then begin
            Log( '---- small values:');
            for i := 0 to aList.Count - 1
            do Log( aList[ i]);
            Log( '---- end');
          end
          else Log( 'No small values found');
        finally
          aList.DisposeOf;
        end;
      end;
    end;

//  private

    function    TFormWren.FunctionalPinName( const aName: string): string;
    var
      aList: TStringList;
    begin
      aList  := Explode( aName, '_');
      Result := '';
      try
        if aList.Count = 2
        then Result := aList[ 1];
      finally
        aList.DisposeOf;
      end;
    end;

    function    TFormWren.SplitConnectorName( const aName: string; var aMod, aPin: string): Boolean;
    var
      aList: TStringList;
    begin
      aMod   := '';
      aPin   := '';
      Result := False;
      aList  := Explode( aName, '.');
      try
        if aList.Count = 2
        then begin
          aMod   := aList[ 0];
          aPin   := aList[ 1];
          Result := not ( SameText( aMod, '<nil>') or SameText( aPin, '<nil>'));
          if Result
          then aPin := FunctionalPinName( aPin);
        end;
      finally
        aList.DisposeOf;
      end;
    end;

    function    TFormWren.ModuleTypeToModule( aType: Integer; const aParent: TSynthPatch; const aName: string): TMod;
    // This couples an editor module ID to it's synth implementation
    // Stuff that needs or can not be compiled, i.e. 'editor only' modules should return nil here
    var
      M : TModuleClass;
    begin
      Result := nil;
      M      := LookupModuleClass( aType);
      if Assigned( M) and Assigned( aParent)
      then Result := M.Create( aParent, aName);
    end;

    procedure   TFormWren.CompilePatch;
    // This creates a synth patch from an editor patch and then
    // changes the the current synth patch for the new one.
    var
      aSynthPatch   : TSynthPatch;
      i             : Integer;
      aPatchModule  : TKnobsCustomModule;
      aModuleType   : Integer;
      aModuleName   : string;
      aModule       : TMod;
      S             : string;
      aSrcMod       : string;
      aSrcPin       : string;
      aDstMod       : string;
      aDstPin       : string;
      aSignalSpecs  : TKnobsModuleSignalSpecs;
    begin
      Log( 'compiling synth patch');
      if Assigned( PatchEditor)
      then begin
        try
          if ClearVUOnRecompile
          then ResetPeaks;

          FixModuleStatics;
          aSignalSpecs := TKnobsModuleSignalSpecs.Create( PatchEditor);

          try
            aSynthPatch := TSynthPatch.Create( nil, PatchName);

            try
              aSynthPatch.Version       := PatchEditor.Version;
              aSynthPatch.OnSynthLog    := DoSynthLog;
              aSynthPatch.OnSynthError  := DoSynthError;
              TimerLightsUpdate.Enabled := False;

              with PatchEditor
              do begin
                FixAllWires;                                 // Get the wire directions right before wire compilation

                Log( 'compiling synth patch - modules');

                for i := 0 to ModuleCount - 1
                do begin
                  aPatchModule := Module[ i];
                  aModuleType  := aPatchModule.ModuleType;
                  aModuleName  := aPatchModule.Name;
                  aModule      := ModuleTypeToModule( aModuleType, aSynthPatch, aModuleName);


                  if Assigned( aModule)                      // Module translates, add it, set it's OSC properties and speed it up if needed
                  then begin
                    aSynthPatch.AddModule( aModule);
                    if aPatchModule.IsSpedUp
                    then begin
                      if aModule.IsFast
                      then LogFmt( 'Tried to speed up fast module type %s, this is not allowed', [ aModule.ClassName])
                      else aModule.MakeFast;
                    end;
                  end;
                end;

                // todo: Log( 'compiling synth patch - apply mappings'); // Apply mappings to aSignalSpecs

                Log( 'compiling synth patch - wires');

                for i := 0 to WireCount - 1
                do begin
                  if
                    SplitConnectorName( Wire[ i].SourceName     , aSrcMod, aSrcPin) and
                    SplitConnectorName( Wire[ i].DestinationName, aDstMod, aDstPin)
                  then begin
                    try
                      aSynthPatch.AddConnection( aSrcMod, aSrcPin, aDstMod, aDstPin);
                    except
                      on E: Exception
                      do LogFmt( 'Error adding connection: ''%s''', [ E.Message]);
                    end;
                  end;
                end;
                aSynthPatch.MidiChannel := MidiChannel;

                Log( 'compiling synth patch - switching in new synth patch');

                if not ChangeSynthPatch( aSynthPatch)
                then FreeAndNil( aSynthPatch);

                // done :: maybe add FSynthPatch.FixZippers; here .. if assigned .. hmm .. startaudioin should do this and changesynthpatch too :s
                // still .. it does fix the issue of glides after a patch compile ... hmmm

                if Assigned( FSynthPatch)
                then begin
                  Log( 'compiling synth patch - post processing');

                  FSynthPatch.FixZippers;
                  FSynthPatch.Reset;

                  // Some debug stuff - write the just created synth patch to test.txt - in the current (application) directory

                  if CompilerDebug
                  then begin
                    try
                      S := '';
                      FSynthPatch.Save( 0, S);
                      StringTofile( S, 'test.txt');

                      if Assigned( aSignalSpecs)
                      then aSignalSpecs.Dump( 'signalspecs.txt');
                    except
                      on E: Exception
                      do KilledException( E);
                    end;
                  end;
                end
                else Log( 'compiling synth patch - No new synth patch, this is odd, but no post processing needed in that case');

              end; // with WirePanel ..

              TimerLightsUpdate.Enabled := True;
              ClearOverUnderFlows;

              Log( 'compiled synth patch');
            except
              on E: Exception
              do begin
                LogFmt( 'Error compiling synth patch: %s', [ E.Message]);
                FreeAndNil( aSynthPatch);
              end;
            end;
          finally
            if Assigned( aSignalSpecs)
            then aSignalSpecs.DisposeOf;
          end;
        except
          on E: Exception
          do LogFmt( 'Error in compilation: %s', [ E.Message]);
        end;
      end; // if Assigned( aWirePanel)
    end;

    procedure   TFormWren.RegisterMidiControls;
    var
      aList    : TStringList;
      i        : Integer;
      aControl : TKnobsValuedControl;
    begin
      if Assigned( PatchEditor) and Assigned( FormSelectMidiCC)
      then begin
        aList             := PatchEditor.CreateMidiCCList;
        aList.Sorted      := False;
        aList.OwnsObjects := False;
        aList.Duplicates  := dupError;

        if Assigned( aList)
        then begin
          try
            FormSelectMidiCC.UnregisterComtrolNames;
            for i := 0 to aList.Count - 1
            do begin
              if aList.Objects[ i] is TKnobsValuedControl
              then begin
                aControl := TKnobsValuedControl( aList.Objects[ i]);
                FormSelectMidiCC.RegisterControlName( i + 1, MakeMidiCCName( aControl), aControl);
              end;
            end;
          finally
            aList.DisposeOf;
          end;
        end;
      end;
    end;

//  private

    procedure   TFormWren.FixTuningAndSampleRate;
    begin
      ComputeTables;                                // Recalculate all tables
      HrastUnit.CreateTables;                       // Recalculate Hrast lookup tables too
      if Assigned( FSynthPatch)                     // Give modules a change to recompute stuff too
      then FSynthPatch.SampleRateChanged;
      if Assigned( PatchEditor)                     // Frequency displays and such may need to reflect a new sample rate
      then PatchEditor.InvalidateDisplays;
    end;

    procedure   TFormWren.ApplyTuning;
    begin
      KnobsConversions.ReferenceA        := ReferenceA;
      KnobsConversions.NotesPerOctave    := NotesPerOctave;
      KnobsConversions.NotesPerOctaveRec := 1.0 / NotesPerOctave;
      KnobsConversions.MiddleNote        := MiddleNote;
      FixTuningAndSampleRate;
      TuningChanged                   := False;
    end;

    procedure   TFormWren.CancelTuning;
    begin
      ReferenceA     := KnobsConversions.ReferenceA;
      NotesPerOctave := KnobsConversions.NotesPerOctave;
      MiddleNote     := KnobsConversions.MiddleNote;
      TuningChanged  := False;
    end;

//  private

    procedure   TFormWren.InitializeCPUCounter;
    begin
      FCpuUsageData := CreateCpuUsageCounter( GetCurrentProcessId);
    end;

    procedure   TFormWren.FinalizeCPUCounter;
    begin
      if Assigned( FCpuUsageData)
      then begin
        DestroyCpuUsageCounter( FCpuUsageData);
        FCpuUsageData := nil;
      end;
    end;

    procedure   TFormWren.TickCPUCounter;
    begin
      if Assigned( FCpuUsageData)
      then FProcessTime := ( FProcessTime + 2 * GetCpuUsage( FCpuUsageData) / CpuCount) / 3
      else FProcessTime := -1;
    end;

//  private

    procedure   TFormWren.StartNetMidiConnectTimer;
    begin
      StopNetMidiConnectTimer;
      TimerNetMidiConnect.Interval := 1000;
      TimerNetMidiConnect.Enabled  := True;
    end;

    procedure   TFormWren.StopNetMidiConnectTimer;
    begin
      TimerNetMidiConnect.Enabled  := False;
    end;

    procedure   TFormWren.NetMidiConnectTimerFired;
    begin
      if NetMidiAutoConnect and not NetMidiConnected
      then NetMidiConnect;
    end;

    procedure   TFormWren.NetMidiConnect;
    begin
      if not NetMidiConnected
      then begin
        // set net midi connect params
        WSocketNetMidi.Addr := NetMidiServer;
        WSocketNetMidi.Port := NetMidiPort;
        // start net midi client
        WSocketNetMidi.Connect;
      end;
    end;

    procedure   TFormWren.NetMidiDisconnect;
    begin
      if NetMidiConnected
      then begin
        // stop net midi client
        WSocketNetMidi.Close;
      end;
    end;

    procedure   TFormWren.NetMidiApply;
    var
      WasConnected : Boolean;
    begin
      WasConnected := NetMidiConnected;
      NetMidiDisconnect;
      NetMidiServer := EditNetMidiServer.Text;
      NetMidiPort   := EditNetMidiPort  .Text;
      if WasConnected
      then NetMidiConnect;
      NetMidiChanged := False;
    end;

    procedure   TFormWren.NetMidiCancel;
    begin
      EditNetMidiServer.Text := NetMidiServer;
      EditNetMidiPort  .Text := NetMidiPort;
      NetMidiChanged := False;
    end;

    procedure   TFormWren.ReceiveNetMidi;
    const
      BufSize = 1024;
    var
      aBuffer : packed array[ 0 .. BufSize - 1] of Byte;
      aCount  : Integer;
    begin
      aCount := WSocketNetMidi.Receive( @ aBuffer, BufSize);
      if ( aCount > 0) and Assigned( FMidiReceiver) and Assigned( FSynthPatch) and FAudioInRunning and FAudioOutRunning
      then FMidiReceiver.AcceptBytes( BytesFromByteArray( aBuffer, aCount));
    end;

    procedure   TFormWren.SendNetMidi( const aData: TBytes);
    const
      MaxBufSize = 4096;
    type
      TPackedBytes = packed array[ 0 .. MaxBufSize - 1] of Byte;
      PPackedBytes = ^TPackedBytes;
    var
      Bytes : PPackedBytes;
      Res   : Integer;
    begin
      if ( Length( aData) > 0) and ( Length( aData) < MaxBufSize)
      then begin
        GetMem( Bytes, Length( aData));
        try
          // todo: test if MIDI send still works
          ByteArrayFromBytes( aData, Bytes^, Length( aData));
          Res := WSocketNetMidi.Send( Bytes, Length( aData));
          if Res < 0
          then MidiLogFmt( 'TX error : %d', [ Res]);
        finally
          FreeMem( Bytes);
        end;
      end
      else begin
        if Length( aData) > MaxBufSize
        then MidiLogFmt( 'TX error: tried to send more (%d) than MaxBufSize (%d) bytes, data dropped', [ Length( aData), MaxBufSize]);
      end;
    end;

//  private

    procedure   TFormWren.DoMidiRxMessage( const aSender: TObject; const aMsg: TMidiMessage);
    var
      aParts      : TStringList;
      aModule     : string;
      aControl    : string;
      aController : TKnobsValuedControl;
      aValue      : Byte;
      aSteps      : Integer;
      aPos        : Integer;
    begin
      if Assigned( FSynthPatch) and ( FAudioInRunning and FAudioOutRunning)
      then begin
        FSynthPatch.AcceptMidi( aMsg);

        if (( aMsg.Channel = MidiChannel) or ( MidiChannel = MIDI_CH_OMNI)) and ( aMsg.Command = CControlChange)
        then begin
          FLastCC := aMsg.Data[ 0];

          if Assigned( FormSelectMidiCC)
          then begin
            aController := FormSelectMidiCC.CCToController( aMsg.Data[ 0]);
            if Assigned( aController)
            then begin
              aParts := Explode( FormSelectMidiCC.CCToControlName( aMsg.Data[ 0]), '_');
              try
                if aParts.Count = 2
                then begin
                  aModule  := aParts[ 0];
                  aControl := aParts[ 1];
                  aValue   := aMsg.Data[ 1];
                  aSteps   := aController.StepCount;
                  aPos     := Round( RangeMap( aValue, 0, 127, 0, aSteps));
                  try
                    aController.AutomationPosition := aPos;
                  except
                    on E: Exception
                    do KilledException( E);
                  end;
                end;
              finally
                aParts.DisposeOf;
              end;
            end;
          end;
        end;

        MidiMsgLogFmt( 'RX : %s', [ MidiMessageToLog( aMsg)]);
      end;
    end;

    procedure   TFormWren.DoMidiTxMessage( const aSender: TObject; const aMsg: TMidiMessage);
    var
      aData : TBytes;
    begin
      MidiMessageToBytes( aMsg, aData);
      SendNetMidi( aData);
      MidiMsgLogFmt( 'TX : %s', [ MidiMessageToLog( aMsg)]);
    end;

    procedure   TFormWren.DoSynthLog( const aSender: TObject; const aMsg: string);
    begin
      LogFmt( 'synth: %s', [ aMsg]);
    end;

    procedure   TFormWren.DoSynthError( const aSender: TObject; const aMsg: string);
    begin
      LogFmt( 'synth: %s', [ aMsg]);
      ViewDebug;
    end;

// private

    procedure   TFormWren.ResetInPeaks;
    begin
      FDbMinMaxIn[ 1].Clear;
      FDbMinMaxIn[ 2].Clear;
      FDbMinMaxIn[ 3].Clear;
      FDbMinMaxIn[ 4].Clear;
      FDbMinMaxIn[ 5].Clear;
      FDbMinMaxIn[ 6].Clear;
      FDbMinMaxIn[ 7].Clear;
      FDbMinMaxIn[ 8].Clear;
      UpdateDbLabels;
    end;

    procedure   TFormWren.ResetOutPeaks;
    begin
      FDbMinMaxOut[ 1].Clear;
      FDbMinMaxOut[ 2].Clear;
      FDbMinMaxOut[ 3].Clear;
      FDbMinMaxOut[ 4].Clear;
      FDbMinMaxOut[ 5].Clear;
      FDbMinMaxOut[ 6].Clear;
      FDbMinMaxOut[ 7].Clear;
      FDbMinMaxOut[ 8].Clear;
      UpdateDbLabels;
    end;

    procedure   TFormWren.ResetPeaks;
    begin
      ResetInPeaks;
      ResetOutPeaks;
    end;

    procedure   TFormWren.ClearVUMeters;
    begin
      ResetPeaks;
    end;

    procedure   TFormWren.MemoDebugWindowProc( var aMsg: TMessage);
    var
      aTicks     : SmallInt;
      aScrollMsg : TWMVScroll;
    begin
      if aMsg.Msg = WM_MOUSEWHEEL
      then begin
          aScrollMsg.Msg := WM_VSCROLL;
          aTicks         := SmallInt( HiWord( aMsg.WParam));
          if aTicks > 0
          then aScrollMsg.ScrollCode := SB_LINEUP
          else aScrollMsg.ScrollCode := SB_LINEDOWN;

          aScrollMsg.Pos := 0;
          MemoDebug.Dispatch( aScrollMsg) ;
        end
      else FOldMemoDebug( aMsg);
    end;

//  private


    procedure   TFormWren.UMOSCString( var aMsg: TMsgOSCData); //message UM_OSCDATA;
    begin
      try
        while FOSCFifo.FillCount > 0
        do SendOSCBytes( FOSCFifo.GetData);
      except
        on E: Exception
        do KilledException( E);
      end;
    end;

    procedure   TFormWren.SendOSCBytes( const aMsg: TBytes);
    begin
      try
        if UseOSC and ( WSocketOSC.State = wsConnected) and ( OSCServer <> '')
        then begin
          WSocketOSC.Send( @ aMsg[ 0], Length( aMsg));
          LogOSCMessage( aMsg, 'out');
        end;
      except
        on E: Exception
        do KilledException( E);
      end;
    end;

    procedure   TFormWren.QueueOSCBytes( const aMsg: TBytes);
    begin
      try
        if UseOSC and ( WSocketOSC.State = wsConnected) and ( OSCServer <> '')
        then begin
          FOSCFifo.Append( aMsg);
          PostMessage( Handle, UM_OSCDATA, 0, 0);
        end;
      except
        on E: Exception
        do KilledException( E);
      end;
    end;

    procedure   TFormWren.DoSendOSCBytes( const aSender: TObject; const aMsg: TBytes);
    begin
      try
        QueueOSCBytes( aMsg);
      except
        on E: Exception
        do KilledException( E);
      end;
    end;

    procedure   TFormWren.SendOSCTestMessage;
    var
      anOSCMessage: TOSCMessage;
    begin
      anOSCMessage := TOSCMessage.Create( TEST_PACKET_NAME);
      try
        anOSCMessage.AddFloat  ( 1.000 ); // Send float first, so an OScMessage module can pick it up.
        anOSCMessage.AddInteger( 1001  );
        anOSCMessage.AddString ( '1002');
        SendOSCBytes( anOSCMessage.ToOSCBytes);
      finally
        FreeAndNil( anOSCMessage);
      end;
    end;

//    procedure   TFormWren.SendOSCMidi( const anAddress: string; aPort, aChannel, aMessage: Byte; aParam1: Byte = $ff; aParam2: Byte = $ff);
//    var
//      anOSCMessage: TOSCMessage;
//    begin
//      anOSCMessage := TOSCMessage.Create( anAddress);
//      try
//        anOSCMessage.AddMIDI( aPort, aChannel, aMessage, aParam1, aParam2);
//        SendOSCBytes( anOSCMessage.ToOSCBytes);
//      finally
//        FreeAndNil( anOSCMessage);
//      end;
//    end;

    procedure   TFormWren.HandleLocalOSCPacket( anOSCPacket: TOSCPacket);
    begin
      // nothing yet .. may do volume controls .. for instance
    end;

    function    TFormWren.OscHandler( const aControl: TControl; aControlClass: TControlClass; const aUserData: TObject): Boolean;
    var
      aValuedControl : TKnobsValuedControl;
      anOSCPacket    : TOSCPacket;
      aModule        : TKnobsCustomModule;
      aModuleName    : string;
      anOSCPattern   : string;
      aLocMsg        : TOSCMessage;
      aValue         : TSignal;
      aSteps         : Integer;
      aPos           : Integer;
    begin
      Result := True;
      if ( aUserData is TOSCPacket) and ( aControl is TKnobsValuedControl)
      then begin
        aValuedControl := TKnobsValuedControl( aControl);

        if aValuedControl.AllowAutomation
        then begin
          if Assigned( aValuedControl.Parent) and ( aValuedControl.Parent is TKnobsCustomModule)
          then begin
            aModule := TKnobsCustomModule( aValuedControl.Parent);

            if ( Length( aModule.Name) > 0) and ( aModule.Name[ Low( aModule.Name)] = '@')
            then begin
              aModuleName := Copy( aModule.Name, Low( aModule.Name) + 1, Length( aModule.Name) - 1);

              if aModuleName <> ''
              then begin
                anOSCPattern  := Format( '/%s/%s/%s', [ SynthName, aModuleName, aValuedControl.Name], AppLocale);
                anOSCPacket   := TOSCPacket( aUserData);
                aLocMsg       := anOSCPacket.MatchAddress( anOSCPattern);

                if Assigned( aLocMsg)
                then begin
                  aLocMsg.Decode;
                  if SameText( string( aLocMsg.TypeTag[ 0]), 'f')
                  then begin
                    aValue := Clip( aLocMsg.ArgumentAsFloat[ 0], 0.0, 1.0);
                    aSteps := aValuedControl.StepCount;
                    aPos   := Round( RangeMap( aValue, 0.0, 1.0, 0.0, aSteps));
                    Result := False;
                    try
                      aValuedControl.AutomationPosition := aPos;
                    except
                      on E: Exception
                      do KilledException( E);
                    end;
                  end;
                end
              end;
            end;
          end;
        end;
      end;
    end;

    procedure   TFormWren.AcceptOSCBytes( const aMsg: TBytes);
    var
      anOSCPacket : TOSCPacket;
    begin
      try
        anOSCPacket := TOSCPacket.Unpack( aMsg, Length( aMsg));
        try
          if Assigned( anOSCPacket)
          then begin
            if Assigned( FSynthPatch) and ( FAudioInRunning and FAudioOutRunning)
            then FSynthPatch.AcceptOSC( SynthName, anOSCPacket);

            if not anOSCPacket.Matched
            then begin
              if Assigned( PatchEditor) and ( FAudioInRunning and FAudioOutRunning)
              then PatchEditor.VisitControls( 0, nil, '', OscHandler, anOSCPacket);

              if not anOSCPacket.Matched
              then HandleLocalOSCPacket( anOSCPacket);
            end;

            LogOSCMessage( aMsg, 'in ');
          end;
        finally
          anOSCPacket.DisposeOf;
        end;
        LedOSCRx1.Active := True;
        LedOSCRx2.Active := True;
      except
        on E: Exception
        do KilledException( E);
      end;
    end;

    procedure   TFormWren.LogOSCMessage( const aMsg: TBytes; const aLabel: string);
    var
      anOSCPacket : TOSCPacket;
      aLocMsg     : TOSCMessage;
    begin
      if LogOSCMsgs
      then begin
        anOSCPacket := TOSCPacket.Unpack( aMsg, Length( aMsg));
        try
          if Assigned( anOSCPacket)
          then begin
            aLocMsg := anOSCPacket.MatchAddress( '*');
            if Assigned( aLocMsg)
            then begin
              aLocMsg.Decode;
              OSCMsgLogFmt( '%s: %s', [ aLabel, aLocMsg.AsString( NO_REVERSE)]);
            end;
          end;
        finally
          anOSCPacket.DisposeOf;
        end;
      end;
    end;

    procedure   TFormWren.HandleOSCReception;
    type
      TBuffer = array[ 0 .. MaxInt div SizeOf( Byte) - 1] of Byte;
      PBuffer = ^TBuffer;
    var
      aData   : TBytes;
      i       : Integer;
      aBuffer : PBuffer;
      aSize   : Integer;
      bSize   : Integer;
    begin
      try
        aSize := 32768;
        GetMem( aBuffer, aSize);
        try
          bSize := WSocketOSC.Receive( aBuffer, aSize);
          if bSize > 0
          then begin
            SetLength( aData, bSize);
            for i := 0 to bSize - 1
            do aData[ i] := aBuffer^[ i];
            AcceptOSCBytes( aData);
          end;
        finally
          FreeMem( aBuffer, aSize);
        end;
      except
        on E: Exception
        do KilledException( E);
      end;
    end;

    procedure   TFormWren.OSCCancel;
    begin
      EditOSCServer .Text    := OSCServer;
      EditOSCPort   .Text    := OSCPort;
      CheckBoxUseOSC.Checked := UseOSC;
      EditSynthName .Text    := SynthName;
      OSCChanged := False;
    end;

    procedure   TFormWren.OSCApply;
    begin
      OSCDisable;
      OSCServer  := EditOSCServer .Text;
      OSCPort    := EditOSCPort   .Text;
      UseOSC     := CheckBoxUseOSC.Checked;
      SynthName  := EditSynthName .Text;
      OSCChanged := False;
      if UseOSC
      then StartOSCGuard;
      LedOSCEnabled.Active := UseOSC;
    end;

    procedure   TFormWren.OSCEnable;
    begin
      if UseOSC
      then begin
        try
          WSocketOSC.Port := OSCPort;

          if OSCServer = ''                       // We are a server - that is we receive broadcasts
          then begin
            OSCLog( 'Setting up server mode');
            WSocketOSC.Proto     := 'udp';
            WSocketOSC.Addr      := '0.0.0.0';
            WSocketOSC.ReuseAddr := True;
            WSocketOSC.Listen;
            BitBtnSendOSCTestMessage.Visible := False;
            StartOSCGuard;
          end
          else begin                              // We are a client, that is we send broadcasts
            OSCLog( 'Setting up client mode');
            WSocketOSC.Proto     := 'udp';
            WSocketOSC.Addr      := OSCServer;
            WSocketOSC.ReuseAddr := False;
            WSocketOSC.Connect;
            BitBtnSendOSCTestMessage.Visible := True;
            StartOSCGuard;
          end;
        except
          on E: Exception
          do OSCLogFmt( 'Error opening socket : %s', [ E.Message]);
        end;
      end;
    end;

    procedure   TFormWren.OSCDisable;
    begin
      try
        if WSocketOSC.State <> wsClosed
        then begin
          OSCLog( 'Shutting down');
          StopOSCGuard;
          WSocketOSC.CloseDelayed;
        end;
      except
        on E: Exception
        do OSCMsgLogFmt( 'Error closing socket: %s', [ E.Message]);
      end;
    end;

    procedure   TFormWren.StartOSCGuard;
    begin
      StopOSCGuard;
      TimerOSCGuard.Interval := 1000;
      TimerOSCGuard.Enabled  := True;
    end;

    procedure   TFormWren.StopOSCGuard;
    begin
      TimerOSCGuard.Enabled := False;
    end;

    procedure   TFormWren.OSCGuardFired;
    begin
      StopOSCGuard;
      if ( WSocketOSC.State = wsClosed) and UseOSC and not ( csDestroying in ComponentState)
      then OSCEnable;
    end;

// public

    function    TFormWren.IsShortCut( var aMessage: TWMKey): Boolean; // override;
    begin
      if PatchEditor.HasEditPopup
      then Result := False
      else Result := inherited IsShortcut( aMessage);
    end;

// Delphi area


procedure TFormWren.UnassignCCClick(Sender: TObject);
begin
  if FPopupSender is TKnobsValuedControl
  then UnAssignMidiCC( FPopupSender as TKnobsValuedControl);
end;

procedure TFormWren.AssigntoCCClick(Sender: TObject);
begin
  if FPopupSender is TKnobsValuedControl
  then AssignLastCCToKnob( FPopupSender as TKnobsValuedControl);
end;

procedure TFormWren.main_midichValueChanged(const aSender: TObject; const aPath, aControlType: string; aValue: Double;
  IsFinal, IsAutomation: Boolean);
begin
  MidiChannel := Round( aValue);
end;

procedure TFormWren.Defaultcolor1Click(Sender: TObject);
begin
  ModuleColorDefault( FPopupSender as TKnobsModule);
end;

procedure TFormWren.Defaultwirecolor1Click(Sender: TObject);
begin
  SetWireColorDefault( FPopupSender as TKnobsConnector);
end;

procedure TFormWren.Redwires1Click(Sender: TObject);
begin
  SetWireColor( FPopupSender as TKnobsConnector, clRed);
end;

procedure TFormWren.MakeGreenClick(Sender: TObject);
begin
  SetWireColor( FPopupSender as TKnobsConnector, clGreen);
end;

procedure TFormWren.ModuleHelpClick(Sender: TObject);
begin
  ShowModuleHelp( FPopupSender as TKnobsModule);
end;

procedure TFormWren.MenuEditPasteValuesClick(Sender: TObject);
begin
  PasteParameters;
end;

procedure TFormWren.MenuActionRecompileClick(Sender: TObject);
begin
  CompilePatch;
end;

procedure TFormWren.MenuActionResetClick(Sender: TObject);
begin
  if Assigned( FSynthPatch)
  then begin
    FSynthPatch.Reset;
    ClearOverUnderFlows;
  end;
end;

procedure TFormWren.MenuFileExportselectedmodulesClick(Sender: TObject);
begin
  ExportModules;
end;

procedure TFormWren.MenuFileImportmodulesClick(Sender: TObject);
begin
  ImportPatch;
end;

procedure TFormWren.MenuActionStartfilerenderClick(Sender: TObject);
begin
  RenderToFile := not RenderToFile;
end;

procedure TFormWren.MenuFileSaveastemplate1Click(Sender: TObject);
begin
  SaveAsTemplate1;
end;

procedure TFormWren.MenuFileSaveastemplate2Click(Sender: TObject);
begin
  SaveAsTemplate2;
end;

procedure TFormWren.IndicatorBarVolumeDblClick(Sender: TObject);
begin
  ClearVUMeters;
end;

procedure TFormWren.Color1Click(Sender: TObject);
begin
  ChangeModuleColor( FPopupSender as TKnobsModule);
end;

procedure TFormWren.LabeldBInMaxClick(Sender: TObject);
begin
  ResetInPeaks;
end;

procedure TFormWren.LabeldBOutMaxClick(Sender: TObject);
begin
  ResetOutPeaks;
end;

procedure TFormWren.LabelRunTimeClick(Sender: TObject);
begin
  if not RenderToFile
  then ResetRuntime;
end;

procedure TFormWren.LockKnobClick(Sender: TObject);
begin
  KnobChangeLock( FPopupSender as TKnobsKnob);
end;

procedure TFormWren.SetKnobDefaultvalueClick(Sender: TObject);
begin
  KnobSetDefaultValue( FPopupSender as TKnobsValuedcontrol)
end;

procedure TFormWren.DeleteModuleClick(Sender: TObject);
begin
  ModuleDelete( FPopupSender as TKnobsModule);
end;

procedure TFormWren.CopyModuleClick(Sender: TObject);
begin
  ModuleCopy( FPopupSender as TKnobsModule);
end;

procedure TFormWren.Customwirecolor1Click(Sender: TObject);
begin
  SetWireColorCustom( FPopupSender as TKnobsConnector);
end;

procedure TFormWren.CutModuleClick(Sender: TObject);
begin
  ModuleCut( FPopupSender as TKnobsModule);
end;

procedure TFormWren.DisconnectConnectorClick(Sender: TObject);
begin
  ConnectorDisconnect( FPopupSender as TKnobsConnector);
end;

procedure TFormWren.DeleteConnectorClick(Sender: TObject);
begin
  ConnectorDelete( FPopupSender as TKnobsConnector);
end;

procedure TFormWren.MenuEditFindClick(Sender: TObject);
begin
  EditSearch.SetFocus;
end;

procedure TFormWren.MenuEditFindunconnectedmodulesClick(Sender: TObject);
begin
  FindUnconnectedModules;
end;

procedure TFormWren.MenuActionProfileClick(Sender: TObject);
begin
  ProfilePatch;
end;

procedure TFormWren.WSocketNetMidiBgException(Sender: TObject; E: Exception; var CanClose: Boolean);
begin
  MidiLogFmt( 'exception : %s', [ E.Message]);
  CanClose := True;
end;

procedure TFormWren.WSocketNetMidiChangeState(Sender: TObject; OldState, NewState: TSocketState);
begin
  MidiLogFmt( 'state changed from %s to %s', [ SocketStateToStr( OldState), SocketStateToStr( NewState)]);
end;

procedure TFormWren.WSocketNetMidiDataAvailable(Sender: TObject; ErrCode: Word);
begin
  if FClosing
  then Exit;
  // MidiLogFmt( 'data available, error code %d', [ ErrCode]);
  LedNetMidiRx1.Active := True;
  LedNetMidiRx2.Active := True;
  ReceiveNetMidi;
end;

procedure TFormWren.WSocketNetMidiDataSent(Sender: TObject; ErrCode: Word);
begin
  if FClosing
  then Exit;
  // MidiLogFmt( 'data sent, error code %d', [ ErrCode]);
  LedNetMidiTx1.Active := True;
  LedNetMidiTx2.Active := True;
end;

procedure TFormWren.WSocketNetMidiSessionClosed(Sender: TObject; ErrCode: Word);
begin
  MidiLogFmt( 'session closed, error code %d', [ ErrCode]);
  NetMidiConnected := False;
  if NetMidiAutoConnect
  then StartNetMidiConnectTimer;
end;

procedure TFormWren.WSocketNetMidiSessionConnected(Sender: TObject; ErrCode: Word);
begin
  MidiLogFmt( 'session connected, error code %d', [ ErrCode]);
  NetMidiConnected := True;
end;

procedure TFormWren.WSocketOSCBgException(Sender: TObject; E: Exception; var CanClose: Boolean);
begin
  OSCLogFmt( 'Socket background exception : %s', [ E.Message]);
  CanClose := True;
end;

procedure TFormWren.WSocketOSCChangeState(Sender: TObject; OldState, NewState: TSocketState);
begin
  OSCLogFmt( 'state changed from %s to %s', [ SocketStateToStr( OldState), SocketStateToStr( NewState)]);
end;

procedure TFormWren.WSocketOSCDataAvailable(Sender: TObject; ErrCode: Word);
begin
  if ErrCode = 0
  then HandleOSCReception
  else OSCMsgLogFmt( 'Data Available, error: %d', [ ErrCode]);
end;

procedure TFormWren.WSocketOSCDataSent(Sender: TObject; ErrCode: Word);
begin
  if ErrCode = 0
  then begin
    if FClosing
    then Exit;
    LedOSCTx1.Active := True;
    LedOSCTx2.Active := True;
  end
  else OSCMsgLogFmt( 'Data Sent, error: %d', [ ErrCode]);
end;

procedure TFormWren.WSocketOSCSessionAvailable(Sender: TObject; ErrCode: Word);
begin
  if ErrCode = 0
  then OSCLog( 'Session Available')
  else OSCLogFmt( 'Session Available, error %d', [ ErrCode]);
end;

procedure TFormWren.WSocketOSCSessionClosed(Sender: TObject; ErrCode: Word);
begin
  if ErrCode = 0
  then begin
    OSCLog( 'Session Closed');
    if UseOSC and not FClosing
    then StartOSCGuard;
  end
  else OSCLogFmt( 'Session Closed, error: %d', [ ErrCode]);
end;

procedure TFormWren.WSocketOSCSessionConnected(Sender: TObject; ErrCode: Word);
begin
  if ErrCode = 0
  then OSCLog( 'Session Connected')
  else OSCLogFmt( 'Session Connected, error: %d', [ ErrCode]);
end;

procedure TFormWren.Yellowwires1Click(Sender: TObject);
begin
  SetWireColor( FPopupSender as TKnobsConnector, clYellow);
end;

procedure TFormWren.MenuViewGraphsClick(Sender: TObject);
begin
  ViewGraphs;
end;

procedure TFormWren.MenuViewDebuggerClick(Sender: TObject);
begin
  ViewDebug;
end;

procedure TFormWren.EditMiddleNoteChange(Sender: TObject);
var
  F : TSignal;
begin
  if EditMiddleNote.Text <> ''
  then begin
    F := StrToFloatDef( EditMiddleNote.Text, NaN);
    if not IsNan( F) and not AlmostZero( F)
    then MiddleNote := F;
  end;
end;

procedure TFormWren.EditNetMidiPortChange(Sender: TObject);
begin
  NetMidiChanged := True;
end;

procedure TFormWren.EditNetMidiServerChange(Sender: TObject);
begin
  NetMidiChanged := True;
end;

procedure TFormWren.EditNotesPerOctaveChange(Sender: TObject);
var
  F : TSignal;
begin
  if EditNotesPerOctave.Text <> ''
  then begin
    F := StrToFloatDef( EditNotesPerOctave.Text, NaN);
    if not IsNan( F) and not AlmostZero( F)
    then NotesPerOctave := F;
  end;
end;

procedure TFormWren.EditOSCPortChange(Sender: TObject);
begin
  OSCChanged := True;
end;

procedure TFormWren.EditOSCServerChange(Sender: TObject);
begin
  OSCChanged := True;
end;

procedure TFormWren.MenuViewEditorClick(Sender: TObject);
begin
  ViewEditor;
end;

procedure TFormWren.EditPatchNameChange(Sender: TObject);
begin
  PatchName := EditPatchName.Text;
end;

procedure TFormWren.EditReferenceAChange(Sender: TObject);
var
  F: TSignal;
begin
  if EditReferenceA.Text <> ''
  then begin
    F := StrToFloatDef( EditReferenceA.Text, NaN);
    if not IsNan( F) and not AlmostZero( F)
    then ReferenceA := F;
  end;
end;

procedure TFormWren.EditSearchChange(Sender: TObject);
begin
  SearchPatch( EditSearch.Text);
end;

procedure TFormWren.EditSynthNameChange(Sender: TObject);
begin
  OSCChanged := True;
end;

procedure TFormWren.RadioGroupControlModeClick(Sender: TObject);
begin
  ControlMode := TDistanceMode( RadioGroupControlMode.ItemIndex);
end;

procedure TFormWren.RadioGroupPrioLevelClick( Sender: TObject);
begin
  PrioLevel := RadioGroupPrioLevel.ItemIndex;
end;

procedure TFormWren.RadioGroupSampleRateClick(Sender: TObject);
begin
  case RadioGroupSampleRate.ItemIndex of
    1 :  Samplerate := 48000;
    2 :  Samplerate := 88200;
    3 :  Samplerate := 96000;
    else Samplerate := 44100;
  end;
end;

procedure TFormWren.MenuSetupSettingsClick(Sender: TObject);
begin
  ViewSettings;
end;

procedure TFormWren.MenuViewSettingsClick(Sender: TObject);
begin
  ViewSettings;
end;

procedure TFormWren.MIDI1Click(Sender: TObject);
begin
  ViewMIDIAssignments;
end;

procedure TFormWren.KnobMIDICCClick(Sender: TObject);
begin
  if FPopupSender is TKnobsValuedControl
  then AssignMidiCC( FPopupSender as TKnobsValuedControl);
end;

procedure TFormWren.MenuHelpHelpClick(Sender: TObject);
begin
  ShowHelp;
end;

procedure TFormWren.SpeedButtonChangeControlPanelClick(Sender: TObject);
begin
  if PanelControl.Width = 0
  then PanelControl.Width := FLastControlWidth
  else begin
    FLastControlWidth  := PanelControl.Width;
    PanelControl.Width := 0;
  end;
  FixFoldButton;
end;

procedure TFormWren.SpinButtonWireThicknessDownClick(Sender: TObject);
begin
  if WireThickness > 0
  then WireThickness := WireThickness - 1;
end;

procedure TFormWren.SpinButtonWireThicknessUpClick(Sender: TObject);
begin
  if WireThickness < 4
  then WireThickness := WireThickness + 1;
end;

procedure TFormWren.MenuFileNewClick(Sender: TObject);
begin
  NewPatch;
end;

procedure TFormWren.MenuSetupDevicesClick(Sender: TObject);
begin
  with FormWaveDeviceSelect
  do begin
    AllowPortAudio     := Self.UsePortAudio;
    PAInitialized      := Self.FPortAudioAvailable;
    UsePortAudio       := Self.FPortAudioSelected;
    SelectedInputId    := Self.FSelectedInputId;           // Legacy stuff
    SelectedOutputId   := Self.FSelectedOutputId;
    SelectedAPIID      := Self.FSelectedAPIID;             // PortAudio stuff
    SelectedInputIdPA  := Self.FSelectedInputIdPA;
    SelectedOutputIdPA := Self.FSelectedOutputIdPA;
    BufferSize         := Self.FBufferSize;
    if Execute
    then begin
      FRequestAudioStart     := False;
      FRequestAsioPanel      := False;
      FRequestAudioRestart   := False;
      FPanelAudioWasRunning  := False;
      SelectDevices;
    end;
  end;
end;

procedure TFormWren.MenuEditWiggleWiresClick(Sender: TObject);
begin
  WiggleWires;
end;

procedure TFormWren.MenuEditRedoClick(Sender: TObject);
begin
  if Assigned( PatchEditor)
  then PatchEditor.Redo;
end;

procedure TFormWren.MenuEditUndoClick(Sender: TObject);
begin
  if Assigned( PatchEditor)
  then PatchEditor.Undo;
end;

procedure TFormWren.MenuEditInvertSelectionClick(Sender: TObject);
begin
  InvertSelection;
end;

procedure TFormWren.MenuEditSelectAllClick(Sender: TObject);
begin
  SelectAll;
end;

procedure TFormWren.MenuEditSelectNoneClick(Sender: TObject);
begin
  SelectNone;
end;

procedure TFormWren.MenuEditPasteClick(Sender: TObject);
begin
  PasteModules;
end;

procedure TFormWren.MenuActionRunStopClick(Sender: TObject);
begin
  StartStopAudioIo;
end;

procedure TFormWren.MenuEditCopyClick(Sender: TObject);
begin
  CopyModules;
end;

procedure TFormWren.MenuEditCutClick(Sender: TObject);
begin
  CutModules;
end;

procedure TFormWren.MenuEditDeleteClick(Sender: TObject);
begin
  DeleteModules;
end;

procedure TFormWren.MenuFileExitClick(Sender: TObject);
begin
  if FDebugRunning
  then DebugRunStop;
  if RenderToFile
  then RenderToFile := False
  else Close;
end;

procedure TFormWren.MenuFileSaveClick(Sender: TObject);
begin
  SavePatch;
end;

procedure TFormWren.MenuFileSaveAsClick(Sender: TObject);
begin
  SavePatchAs;
end;

procedure TFormWren.MenuFileLoadClick(Sender: TObject);
begin
  LoadPatch;
end;

procedure TFormWren.ModuleSelectorDrawTab(Control: TCustomTabControl; TabIndex: Integer; const Rect: TRect;
  Active: Boolean);
var
  S         : string;
  aTextSize : TSize;
  aTextLeft : Integer;
begin
  S         := ModuleSelector.Pages[ tabindex].Caption;
  aTextSize := Control.Canvas.TextExtent( S);
  aTextLeft := ( Rect.Width - aTextSize.Width) div 2;
  Control.Canvas.Brush.Color := ModuleSelector.GetTabColor( TabIndex);
  Control.Canvas.FillRect( Rect);
  Control.Canvas.TextOut( Rect.left + aTextLeft, Rect.top - 1, S);
end;

function TFormWren.ModuleSelectorGetGlyph(aSender: TObject; const aName: string): TBitmap;
begin
  Result := FormStore.FindBitmap( aName);
end;

procedure TFormWren.ModuleSelectorModuleButtonClick(aSender: TObject; aModuleclass: Integer);
begin
  // User requested module creation by clicking
  // a button in the module selector, create it !
  // done : is FixupInsertions really needed here? - it will not hurt, do not change things.
  PatchEditor.BeginStateChange;
  try
    FormStore.CreateModule( PatchEditor, aModuleClass, DO_DRAG, StandardColors).FixupInsertion;
  finally
    PatchEditor.EndStateChange( True);
  end;
end;

procedure TFormWren.TimerStatsUpdateTimer(Sender: TObject);
begin
  UpdateStats;
end;

procedure TFormWren.TimerLightsUpdateTimer(Sender: TObject);
begin
  UpdateLights;
end;

procedure TFormWren.TimerNetMidiConnectTimer(Sender: TObject);
begin
  if NetMidiAutoConnect
  then begin
    if NetMidiConnected
    then StopNetMidiConnectTimer
    else NetMidiConnectTimerFired;
  end
  else StopNetMidiConnectTimer;
end;

procedure TFormWren.TimerOSCGuardTimer(Sender: TObject);
begin
  OSCGuardFired;
end;

procedure TFormWren.knob_iolevel_UnFocus(const aSender: TObject);
begin
  DoUnFocus( aSender);
end;

procedure TFormWren.knob_inputlevel1ValueChanged(aSender: TObject; const aPath, aControlType: string; aValue: Double; IsFinal, IsAutomation: Boolean);
begin
  InVolume1 := knob_inputlevel1.KnobPosition;
end;

procedure TFormWren.knob_inputlevel2ValueChanged(const aSender: TObject; const aPath, aControlType: string;
  aValue: Double; IsFinal, IsAutomation: Boolean);
begin
  InVolume2 := knob_inputlevel2.KnobPosition;
end;

procedure TFormWren.knob_inputlevel3ValueChanged(const aSender: TObject; const aPath, aControlType: string;
  aValue: Double; IsFinal, IsAutomation: Boolean);
begin
  InVolume3 := knob_inputlevel3.KnobPosition;
end;

procedure TFormWren.knob_inputlevel4ValueChanged(const aSender: TObject; const aPath, aControlType: string;
  aValue: Double; IsFinal, IsAutomation: Boolean);
begin
  InVolume4 := knob_inputlevel4.KnobPosition;
end;

procedure TFormWren.knob_outputlevel1ValueChanged(aSender: TObject; const aPath, aControlType: string; aValue: Double; IsFinal, IsAutomation: Boolean);
begin
  OutVolume1 := knob_outputlevel1.KnobPosition;
end;

procedure TFormWren.knob_outputlevel2ValueChanged(const aSender: TObject; const aPath, aControlType: string;
  aValue: Double; IsFinal, IsAutomation: Boolean);
begin
  OutVolume2 := knob_outputlevel2.KnobPosition;
end;

procedure TFormWren.knob_outputlevel3ValueChanged(const aSender: TObject; const aPath, aControlType: string;
  aValue: Double; IsFinal, IsAutomation: Boolean);
begin
  OutVolume3 := knob_outputlevel3.KnobPosition;
end;

procedure TFormWren.knob_outputlevel4ValueChanged(const aSender: TObject; const aPath, aControlType: string;
  aValue: Double; IsFinal, IsAutomation: Boolean);
begin
  OutVolume4 := knob_outputlevel4.KnobPosition;
end;

procedure TFormWren.KnobsSmallKnob_LightsRateValueChanged(aSender: TObject; const aPath, aControlType: string;
  aValue: Double; IsFinal, IsAutomation: Boolean);
begin
  if IsFinal
  then LightsRate := aValue;
end;

procedure TFormWren.KnobsNoKnob_HistoryCountValueChanged(const aSender: TObject; const aPath, aControlType: string;
  aValue: Double; IsFinal, IsAutomation: Boolean);
begin
  HistoryCount := Round( aValue);
end;

procedure TFormWren.KnobsSelectorFileRenderValueChanged(const aSender: TObject; const aPath, aControlType: string;
  aValue: Double; IsFinal, IsAutomation: Boolean);
begin
  RenderToFile := SignalToLogic( aValue);
end;

procedure TFormWren.knob_WheelSensitivityValueChanged(const aSender: TObject; const aPath,
  aControlType: string; aValue: Double; IsFinal, IsAutomation: Boolean);
begin
  WheelSensitivity := knob_WheelSensitivity.KnobPosition;
end;

procedure TFormWren.KnobsSmallKnobModuleOpacityValueChanged(const aSender: TObject; const aPath,
  aControlType: string; aValue: Double; IsFinal, IsAutomation: Boolean);
begin
  ModuleOpacity := Clip( Round( aValue), 0, 255);
end;

procedure TFormWren.KnobsSmallKnob_LeftOffsetValueChanged(aSender: TObject; const aPath, aControlType: string;
  aValue: Double; IsFinal, IsAutomation: Boolean);
begin
  OffsetLeft := Round( aValue);
end;

procedure TFormWren.KnobsSmallKnob_TopOffsetValueChanged(aSender: TObject; const aPath, aControlType: string;
  aValue: Double; IsFinal, IsAutomation: Boolean);
begin
  OffsetTop := Round( aValue);
end;

procedure TFormWren.CheckBoxClearVUOnRecompileClick(Sender: TObject);
begin
  ClearVUOnRecompile := CheckBoxClearVUOnRecompile.Checked;
end;

procedure TFormWren.CheckBoxClearVUOnStopClick(Sender: TObject);
begin
  ClearVUOnStop := CheckBoxClearVUOnStop.Checked;
end;

procedure TFormWren.CheckBoxAbsTimeStampsClick(Sender: TObject);
begin
 AbsTimeStamps := CheckBoxAbsTimeStamps.Checked;
end;

procedure TFormWren.CheckBoxAudioStatusInCaptionClick(Sender: TObject);
begin
  AudioStatusInCaption := CheckBoxAudioStatusInCaption.Checked;
end;

procedure TFormWren.CheckBoxAutoRunClick(Sender: TObject);
begin
  AutoRun := CheckBoxAutoRun.Checked;
end;

procedure TFormWren.CheckBoxCompilerDebugClick(Sender: TObject);
begin
  CompilerDebug := CheckBoxCompilerDebug.Checked;
end;

procedure TFormWren.CheckBoxCurvedLinesClick(Sender: TObject);
begin
  CurvedLines := CheckBoxCurvedLines.Checked;
end;

procedure TFormWren.CheckBoxFileVersionInCaptionClick(Sender: TObject);
begin
  FileVersionInCaption := CheckBoxFileVersionInCaption.Checked;
end;

procedure TFormWren.CheckBoxGraphStairsClick(Sender: TObject);
begin
  GraphStairs := CheckBoxGraphStairs.Checked;
end;

procedure TFormWren.CheckBoxLightsActiveClick(Sender: TObject);
begin
  LightsActive := CheckBoxLightsActive.Checked;
end;

procedure TFormWren.CheckBoxLogMidiClick(Sender: TObject);
begin
  LogMidi := CheckBoxLogMidi.Checked;
end;

procedure TFormWren.CheckBoxLogMidiMsgsClick(Sender: TObject);
begin
  LogMidiMsgs := CheckBoxLogMidiMsgs.Checked;
end;

procedure TFormWren.CheckBoxLogOSCClick(Sender: TObject);
begin
  LogOSC := CheckBoxLogOSC.Checked;
end;

procedure TFormWren.CheckBoxLogOSCMsgsClick(Sender: TObject);
begin
  LogOSCMsgs := CheckBoxLogOSCMsgs.Checked;
end;

procedure TFormWren.CheckBoxLogToFileClick(Sender: TObject);
begin
  LogToFile := CheckBoxLogToFile.Checked;
end;

procedure TFormWren.CheckBoxNetMidiAutoConnectClick(Sender: TObject);
begin
  NetMidiAutoConnect := CheckBoxNetMidiAutoConnect.Checked;
end;

procedure TFormWren.CheckBoxPatchChangedInCaptionClick(Sender: TObject);
begin
  PatchChangedInCaption := CheckBoxPatchChangedInCaption.Checked;
end;

procedure TFormWren.CheckBoxPatchNameInCaptionClick(Sender: TObject);
begin
  PatchNameInCaption := CheckBoxPatchNameInCaption.Checked;
end;

procedure TFormWren.CheckBoxPortAudioInCaptionClick(Sender: TObject);
begin
  PortAudioInCaption := CheckBoxPortAudioInCaption.Checked;
end;

procedure TFormWren.CheckBoxProfiledInCaptionClick(Sender: TObject);
begin
  ProfiledInCaption := CheckBoxProfiledInCaption.Checked;
end;

procedure TFormWren.CheckBoxProgramNameInCaptionClick(Sender: TObject);
begin
  ProgramNameInCaption := CheckBoxProgramNameInCaption.Checked;
end;

procedure TFormWren.CheckBoxReloadLastPatchClick(Sender: TObject);
begin
  ReloadLastPatch := CheckBoxReloadLastPatch.Checked;
end;

procedure TFormWren.CheckBoxShowLightsTimeClick(Sender: TObject);
begin
  ShowLightsTime := CheckBoxShowLightsTime.Checked;
end;

procedure TFormWren.CheckBoxSourceNameInCaptionClick(Sender: TObject);
begin
  SourceNameInCaption := CheckBoxSourceNameInCaption.Checked;
end;

procedure TFormWren.CheckBoxStandardColorsClick(Sender: TObject);
begin
  StandardColors := CheckBoxStandardColors.Checked;
end;

procedure TFormWren.CheckBoxSynthNameInCaptionClick(Sender: TObject);
begin
  SynthNameInCaption := CheckBoxSynthNameInCaption.Checked;
end;

procedure TFormWren.CheckBoxUndoAfterLoadClick(Sender: TObject);
begin
  UndoAfterLoad := CheckBoxUndoAfterLoad.Checked;
end;

procedure TFormWren.CheckBoxUndoAfterSaveClick(Sender: TObject);
begin
  UndoAfterSave := CheckBoxUndoAfterSave.Checked;
end;

procedure TFormWren.CheckBoxUseConfigHintsClick(Sender: TObject);
begin
  UseConfigHints := CheckBoxUseConfigHints.Checked;
end;

procedure TFormWren.CheckBoxUseGraphsClick(Sender: TObject);
begin
  UseGraphs := CheckBoxUseGraphs.Checked;
end;

procedure TFormWren.CheckBoxUseOSCClick(Sender: TObject);
begin
  OSCChanged := True;
end;

procedure TFormWren.CheckBoxUsePortAudioClick(Sender: TObject);
begin
  UsePortAudio := CheckBoxUsePortAudio.Checked;
end;

procedure TFormWren.CheckBoxUseUnFocusClick(Sender: TObject);
begin
  UseUnFocus := CheckBoxUseUnFocus.Checked;
end;

procedure TFormWren.CheckBoxUseWheelOnKnobsClick(Sender: TObject);
begin
  UseWheelOnKnobs := CheckBoxUseWheelOnKnobs.Checked;
end;

procedure TFormWren.CheckBoxWarnChangeOnLoadClick(Sender: TObject);
begin
  WarnChangeOnLoad := CheckBoxWarnChangeOnLoad.Checked;
end;

procedure TFormWren.CheckBoxWarnOnPatchChangeClick(Sender: TObject);
begin
  WarnOnPatchChange := CheckBoxWarnOnPatchChange.Checked;
end;

procedure TFormWren.Checkforupdates1Click(Sender: TObject);
begin
  CheckForUpdates;
end;

procedure TFormWren.BitBtnDebugStepClick(Sender: TObject);
begin
  if FAudioInRunning or FAudioOutRunning
  then Log( 'can not do a debug step while audio generation is on')
  else ExecutePatch;
end;

procedure TFormWren.BitBtnDocumentClick(Sender: TObject);
begin
  MakeDocs( DocsPath);    // Forcibly make docs.
  ShowHelp;
end;

procedure TFormWren.BitBtnClearGraphsClick(Sender: TObject);
begin
  ClearGraphs;
end;

procedure TFormWren.BitBtnCloseDubuggerClick(Sender: TObject);
begin
  ViewEditor;
end;

procedure TFormWren.BitBtnCloseGraphsClick(Sender: TObject);
begin
  ViewEditor;
end;

procedure TFormWren.BitBtnCloseSettingsClick(Sender: TObject);
begin
  ViewEditor;
end;

procedure TFormWren.BitBtnLoadTemplate1Click(Sender: TObject);
begin
  DoLoadPatch( Template1Name, False);
end;

procedure TFormWren.BitBtnLoadTemplate2Click(Sender: TObject);
begin
  DoLoadPatch( Template2Name, False);
end;

procedure TFormWren.BitBtnModuleTitleFontClick(Sender: TObject);
begin
  if Assigned( FormStore)
  then begin
    FontDialog.Font.Assign( TitleFont);
    if FontDialog.Execute
    then TitleFont := FontDialog.Font;
  end;
end;

procedure TFormWren.BitBtnSendOSCTestMessageClick(Sender: TObject);
begin
  SendOSCTestMessage;
end;

procedure TFormWren.BitBtnAcknowledgementsClick(Sender: TObject);
begin
  ShowAcknowledgements;
end;

procedure TFormWren.BitBtnApplyNetMidiClick(Sender: TObject);
begin
  NetMidiApply;
end;

procedure TFormWren.BitBtnApplyOSCClick(Sender: TObject);
begin
  OSCApply;
end;

procedure TFormWren.BitBtnApplyTuningClick(Sender: TObject);
begin
  ApplyTuning;
end;

procedure TFormWren.BitBtnAudioRunningClick(Sender: TObject);
begin
  StartStopAudioIo;
end;

procedure TFormWren.BitBtnCancelNetMidiClick(Sender: TObject);
begin
  NetMidiCancel;
end;

procedure TFormWren.BitBtnCancelOSCClick(Sender: TObject);
begin
  OSCCancel;
end;

procedure TFormWren.BitBtnCancelTuningClick(Sender: TObject);
begin
  CancelTuning;
end;

procedure TFormWren.BitBtnCheckForUpdatesClick(Sender: TObject);
begin
  CheckForUpdates;
end;

procedure TFormWren.BitBtnClearClick(Sender: TObject);
begin
  ClearLog;
end;

procedure TFormWren.BitBtnDebugResetClick(Sender: TObject);
begin
  if FAudioInRunning or FAudioOutRunning
  then Log( 'can not do a debug reset while audio generation is on')
  else begin
    if Assigned( FSynthPatch)
    then begin
      FSynthPatch.Reset;
      FSynthPatch.ResetSampleCounts;
    end;
    ClearGraphs;
  end;
end;

procedure TFormWren.BitBtnSynthResetClick(Sender: TObject);
begin
  if Assigned( FSynthPatch)
  then FSynthPatch.Reset;
end;

procedure TFormWren.BitBtnView1Click(Sender: TObject);
begin
  PanelControl.Width := 47 * ( Sender as TBitBtn).Tag;
  FixFoldButton;
end;

procedure TFormWren.Bluewires1Click(Sender: TObject);
begin
  SetWireColor( FPopupSender as TKnobsConnector, clBlue);
end;

procedure TFormWren.BreakConnectorClick(Sender: TObject);
begin
  ConnectorBreak( FPopupSender as TKnobsConnector);
end;

procedure TFormWren.BitBtnDebugRunClick(Sender: TObject);
begin
  DebugRunStop;
end;

procedure TFormWren.BitBtnDumpClick(Sender: TObject);
begin
  ShowPatch;
end;

procedure TFormWren.BitBtnExItClick(Sender: TObject);
begin
  FDebugRunning := False;
  Close;
end;

procedure TFormWren.BitBtnModuleColorClick(Sender: TObject);
begin
  if Assigned( PatchEditor)
  then begin
    with ColorDialogModule
    do begin
      Color := ModuleColor;
      if Execute
      then ModuleColor := Color;
    end;
  end;
end;

procedure TFormWren.BitBtnModuleFontClick(Sender: TObject);
begin
  if Assigned( FormStore)
  then begin
    FontDialog.Font.Assign( ModuleFont);
    if FontDialog.Execute
    then ModuleFont := FontDialog.Font;
  end;

end;

procedure TFormWren.BitBtnNetMidiConnectClick(Sender: TObject);
begin
  if NetMidiConnected
  then NetMidiDisconnect
  else NetMidiConnect;
end;

procedure TFormWren.BitBtnProfileClick(Sender: TObject);
begin
  ProfilePatch;
end;

procedure TFormWren.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FClosing := True;
  try
    StopAudioIn;
    StopAudioOut;
    NetMidiDisconnect;
    OSCDisable;
  except
    on E: Exception
    do KilledException( E);
  end;
  if FIniLoaded
  then SaveIni;
end;

procedure TFormWren.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := CheckDiscardPatchChanges( 'Program Exit', WarnOnPatchChange);
end;

procedure TFormWren.FormCreate(Sender: TObject);
var
  aPAError : TPAError;
  anErrVal : Integer;
  i        : Integer;
begin

  FVuSampleCount := 1;                             // Number of sample sets / frame - this can not be zero, it will be
                                                   // set later on in this method to a larger value, and the audio
                                                   // input and output functions will change it as well.
  ClearDebugTiming;                                // For relative debug time stamps
  CanLog    := False;                              // Causes logs to be stored on FSavedLogs
  LogToFile := True;                               // Causes logs to be written to a file as well as to the log memo
  if FileExists( LogFileName)                      // Delete existing logs
  then DeleteFile( LogFileName);

  Log( 'Creating main form');
  LogFmt( 'Wren version  : %s', [ GetFileVersion   ]);
  LogFmt( 'Patch version : %d', [ KnobsPatchVersion]);

  FSelectedAPIID      := -1;
  FPortAudioAvailable := False;
  try
    LogFmt( 'probing PortAudio DLL presence, looking for "%s"', [ portaudio.LibName]);
    aPAError            := Pa_Initialize;
    FPortAudioAvailable := aPAError = paNoError;

  {$IFDEF DEBUG_PORT_AUDIO}
    if FPortAudioAvailable
    then PaUtil_SetDebugPrintFunction( @ GPaDebugProc);
  {$ENDIF}

  except
    on E: Exception
    do begin
      FPortAudioAvailable := False;
      KilledException( E);
    end;
  end;

  if FPortAudioAvailable
  then Log( 'PortAudio DLL found')
  else Log( 'No PortAudio DLL found');

  FFFTWAvailable := False;
  try
    LogFmt( 'probing FFTW DLL presence, looking for "%s"', [ fftw_dllpath]);
    anErrVal := fftw_init_threads;
    if anErrVal <> 0
    then begin
      fftw_plan_with_nthreads( 1);                         // Set maximum number of threads for FFTW to use
      Log( 'FFTW DLL found');
      FFFTWAvailable := True;
    end
    else Log( 'FFTW DLL found, but no threads avaliable, might be unusable');
  except
    on E: Exception
    do begin
      Log( 'FFTW DLL not found, or an error occurred calling into it');
      KilledException( E);
    end;
  end;

  FOSCFifo := TBytesFifo.Create( 256);

  FOldMemoDebug        := MemoDebug.WindowProc;            // Make mousewheel support for the debug memo
  MemoDebug.WindowProc := MemoDebugWindowProc;

  Randomize;
  InitializeCPUCounter;

  GOnCreateModuleBitmap   := DoCreateModuleBitmap;         // Helpers for help system and for module selector
  GOnReadModuleComment    := DoReadModuleComment;
  GOnLookupModuleClass    := LookupModuleGeneralClass;

  with Application
  do begin
    HintPause     :=  0;
    HintHidePause := -1;
    OnShowHint    := DoShowHint;
  end;

  Log( 'Creating designer form');

  FormStore := TFormStore.Create( Application);            // "designer" needs manual creation .. ok, do it.
  with FormStore
  do begin
    FormStore.OnDesignerLog := DoDesignerLog;
    PopulateSelector( ModuleSelector);                     // Poplulate module selector from the "designer"
    ModuleSelector.GetTabColors( FormStore.GetTabColor, clSilver, 192);   // Obtain tab colors for the module selector
    LabelModuleTitleFont.Font.Assign( FormStore.TitleFont);
  end;

  Log( 'Created designer form, creating patch reader and writer');

  FPatchReader := TPatchReader.Create;                     // For patch reading / writing to/from file/clipboard
  FPatchWriter := TPatchWriter.Create;

  Log( 'Created patch reader and writer, configuring Editor');

  with PatchEditor
  do begin
    OnLog           := DoWirePanelLog;
    PatchReader     := FPatchReader;
    PatchWriter     := FPatchWriter;
    OnHistoryChange := DoHistoryChanged;
    OnValueChanged  := DoValueChanged;
    OnTextChanged   := DoTextChanged;
    OnPatchChanged  := DoPatchChanged;
    OnWiresChanged  := DoWiresChanged;
    OnShowPoup      := DoShowPopupMenu;
    OnUnFocus       := DoUnFocus;
    Title           := 'no name';
    MaxHistory      := 100;
  end;

  Log( 'Configured Editor, creating RecentSourceFiles');

  FRecentSourceFiles := TRecentStrings.Create( 20);

  Log( 'Created RecentSourceFiles, setting up PageControlMain');

  with PageControlMain                             // Hide outer level tabs
  do begin
    for i := 0 to PageCount - 1
    do Pages[ i].TabVisible := False;
  end;
  ViewEditor;

  Log( 'Set up PageControlMain, setting some defaults and clearing VU meters');
                                                   // Create dB level handlers
  for i := Low( FDbMinMaxIn) to High( FDbMinMaxIn)
  do FDbMinMaxIn[ i] := TDbMinMax.Create( MIN_DB, MAX_DB, DB_DECAY_RATE, DB_DECAY_RATE);

  for i := Low( FDbMinMaxOut) to High( FDbMinMaxOut)
  do FDbMinMaxOut[ i] := TDbMinMax.Create( MIN_DB, MAX_DB, DB_DECAY_RATE, DB_DECAY_RATE);

  SetVuSampleCount( 512);                          // As long as its not zero ... a default frame size

  Log( 'Set defaults, setup Midi reciver');

  FMidiReceiver := TMidiReceiver.Create;
  FMidiReceiver.OnMessage := DoMidiRxMessage;
  Log( 'Midi receiver set up');
  Log( 'Created main form');
end;

procedure TFormWren.FormDestroy(Sender: TObject);
var
  i : Integer;
begin
  Log( 'Destroying main form');
  Log( 'Destroying synth patch');

  if Assigned( FSynthPatch)
  then begin
    FSynthPatch.OnSendMidi      := nil;
    FSynthPatch.OnSendOSCString := nil;
    FSynthPatch.OnSynthLog      := nil;
  end;
  FreeAndNil( FSynthPatch);

  Log( 'Destroying audio devices');

  FreeDevices;

  Log( 'Destroying RecentSourceFiles');

  FreeAndNil( FRecentSourceFiles);

  Log( 'Finalizing CPU counter');

  FinalizeCPUCounter;

  Log( 'Freeing MIN/MAX tools');

  for i := Low( FDbMinMaxIn) to High( FDbMinMaxIn)
  do FreeAndNil( FDbMinMaxIn[ i]);

  for i := Low( FDbMinMaxOut) to High( FDbMinMaxOut)
  do FreeAndNil( FDbMinMaxOut[ i]);

  Log( 'Cleaning up DLL stuff');

  // Clean up DLL stuff
  //
  try
    if FFFTWAvailable
    then fftw_cleanup_threads
  except
    on E: Exception
    do KilledException( E);
  end;
  //
  try
    if FPortAudioAvailable
    then Pa_Terminate;
  except
    on E: Exception
    do KilledException( E);
  end;
  //
  // end Clean up DLL stuff

  Log( 'Cleaned up DLL stuff, free the logger and the MIDI reciever');


  FreeAndNil( FSavedLogs);
  FMidiReceiver.OnMessage := nil;
  FreeAndNil( FMidiReceiver);
  FreeAndNil( FOSCFifo);
  TalkieDestroyPhrases;

  Log( 'Main form destroyed, bye ...');
end;


procedure TFormWren.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if ( Shift = []) and ( Key = VK_F8) and not FKeyF8Down
  then begin
    Key        := 0;
    FKeyF8Down := True;
    if Assigned( PatchEditor)
    then PatchEditor.ShowAllPopups;
  end;
end;

procedure TFormWren.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if ( Shift = []) and ( Key = VK_F8) and FKeyF8Down
  then begin
    Key        := 0;
    FKeyF8Down := False;
    if Assigned( PatchEditor)
    then PatchEditor.ForceHideAllPopups;
  end;
end;

procedure TFormWren.FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
Var
  aMsg  : Cardinal;
  aCode : Cardinal;
  i     : Integer;
  n     : Integer;
begin

  MousePos := ScreenToClient( MousePos);
  if
    ( MousePos.X > PatchEditor.Left                     ) and
    ( MousePos.Y > PatchEditor.Top                      ) and
    ( MousePos.X < PatchEditor.Left + PatchEditor.Width ) and
    ( MousePos.Y < PatchEditor.Top  + PatchEditor.Height)
  then begin
    if ssShift in Shift
    then aMsg := WM_HSCROLL
    else aMsg := WM_VSCROLL;

    if WheelDelta < 0
    then aCode := SB_LINEDOWN
    else aCode := SB_LINEUP;

    n := Mouse.WheelScrollLines;
    for i:= 1 to n
    do PatchEditor.Perform( aMsg, aCode, 0);
    PatchEditor.Perform( aMsg, SB_ENDSCROLL, 0);
    Handled := True;
  end;
end;

procedure TFormWren.FormShow(Sender: TObject);
var
  aPhraseSets     : TTalkiePhraseSets;
  WasFileLogging : Boolean;
begin
  Log( 'Main form OnShow started, handle saved logs');

  try
    ClearLog;                                        // Clear log window
    WasFileLogging := LogToFile;
    LogToFile      := False;                         // Do not log old logs to the log file, they are in it already
    try
      CanLog := True;                                // This will dump FSavedLogs to to the log view
    finally
      LogToFile := WasFileLogging;
    end;
  except
    on E: Exception
    do KilledException( E);
  end;

  Log( 'Saved logs written');

  Log( 'reading Talkie phrase sets from ''words.lpc''');
  TalkieCreatePhrases( 'words.lpc');
  aPhraseSets := TalkiePhraseSets;
  if not Assigned( aPhraseSets)
  then Log( '''words.lpc'' not found or erroneous')
  else Log( 'phrase sets loaded');

  FOrigCaption   := Caption;
  PatchName      := '';
  SourceFileName := '';

  KnobsLedrendering.Visible := False;

  Log( 'Initialize wave selector window');

  FormWaveDeviceSelect := TFormWaveDeviceSelect.Create( Self);
  with FormWaveDeviceSelect
  do begin
    OnLog           := WaveLog;
    PAInitialized   := Self.FPortAudioAvailable;
    OnShowAsioPanel := WaveShowAsioPanel;
    OnRestartAudio  := WaveRestartAudio;
    Initialize;
  end;

  ClearVUMeters;

  Log( 'Set default values');

  Width  := 1000;                               // Default form width
  Height :=  700;                               // Default form height
  SplitterMain.ShowHint := True;                // Hints on VU/main splitter
  PanelControl.Width    := 47;                  // By default show channel 1 controls only
  FLastControlWidth     := PanelControl.Width;
  FixFoldButton;

  // Setup defaults

  FSynthName              := '-';          SynthName              := 'wren';
  FLightsActive           := False;        LightsActive           := True;
  FAbsTimeStamps          := False;        AbsTimeStamps          := True;
  FUseGraphs              := True;         UseGraphs              := False;
  InVolume1               := 1;            InVolume1              := 0;
  InVolume2               := 1;            InVolume2              := 0;
  InVolume3               := 1;            InVolume3              := 0;
  InVolume4               := 1;            InVolume4              := 0;
  OutVolume1              := 1;            OutVolume1             := 81;
  OutVolume2              := 1;            OutVolume2             := 81;
  OutVolume3              := 1;            OutVolume3             := 81;
  OutVolume4              := 1;            OutVolume4             := 81;
  FClearVUOnStop          := False;        ClearVUOnStop          := True;
  FClearVUOnRecompile     := False;        ClearVUOnRecompile     := True;
  FAudioInRunning         := False;
  FAudioOutRunning        := False;
  FReloadLastPatch        := False;        ReloadLastPatch        := True;
  FHistoryCount           := 0;            HistoryCount           := 15;
  FCurvedLines            := False;        CurvedLines            := True;
  FControlMode            := dmHorizontal; ControlMode            := dmCircular;
  Samplerate              := 48000;        Samplerate             := 44100;
  BufferSize              := 4096;
  WaveDebug               := True;
  ReferenceA              := 100;          ReferenceA             := 440.0;
  NotesPerOctave          := 3;            NotesPerOctave         := 12.0;
  MiddleNote              := 1;            MiddleNote             := 69;
  FUseConfigHints         := False;        UseConfigHints         := True;
  FWireThickness          := 2;            WireThickness          := 1;
  FPrioLevel              := 0;
  OffsetLeft              := 6;
  OffsetTop               := 6;
  NetMidiServer           := 'localhost';
  NetMidiPort             := '31415';
  FNetMidiAutoConnect     := True;         NetMidiAutoConnect     := False;
  FLogMidi                := False;        LogMidi                := True;
  FLogMidiMsgs            := True;         LogMidiMsgs            := False;
  FMidiChannel            := 1;            MidiChannel            := MIDI_CH_OMNI; // Default to onmi RX mode and TX on 1
  FNetMidiChanged         := True;         NetMidiChanged         := False;
  FOscServer              := '-';          OSCServer              := '';           // default to a transmitter
  OSCPort                 := '31435';
  FUSeOSC                 := True;         UseOSC                 := False;
  FLogOSC                 := False;        LogOSC                 := True;
  FLogOSCMsgs             := True;         LogOSCMsgs             := False;
  FOSCChanged             := True;         OSCChanged             := False;
  FCompilerDebug          := True;         CompilerDebug          := False;
  FWarnOnPatchChange      := False;        WarnOnPatchChange      := True;
  FWarnChangeOnLoad       := False;        WarnChangeOnLoad       := True;
  FUndoAfterSave          := True;         UndoAfterSave          := False;
  FUndoAfterLoad          := True;         UndoAfterLoad          := False;
  FUseWheelOnKnobs        := True;         UseWheelOnKnobs        := False;
  FWheelSensitivity       := 1;            WheelSensitivity       := 25;
  FUseUnFocus             := False;        UseUnFocus             := True;
  FRenderToFile           := True;         RenderToFile           := False;
  FResetOnRender          := False;        ResetOnRender          := True;
  FShowLightsTime         := True;         ShowLightsTime         := False;
  ModuleOpacity           := 223;
  FStandardColors         := False;        StandardColors         := True;

  FSynthNameInCaption     := True;         SynthNameInCaption     := False;
  FPatchChangedInCaption  := False;        PatchChangedInCaption  := True;
  FProfiledInCaption      := False;        ProfiledInCaption      := True;
  FAudioStatusInCaption   := True;         AudioStatusInCaption   := False;
  FProgramNameInCaption   := False;        ProgramNameInCaption   := True;
  FFileVersionInCaption   := True;         FileVersionInCaption   := False;
  FPatchNameInCaption     := True;         PatchNameInCaption     := False;
  FSourceNameInCaption    := False;        SourceNameInCaption    := True;
  FPortAudioInCaption     := True;         PortAudioInCaption     := False;

  FSelectedAPIID          := paDirectSound;
  FSelectedInputId        := 0;
  FSelectedOutputId       := 0;
  FSelectedInputIdPA      := 0;
  FSelectedOutputIdPA     := 0;

  FUsePortAudio           := not FPortAudioAvailable; UsePortAudio := FPortAudioAvailable;
  FPortAudioSelected      := FPortAudioAvailable;

  Log( 'Check audio devices');

  VerifyDevices;

  Log( 'Setup profiler');

  if not HAS_PATCH_PROFILER
  then begin
    BitBtnProfile    .Caption := 'find small values';
    MenuActionProfile.Caption := 'Find small values';
  end;

  Log( 'Clear some user interface stuff');

  FLightsRate                            :=   0;
  KnobsSmallKnob_LightsRate.KnobPosition :=   0;
  KnobsSmallKnob_LightsRate.KnobPosition := 156;

  LabelProgramVersion.Caption := Format( 'program version: %s', [ GetFileVersion   ], AppLocale);
  LabelPatchVersion  .Caption := Format( 'patch version: %d'  , [ KnobsPatchVersion], AppLocale);
  ClearVolumeIndicators;
  ResetRuntime;

  // Load user prefs when they are available

  LogFmt( 'Load user prefs from ''%s''', [ IniFileName]);

  if FileExists( IniFileName)
  then LoadIni
  else begin
    Log( 'No user prefs found, creating initial prefs');

    AutoRun    := True;
    FIniLoaded := True;
    SaveIni;                      // Save default settings
    AutoRun    := False;          // To be reloaded from ini file

    Log( 'Loading freshly created user prefs');

    if FileExists( IniFileName)   // and load them
    then LoadIni;
  end;

  Log( 'User prefs loadesd, some more details to fix ...');

  if Assigned( PatchEditor)
  then KnobsLedModuleColor.ColorOn  := PatchEditor.ModuleColor;

  if PageControlMain.ActivePage = TabSheetEditor
  then EditSearch.SetFocus;       // Set keyboard and mouse wheel focus to something harmless .. if possible

  Log( '... all done, Main form onshow setup completed OK');
end;


initialization

  // Couple editor module IDs to synth module types

  RegisterModuleType(  101, TModInput            );
  RegisterModuleType(  102, TModOutput           );

  RegisterModuleType(  201, TModXFade            );
  RegisterModuleType(  202, TModPan              );
  RegisterModuleType(  203, TModMixM4to1         );
  RegisterModuleType(  204, TModMixS2to1         );
  RegisterModuleType(  205, TModMixM6to6         );
  RegisterModuleType(  206, TModMixT1to1         );
  RegisterModuleType(  207, TModMixAudio         );
  RegisterModuleType(  208, TModMixQ1to1         );
  RegisterModuleType(  209, TModMixM16to1        );

  RegisterModuleType(  301, TModConstant         );
  RegisterModuleType(  302, TModInverter         );
  RegisterModuleType(  303, TModAdder            );
  RegisterModuleType(  304, TModMultiplier       );
  RegisterModuleType(  305, TModAmplifier        );
  RegisterModuleType(  306, TModScaler           );
  RegisterModuleType(  307, TModQuantize         );
  RegisterModuleType(  308, TModRatio            );
  RegisterModuleType(  309, TModRotator          );
  RegisterModuleType(  310, TModRectifier        );
  RegisterModuleType(  311, TModMinMax           );
  RegisterModuleType(  312, TModMultiMult        );
  RegisterModuleType(  313, TModNoteToDelay      );
  RegisterModuleType(  314, TModZeroCounter      );
  RegisterModuleType(  315, TModMedian           );
  RegisterModuleType(  316, TModScala            );
  RegisterModuleType(  317, TModHardClip         );
  RegisterModuleType(  318, TModTransInv         );
  RegisterModuleType(  319, TModPad              );
  RegisterModuleType(  320, TModEuclideanScale   );
  RegisterModuleType(  321, TModInterpreter      );
  RegisterModuleType(  322, TModRangeConverter   );
  RegisterModuleType(  323, TModLogisticMap      );
  RegisterModuleType(  324, TModWaveWiper        );
  RegisterModuleType(  325, TModWaveWrapper      );
  RegisterModuleType(  326, TModChebGen          );
  RegisterModuleType(  327, TModPoetry           );

  RegisterModuleType(  401, TModLfo              );
  RegisterModuleType(  402, TModSquareLfo        );
  RegisterModuleType(  403, TModNoiseLfo         );
  RegisterModuleType(  404, TModRandomWalkLfo    );
  RegisterModuleType(  405, TModLfoTrig          );
  RegisterModuleType(  406, TModSquareLfoTrig    );
  RegisterModuleType(  407, TModNoiseLfoTrig     );
  RegisterModuleType(  408, TModRandSig          );
  RegisterModuleType(  409, TModPulses           );
  RegisterModuleType(  410, TModAttractorLfo     );

  RegisterModuleType(  501, TModOsc              );
  RegisterModuleType(  502, TModSquare           );
  RegisterModuleType(  503, TModNoise            );
  RegisterModuleType(  504, TModTrigOsc          );
  RegisterModuleType(  505, TModSquareTrig       );
  RegisterModuleType(  506, TModNoiseTrig        );
  RegisterModuleType(  507, TModTerraGen         );
  RegisterModuleType(  508, TModPluck            );
  RegisterModuleType(  510, TModTalkie           );
  RegisterModuleType(  511, TModAttractor        );

  RegisterModuleType(  601, TModNot              );
  RegisterModuleType(  602, TModGate             );
  RegisterModuleType(  603, TModDivider          );
  RegisterModuleType(  604, TModDFlipFlop        );
  RegisterModuleType(  605, TModRSFlipFlop       );
  RegisterModuleType(  606, TModCounter          );
  RegisterModuleType(  607, TModAdc              );
  RegisterModuleType(  608, TModDac              );
  RegisterModuleType(  609, TModPhaseDetect      );
  RegisterModuleType(  610, TModCompare          );
  RegisterModuleType(  611, TModLogicSelector    );
  RegisterModuleType(  612, TModProgDivider      );

  RegisterModuleType(  701, TModDelay            );
  RegisterModuleType(  702, TModWavePlayer       );
  RegisterModuleType(  703, TModReverb           );
  RegisterModuleType(  704, TModFlangeChorus     );
  RegisterModuleType(  705, TModPitchChange      );
  RegisterModuleType(  706, TModClockedDelay     );
  RegisterModuleType(  707, TModGVerb            );
  RegisterModuleType(  708, TModDelay8           );
  RegisterModuleType(  709, TModRndGranulator    );
  RegisterModuleType(  710, TModGranulator       );
  RegisterModuleType(  711, TModSimpleGranulator );

  RegisterModuleType(  801, TModSampleAndHold    );
  RegisterModuleType(  802, TModTrackAndHold     );
  RegisterModuleType(  803, TModSwitch2to1       );
  RegisterModuleType(  804, TModMultiSAndH       );
  RegisterModuleType(  805, TModMux              );
  RegisterModuleType(  806, TModDemux            );
  RegisterModuleType(  807, TModDigiMux          );
  RegisterModuleType(  808, TModDigiDemux        );

  RegisterModuleType(  901, TModEnvAR            );
  RegisterModuleType(  902, TModEnvARRetrig      );
  RegisterModuleType(  903, TModEnvAHD           );
  RegisterModuleType(  904, TModEnvADSR          );
  RegisterModuleType(  905, TModEnvelope         );
  RegisterModuleType(  906, TModCompressor       );
  RegisterModuleType(  907, TModVocoder          );
  RegisterModuleType(  908, TModNeuron           );
  RegisterModuleType(  909, TModConvoder         );
  RegisterModuleType(  910, TModPitchShift       );

  RegisterModuleType( 1001, TModAverage          );
  RegisterModuleType( 1002, TModSVF              );
  RegisterModuleType( 1003, TModIntDif           );
  RegisterModuleType( 1004, TModFormant          );
  RegisterModuleType( 1005, TModPinkFilter       );
  RegisterModuleType( 1006, TModResonator        );
  RegisterModuleType( 1007, TModFilterBank       );

  RegisterModuleType( 1106, TModDisplay          );
  RegisterModuleType( 1108, TModXYScope          );

  RegisterModuleType( 1201, TModSequencer        );
  RegisterModuleType( 1202, TModTextSequencer    );
  RegisterModuleType( 1203, TModSeqStep          );
  RegisterModuleType( 1204, TModSeqClockStep     );
  RegisterModuleType( 1205, TModEuclideanRhythm  );
  RegisterModuleType( 1206, TModCsvData          );
  RegisterModuleType( 1207, TModKleeBit          );
  RegisterModuleType( 1208, TModSeqRandom        );
  RegisterModuleType( 1209, TModMorse            );
  RegisterModuleType( 1210, TModGateSeq          );
  RegisterModuleType( 1211, TModSeq16            );
  RegisterModuleType( 1212, TModSeqSeq           );
  RegisterModuleType( 1213, TModPattern          );
  RegisterModuleType( 1214, TModFriemels         );

  RegisterModuleType( 1301, TModMidiNoteIn       );
  RegisterModuleType( 1302, TModMidiCCIn         );
  RegisterModuleType( 1303, TModMidiNoteOut      );
  RegisterModuleType( 1304, TModMidiCCOut        );
  RegisterModuleType( 1305, TModMidiPlayer       );
  RegisterModuleType( 1306, TModSync             );
  RegisterModuleType( 1307, TModOscMessage       );

  RegisterModuleType( 1401, TModFreqShifter      );

  RegisterModuleType( 4001, THrastOsc            );
  RegisterModuleType( 4002, THrastSVF            );
end.

